#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define x first
#define y second

const int maxn = 1005;

vector<vector<int>> g;
vector<vector<int>> g2;
char a[maxn][maxn];
vector<int> vis;
vector<int> d;
vector<int> p;

void dfs(int v)
{
    vis[v] = 1;
    for(auto u:g[v])
    {
        if(!vis[u])
            dfs(u);
    }
    return ;
}

void bfs(int s)
{
    p[s] = -1;
    vis[s] = 1;
    d[s] = 0;
    deque<int> f;
    f.push_back(s);
    while(f.size())
    {
        int v = f[0];
        f.pop_front();
        for(auto u:g2[v])
        {
            if(!vis[u])
            {
                vis[u] = 1;
                p[u] = v;
                d[u] = d[v] + 1;
                f.push_back(u);
            }
        }
    }
    return ;
}

signed main()
{
    int h,w;
    cin >> h >> w;
    g.resize(h*w);
    g2.resize(h*w);
    vis.resize(h*w);
    d.resize(h*w);
    p.resize(h*w);
    for(int j = 0;j < h;++j)
    {
        for(int k = 0;k < w;++k)
        {
            cin >> a[j][k];
        }
    }
    for(int j = 0;j < h;++j)
    {
        for(int k = 0;k < w;++k)
        {
            if(a[j][k] == '.' && j != h-1 && a[j+1][k] == '.')
            {
                g[j*w+k].push_back((j+1)*w+k);
                g[(j+1)*w+k].push_back(j*w+k);
            }
            if(a[j][k] == '.' && k != w-1 && a[j][k+1] == '.')
            {
                g[j*w+k].push_back(j*w+k+1);
                g[j*w+k+1].push_back(j*w+k);
            }
        }
    }
    for(int i = 0;i < h;++i)
    {
        for(int j = 0;j < w;++j)
        {
            if(i == 0 || j == 0 || i == h-1 || j == w-1)
            {
                if(!vis[i*w+j] && a[i][j] == '.')
                {
                    dfs(i*w+j);
                }
            }
        }
    }
    int64_t mni = -1,mnj = -1;
    for(int i = 0;i < h;++i)
    {
        for(int j = 0;j < w;++j)
        {
            if(a[i][j] == '.' && !vis[i*w+j])
            {
                if(mni == -1)
                {
                    mni = i;
                    mnj = j;
                }
                else
                {
                    if(mnj > j)
                    {
                        mni = i;
                        mnj = j;
                    }
                    else if(mnj == j && mni > i)
                    {
                        mni = i;
                        mnj = j;
                    }
                }
            }
        }
    }
   // cout << mni << ' ' << mnj << "\n";
    for(int j = 0;j < h;++j)
    {
        for(int k =0;k < w;++k)
        {
            if(a[j][k] == '#' && j != h-1 && a[j+1][k] == '#')
            {
                if(j == mni && k < mnj)
                {
                   // cout << j << ' ' << k << "\n";
                    continue;
                }
                //cout << j << ' ' << k << "\n";
                g2[j*w+k].push_back((j+1)*w+k);
                g2[(j+1)*w+k].push_back(j*w+k);
            }
            if(a[j][k] == '#' && k != w-1 && a[j][k+1] == '#')
            {
                //cout << j << ' ' << k << "!\n";
                g2[j*w+k].push_back(j*w+k+1);
                g2[j*w+k+1].push_back(j*w+k);
            }
        }
    }
    char b[h][w];
    for(int j = 0;j < h;++j)
    {
        for(int k = 0;k < w;++k)
        {
            b[j][k] ='.';
        }
    }
    for(auto &c:vis)
        c=0;
    bfs(mni*w+mnj-1);
    int u = (mni+1)*w+mnj-1;
    while(u != -1)
    {
        b[u/w][u%w] = '#';
        u = p[u];
    }
    for(int i =0;i < h;++i)
    {
        for(int j = 0;j < w;++j)
        {
            cout << b[i][j];
        }
        cout << "\n";
    }
    return 0;


}
