#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define inf (LONG_LONG_MAX / 2)
#define all(x) x.begin(), x.end()

int mod = 1000000007;

void solve() {
    int n, m, s, t, l;
    cin >> n >> m >> s >> t >> l; s--; t--;
    vector<vector<pair<int, int>>> v(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        v[a].emplace_back(b, c);
        v[b].emplace_back(a, c);
    }

    vector<pair<int, int>> st(n, {inf, -1});
    vector<int> used(n, 0);
    st[s] = {0, 1};
    set<pair<int, int>> d;
    d.emplace(0, s);
    while (!d.empty()) {
        auto p = *d.begin();
        d.erase(d.begin());
        if (used[p.y] == 1) {
            continue;
        }
        used[p.y] = 1;
        for (auto& i : v[p.y]) {
            if (st[i.x].x > p.x + i.y) {
                st[i.x].x = p.x + i.y;
                st[i.x].y = st[p.y].y;
                d.emplace(p.x + i.y, i.x);
            }
        }
    }


    vector<pair<int, int>> fn(n, {inf, -1});
    vector<int> used2(n, 0);
    fn[t] = {0, 1};
    set<pair<int, int>> d2;
    d2.emplace(0, t);
    while (!d2.empty()) {
        auto p = *d2.begin();
        d2.erase(d2.begin());
        if (used2[p.y] == 1) {
            continue;
        }
        used2[p.y] = 1;
        for (auto& i : v[p.y]) {
            if (fn[i.x].x > p.x + i.y) {
                fn[i.x].x = p.x + i.y;
                fn[i.x].y = fn[p.y].y;
                d2.emplace(p.x + i.y, i.x);
            }
        }
    }

    if (st[t].x == l) {
        cout << st[t].y;
        return;
    }

    int ans = 0;

    for (int i = 0; i < n; i++) {
        if (st[i].x + fn[i].x == st[t].x) {
            for (auto& j : v[i]) {
                if (st[i].x + j.y + fn[j.x].x == l) {
                    ans += st[i].y * fn[j.x].y;
                    ans %= mod;
                }
            }
        }
    }

    cout << ans;
}
/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
 */
signed main() {
    ios_base::sync_with_stdio(false);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
/*
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11
 */