#include<bits/stdc++.h>

#define int long long
#define ld long double
#define sz(x) x.sixe()
#define all(x) x.begin(),x.end()
#define allr(x) x.rbegin(),x.rend()
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define pw(x) (1LL<<(x))

using namespace std;

const int INF = 1e18;

    int n, m;
    vector<string> s;
    vector<vector<int> > c;
    vector<vector<bool> > used;

void dfs(int i, int j, int color){
//    cout << i << ' ' << j << '\n';
    c[i][j] = color;
    if (i > 0 && s[i - 1][j] == s[i][j] && c[i - 1][j] == 0)
        dfs(i - 1, j, color);
    if (j > 0 && s[i][j - 1] == s[i][j] && c[i][j - 1] == 0)
        dfs(i, j - 1, color);
    if (j < m  - 1 && s[i][j + 1] == s[i][j] && c[i][j + 1] == 0)
        dfs(i, j + 1, color);
    if (i < n - 1 && s[i + 1][j] == s[i][j] && c[i + 1][j] == 0)
        dfs(i + 1, j, color);
}

bool dfs2(int i, int j){
    used[i][j] = true;
    bool can = false;
    if (i > 0 && !used[i - 1][j] && s[i - 1][j] == '.')
        can |= dfs2(i - 1, j);
    if (j > 0 && !used[i][j - 1] && s[i][j - 1] == '.')
        can |= dfs2(i, j - 1);
    if (j < m - 1 && !used[i][j + 1] && s[i][j + 1] == '.')
        can |= dfs2(i, j + 1);
    if (i < n - 1 && !used[i + 1][j] && s[i + 1][j] == '.')
        can |= dfs2(i + 1, j);
    if (i == n - 1 || j == m - 1 || i == 0 || j == 0)
        return true;
    return can;
}

main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);

    cin >> n >> m;
    s.resize(n);
    c.resize(n);
    used.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> s[i];

    for(int i = 0; i < n; i ++){
        c[i].resize(m);
        used[i].resize(m);
    }

    int next_c = 1;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if (c[i][j] == 0){
                dfs(i, j, next_c);
//                cout << "out\n";
                next_c ++;
            }
        }
    }
//    cout<<dfs2(0,3)<<'\n';

    int C = -1;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if (s[i][j] == '#' || used[i][j])
                continue;
            if (!dfs2(i, j))
                C = c[i][j];
        }
    }

//    cout << C << "\n";
//    for(int i = 0; i < n; i ++){
//        for(int j = 0;  j < m; j ++)
//            cout << c[i][j] << ' ';
//        cout << '\n';
//    }
    int up, down, left, right;
    up = left = INF;
    down = right = -INF;

    for(int i = 0; i < n; i ++){
        for(int j =0;  j < m; j ++){
            if (c[i][j] != C)
                continue;
            up = min(up, i);
            down = max(down, i);
//            cout << i << ' ' << j << '\n';
            left = min(left, j);
            right = max(right, j);
        }
    }

    up --; down ++; left --; right ++;
//    cout << up << ' ' << left << ' ' << down << ' ' << right << '\n';

    int x1, y1, x2, y2;
    queue<pair<int, int> > bfs;
    vector<vector<pair<int, int> > > p;
    p.resize(n);
    for(int i = 0; i < n; i ++){
        p[i].resize(m);
        for(int j = 0; j < m; j ++)
            p[i][j] = {-1, -1};
    }

    /// 1
    x1 = up, y1 = left, x2 = up, y2 = right;

//            cout << "here";
    bfs.push({x1, y1});
    while(!bfs.empty()){
        int x = bfs.front().first;
        int y = bfs.front().second;
//        cout << x << ' ' << y << '\n';
        bfs.pop();
        if (x == x2 && y == y2)
            break;

        if (x > 0 && s[x - 1][y] == '#' && p[x - 1][y].first == -1 && p[x - 1][y].second == -1){
            p[x - 1][y] = {x, y};
            bfs.push({x - 1, y});
        }
        if (y > 0 &&  s[x][y - 1] == '#' && p[x][y - 1].first == -1 && p[x][y - 1].second == -1){
            p[x][y - 1] = {x, y};
            bfs.push({x, y - 1});
        }
        if (x < n - 1 && x + 1< down &&  s[x + 1][y] == '#' && p[x + 1][y].first == -1 && p[x + 1][y].second == -1){
            p[x + 1][y] = {x, y};
            bfs.push({x + 1, y});
        }
        if (y < m - 1 &&  s[x][y + 1] == '#' && p[x][y + 1].first == -1 && p[x][y + 1].second == -1){
            p[x][y + 1] = {x, y};
            bfs.push({x, y + 1});
        }
    }
    while(!bfs.empty())
        bfs.pop();

    vector<vector<char> > ans(n);
    for(int i = 0; i < n; i ++){
        ans[i].resize(m);
        for(int j = 0; j < m; j ++)
            ans[i][j] = '.';
    }

    while(x2 != x1 || y2 != y1){
        ans[x2][y2] = '#';
        pair<int, int> mem = p[x2][y2];
        x2 = mem.first;
        y2 = mem.second;
    }
    ans[x1][y1] = '#';


    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            p[i][j] = {-1, -1};

    /// 2
    x1 = up, y1 = right, x2 = down, y2 = right;
    bfs.push({x1, y1});
    while(!bfs.empty()){
        int x = bfs.front().first;
        int y = bfs.front().second;
//        cout << x << ' ' << y << '\n';
        bfs.pop();
        if (x == x2 && y == y2)
            break;

        if (x > 0 &&  s[x - 1][y] == '#' && p[x - 1][y].first == -1 && p[x - 1][y].second == -1){
            p[x - 1][y] = {x, y};
            bfs.push({x - 1, y});
        }
        if (y > 0 && y - 1> left &&  s[x][y - 1] == '#' && p[x][y - 1].first == -1 && p[x][y - 1].second == -1){
            p[x][y - 1] = {x, y};
            bfs.push({x, y - 1});
        }
        if (x < n - 1 &&  s[x + 1][y] == '#' && p[x + 1][y].first == -1 && p[x + 1][y].second == -1){
            p[x + 1][y] = {x, y};
            bfs.push({x + 1, y});
        }
        if (y < m - 1 &&  s[x][y + 1] == '#' && p[x][y + 1].first == -1 && p[x][y + 1].second == -1){
            p[x][y + 1] = {x, y};
            bfs.push({x, y + 1});
        }
    }
    while(!bfs.empty())
        bfs.pop();

    while(x2 != x1 || y2 != y1){
        ans[x2][y2] = '#';
        pair<int, int> mem = p[x2][y2];
        x2 = mem.first;
        y2 = mem.second;
    }
    ans[x1][y1] = '#';


    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            p[i][j] = {-1, -1};
    /// 3
    x1 = down, y1 = right, x2 = down, y2 = left;
//    cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<'\n';
    bfs.push({x1, y1});
    while(!bfs.empty()){
        int x = bfs.front().first;
        int y = bfs.front().second;
//        cout << x << ' ' << y << '\n';
        bfs.pop();
        if (x == x2 && y == y2)
            break;

        if (x > 0 && x - 1 > up && s[x - 1][y] == '#' && p[x - 1][y].first == -1 && p[x - 1][y].second == -1){
            p[x - 1][y] = {x, y};
            bfs.push({x - 1, y});
        }
        if (y > 0 && s[x][y - 1] == '#' && p[x][y - 1].first == -1 && p[x][y - 1].second == -1){
            p[x][y - 1] = {x, y};
            bfs.push({x, y - 1});
        }
        if (x < n - 1 && s[x + 1][y] == '#' && p[x + 1][y].first == -1 && p[x + 1][y].second == -1){
            p[x + 1][y] = {x, y};
            bfs.push({x + 1, y});
        }
        if (y < m - 1 && s[x][y + 1] == '#' && p[x][y + 1].first == -1 && p[x][y + 1].second == -1){
            p[x][y + 1] = {x, y};
            bfs.push({x, y + 1});
        }
    }
    while(!bfs.empty())
        bfs.pop();

    while(x2 != x1 || y2 != y1){
//    cout<<x2<<" "<<y2<<'\n';
        ans[x2][y2] = '#';
        pair<int, int> mem = p[x2][y2];
        x2 = mem.first;
        y2 = mem.second;
    }
    ans[x1][y1] = '#';


    for(int i = 0; i < n; i ++)
        for(int j = 0; j < m; j ++)
            p[i][j] = {-1, -1};
    /// 4
    x1 = down, y1 = left, x2 = up, y2 = left;
    bfs.push({x1, y1});
    while(!bfs.empty()){
        int x = bfs.front().first;
        int y = bfs.front().second;
//        cout << x << ' ' << y << '\n';
        bfs.pop();
        if (x == x2 && y == y2)
            break;

        if (x > 0 && s[x - 1][y] == '#' && p[x - 1][y].first == -1 && p[x - 1][y].second == -1){
            p[x - 1][y] = {x, y};
            bfs.push({x - 1, y});
        }
        if (y > 0 && s[x][y - 1] == '#' && p[x][y - 1].first == -1 && p[x][y - 1].second == -1){
            p[x][y - 1] = {x, y};
            bfs.push({x, y - 1});
        }
        if (x < n - 1 && s[x + 1][y] == '#' && p[x + 1][y].first == -1 && p[x + 1][y].second == -1){
            p[x + 1][y] = {x, y};
            bfs.push({x + 1, y});
        }
        if (y < m - 1 && y + 1 < right && s[x][y + 1] == '#' && p[x][y + 1].first == -1 && p[x][y + 1].second == -1){
            p[x][y + 1] = {x, y};
            bfs.push({x, y + 1});
        }
    }
//    cout << "here";
    while(!bfs.empty())
        bfs.pop();

    while(x2 != x1 || y2 != y1){
        ans[x2][y2] = '#';
        pair<int, int> mem = p[x2][y2];
        x2 = mem.first;
        y2 = mem.second;
    }
    ans[x1][y1] = '#';


    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++)
            cout << ans[i][j];
        cout << '\n';
    }
    return 0;
}


/*
4 7
#######
#.#.#..
#...###
#####..


8 8
###..###
#.#..#.#
#.#..#.#
#.#..#.#
#.####.#
#......#
#......#
########
*/
