#include<bits/stdc++.h>

#define int long long
#define ld long double
#define sz(x) x.sixe()
#define all(x) x.begin(),x.end()
#define allr(x) x.rbegin(),x.rend()
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define pw(x) (1LL<<(x))

using namespace std;

const int INF = 1e18;

    int n, m;
    vector<string> s;
    vector<vector<int> > c;
    vector<vector<bool> > used;

void dfs(int i, int j, int color){
//    cout << i << ' ' << j << '\n';
    c[i][j] = color;
    if (i > 0 && s[i - 1][j] == s[i][j] && c[i - 1][j] == 0)
        dfs(i - 1, j, color);
    if (j > 0 && s[i][j - 1] == s[i][j] && c[i][j - 1] == 0)
        dfs(i, j - 1, color);
    if (j < m  - 1 && s[i][j + 1] == s[i][j] && c[i][j + 1] == 0)
        dfs(i, j + 1, color);
    if (i < n - 1 && s[i + 1][j] == s[i][j] && c[i + 1][j] == 0)
        dfs(i + 1, j, color);
}

bool dfs2(int i, int j){
    used[i][j] = true;
    bool can = false;
    if (i > 0 && !used[i - 1][j] && s[i - 1][j] == '.')
        can |= dfs2(i - 1, j);
    if (j > 0 && !used[i][j - 1] && s[i][j - 1] == '.')
        can |= dfs2(i, j - 1);
    if (j < m - 1 && !used[i][j + 1] && s[i][j + 1] == '.')
        can |= dfs2(i, j + 1);
    if (i < n - 1 && !used[i + 1][j] && s[i + 1][j] == '.')
        can |= dfs2(i + 1, j);
    if (i == n - 1 || j == m - 1 || i == 0 || j == 0)
        return true;
    return can;
}

main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);

    cin >> n >> m;
    s.resize(n);
    c.resize(n);
    used.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> s[i];

    for(int i = 0; i < n; i ++){
        c[i].resize(m);
        used[i].resize(m);
    }

    int next_c = 1;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if (c[i][j] == 0){
                dfs(i, j, next_c);
//                cout << "out\n";
                next_c ++;
            }
        }
    }
//    cout<<dfs2(0,3)<<'\n';

    int C = -1;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if (s[i][j] == '#' || used[i][j])
                continue;
            if (!dfs2(i, j))
                C = c[i][j];
        }
    }

//    cout << C << "\n";
//    for(int i = 0; i < n; i ++){
//        for(int j = 0;  j < m; j ++)
//            cout << c[i][j] << ' ';
//        cout << '\n';
//    }
    int up, down, left, right;
    up = left = INF;
    down = right = -INF;

    for(int i = 0; i < n; i ++){
        for(int j =0;  j < m; j ++){
            if (c[i][j] != C)
                continue;
            up = min(up, i);
            down = max(down, i);
//            cout << i << ' ' << j << '\n';
            left = min(left, j);
            right = max(right, j);
        }
    }

    up --; down ++; left --; right ++;
//    cout << up << ' ' << left << ' ' << down << ' ' << right << '\n';

    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if (s[i][j] != '#')
                continue;
            if (!((i > 0 && j > 0 && c[i - 1][j - 1] == C) || (i > 0 && j >= 0 && c[i - 1][j] == C) || (i > 0 && j < m - 1 && c[i - 1][j + 1] == C) || (i >= 0 && j < m - 1 && c[i][j + 1] == C) || (i < n - 1 && j < m - 1 && c[i + 1][j + 1] == C) || (i < n - 1 && j <= m - 1 && c[i + 1][j] == C) || (i < n - 1 && j > 0 && c[i + 1][j - 1] == C) || (i <= n - 1 && j > 0 && c[i][j - 1] == C)))
               s[i][j] = '.';
        }
    }

//    for(int i = 0; i < n; i ++)
//        cout << s[i] << '\n';
//        return 0;

    int x1, y1;
    bool found = false;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            int num = 0;
            if (i > 0 && s[i - 1][j] == '#')
                num ++;
            if (j > 0 && s[i][j - 1] == '#')
                num ++;
            if (i < n - 1 && s[i + 1][j] == '#')
                num ++;
            if (j < m - 1 && s[i][j + 1] == '#')
                num ++;

            if (num == 2){
                x1 = i, y1 = j;
                found = true;
                break;
            }
        }
        if (found)
            break;
    }

//    cout << "FROM:" << x1 << ' ' << y1 << '\n';

    vector<vector<pair<int, int>  > > p(n);
    for(int i = 0; i < n; i ++){
        p[i].resize(m);
        for(int j = 0; j < m; j ++)
        p[i][j] = {-1, -1};
    }
    p[x1][y1] = {-2, -2};
    int sx, sy;
    queue<pair<pair<int, int>, int>  > bfs;
    if (x1 > 0 && s[x1 - 1][y1] == '#')
    {
        bfs.push({{x1 - 1, y1}, 1});
        sx=x1-1;
        sy=y1;
    }
    else if (y1 > 0 && s[x1][y1 - 1] == '#')
    {
        bfs.push({{x1, y1 - 1}, 1});
        sx=x1;
        sy=y1-1;
    }
    else if (x1 < n - 1 && s[x1 + 1][y1] == '#')
    {
        bfs.push({{x1 + 1, y1}, 1});
        sx=x1+1;
        sy=y1;
    }
    else if (y1 < m - 1 && s[x1][y1 + 1] == '#')
    {
        bfs.push({{x1, y1 + 1}, 1});
        sx=x1;
        sy=y1+1;
    }
    p[sx][sy]={x1,y1};
    while(!bfs.empty()){
        int x = bfs.front().first.first;
        int y = bfs.front().first.second;
        int z = bfs.front().second;
//        cout << x << ' ' << y << '\n';
        bfs.pop();

        if (x > 0 && s[x - 1][y] == '#' && p[x - 1][y].first == -1 && !(z == 1 && x - 1 == x1)){
            p[x - 1][y] = {x, y};
            bfs.push({{x - 1, y}, z + 1});
        }
        if (y > 0 && s[x][y - 1] == '#' && p[x][y - 1].first == -1 && !(z == 1 && y - 1 == y1)){
            p[x][y - 1] = {x, y};
            bfs.push({{x, y - 1}, z + 1});
        }
        if (x < n - 1 && s[x + 1][y] == '#' && p[x + 1][y].first == -1 && !(z == 1 && x + 1 == x1)){
            p[x + 1][y] = {x, y};
            bfs.push({{x + 1, y}, z + 1});
        }
        if (y < m - 1 && s[x][y + 1] == '#' && p[x][y + 1].first == -1 && !(z == 1 && y + 1 == x1)){
            p[x][y + 1] = {x, y};
            bfs.push({{x, y + 1}, z + 1});
        }
    }

    vector<vector<char> > ans(n);
    for(int i = 0;  i < n; i ++){
        ans[i].resize(m);
        for(int j =0; j < m; j ++)
            ans[i][j] = '.';
    }

//    for(int i = 0; i < n; i ++){
//        for(int j = 0; j < m; j ++)
//            cout << p[i][j].first << ", " << p[i][j].second << "    ";
//        cout << '\n';
//    }

//    cout << x1 << ' ' << y1 << '\n';
//    return 0;
    ans[x1][y1] = '#';
    if (x1 > 0 && s[x1 - 1][y1] == '#' && (x1-1!=sx))
    {
        x1--;
    }
    else if (y1 > 0 && s[x1][y1 - 1] == '#' && y1-1!=sy)
    {
        y1--;
    }
    else if (x1 < n - 1 && s[x1 + 1][y1] == '#' && x1+1!=sx)
    {
        x1++;
    }
    else if (y1 < m - 1 && s[x1][y1 + 1] == '#' && y1+1!=sy)
    {
        y1++;
    }

//    pair<int, int> mem = p[x1][y1];
//    pair<int, int> MEM = {x1, y1};
//    x1 = mem.first, y1 = mem.second;
//    cout << x1
    while(x1 != sx || y1 != sy){
//        cout << x1 << ' ' << y1 << '\n';
if (x1 < 0 && y1 < 0)
    break;
        ans[x1][y1] = '#';
        pair<int, int> mem2 = p[x1][y1];
        x1 = mem2.first;
        y1 = mem2.second;
    }

//    cout << '\n';
//    cout << '\n';
//    cout << '\n';
//    cout << '\n';
    ans[x1][y1] = '#';
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++)
            cout << ans[i][j];
        cout << '\n';
    }




//
//    for(int i = 0; i < n; i ++){
//        for(int j = 0; j < m; j ++)
//            cout << ans[i][j];
//        cout << '\n';
//    }
    return 0;
}


/*
4 7
#######
#.#.#..
#...###
#####..


8 8
###..###
#.#..#.#
#.#..#.#
#.#..#.#
#.####.#
#......#
#......#
########

12 15
#.####..#######
#.#..#..#..#..#
###..#..#.###.#
#....####.#...#
#.##......###.#
#.##..#..##...#
########......#
.......########
########......#
#############..
#####...#######
######.########
*/
