#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define INF 1e18
#define pii pair<int, int>
#define rz resize

using namespace std;

int mod = 1e9 + 7;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, s, t, L;
    cin >> n >> m >> s >> t >> L;
    s--, t--;
    vector<vector<pii> > e(n, vector<pii>(0));
    FOR(i, m)
    {
        int u, v, c;
        cin >> u >> v >> c;
        e[u - 1].pb({v - 1, c});
        e[v - 1].pb({u - 1, c});
    }

    set<pii> q;

    vector<int> d1(n, INF), d2(n, INF), k1(n, 0), k2(n, 0);

    k1[s] = 1;
    d1[s] = 0;
    q.insert({0, s});

    while(!q.empty())
    {
        auto [dist, v] = *q.begin();

        q.erase(q.begin());

        if(d1[v] < dist)
        {
            continue;
        }

        for(auto [to, c] : e[v])
        {
            if(c + dist > d1[to])
            {
                continue;
            }

            if(c + dist == d1[to])
            {
                k1[to] = (k1[to] + k1[v]) % mod;
                continue;
            }

            k1[to] = k1[v];
            d1[to] = c + dist;
            q.insert({d1[to], to});
        }
    }

    k2[t] = 1;
    d2[t] = 0;
    q.insert({0, t});

    while(!q.empty())
    {
        auto [dist, v] = *q.begin();

        q.erase(q.begin());

        if(d2[v] < dist)
        {
            continue;
        }

        for(auto [to, c] : e[v])
        {
            if(c + dist > d2[to])
            {
                continue;
            }

            if(c + dist == d2[to])
            {
                k2[to] = (k2[to] + k2[v]) % mod;
                continue;
            }

            k2[to] = k2[v];
            d2[to] = c + dist;
            q.insert({d2[to], to});
        }
    }

    int len = d1[t];

    if(len == L)
    {
        cout << k1[t] << endl;
        return 0;
    }

    int k = 0;

    FOR(v, n)
    {
        if(d1[v] + d2[v] != len or v == t)continue;

        for(auto [to, c] : e[v])
        {
            if(d1[v] + c + d2[to] == L)
            {
                k = (k + (k1[v] * k2[to]) % mod) % mod;
            }
        }
    }

    cout << k << endl;
}

