#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1e5 + 5;

int n, B, C;
int x[N], p[N];

struct MinQueue {
    ve<pii> st1, st2;
    int getMin() {
        int mn = 2e9;
        if (sz(st1)) umn(mn, st1.back().se);
        if (sz(st2)) umn(mn, st2.back().se);
        return mn;
    }
    void push(int x) {
        int val = min(sz(st1) ? st1.back().se : int(2e9), x);
        st1.pb({x, val});
    }
    void pop() {
        assert(sz(st1) || sz(st2));
        if (sz(st2)) {
            st2.pop_back();
        } else {
            while (sz(st1)) {
                int x = st1.back().fi;
                int val = min(sz(st2) ? st2.back().se : int(2e9), x);
                st1.pop_back();
                st2.pb({x, val});
            }
            st2.pop_back();
        }
    }
};

MinQueue Q;
deque<int> alive;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> B >> C;

    int ptr = 2;
    fr (i, 1, n) {
        cin >> x[i] >> p[i];
    }

    alive.pb(1);
    Q.push(p[1]);
    int pos = x[1];

    while (1) {
//        cout << pos << " " << B << "\n";
        while (sz(alive) && x[alive[0]] < pos - C + 1) {
            alive.pop_front();
            Q.pop();
        }
        while (ptr <= n && x[ptr] <= pos) {
            alive.pb(ptr);
            Q.push(p[ptr]);
            ptr++;
        }

        if (!sz(alive)) {
            break;
        }

        int T = 2e9;
        umn(T, x[alive[0]] - (pos - C + 1) + 1);
        if (ptr <= n) umn(T, x[ptr] - pos);

//        cout << "T: " << T << "\n";

        assert(T >= 1);
        int can = min(T, B / Q.getMin());
        pos += can;
        B -= Q.getMin() * can;

        if (can < T) {
            break;
        }
    }

    cout << pos << "\n";

    return 0;
}
