#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0) {
        return a + MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

void addSelf(int& a, int b) {
    a += b;
    if (a >= MOD) {
        a -= MOD;
    }
}

void subSelf(int& a, int b) {
    a -= b;
    if (a < 0) {
        a += MOD;
    }
}

const int N = 405;

int h, w;

int dp[N][N][N];
int dp2[N][N][N];

int p1[N][N], p2[N][N], p3[N][N], p4[N][N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

//    cout << sizeof(dp) / 1e6 << "\n";

    cin >> h >> w;

    fr (i, 1, h) {
        fr (j, 1, w) {
            dp[i][j][1] = 1;
        }
    }

//    fr (c, 1, h) {
//        fr (wasI, 1, h) {
//            fr (wasJ, 1, w) {
//                fr (nxtI, wasI + 2, h) {
//                    fr (nxtJ, wasJ + 2, w) {
//                        int ways = mult(nxtI - wasI - 1, nxtJ - wasJ - 1);
//                        addSelf(dp[nxtI][nxtJ][c + 1], mult(dp[wasI][wasJ][c], ways));
//                    }
//                }
//            }
//        }
//    }

    int mx = (min(w, h) - 1) / 2 + 1;

//    cout << mx << "\n";

    fr (c, 2, mx) {
        fr (i, 0, h) {
            fr (j, 0, w) {
                p1[i][j] = 0;
                p2[i][j] = 0;
                p3[i][j] = 0;
                p4[i][j] = 0;
            }
        }

        fr (i, 1, h) {
            fr (j, 1, w) {
                int sum = 0;
                addSelf(sum, mult(i, j));
                addSelf(sum, i);
                addSelf(sum, j);
                p1[i][j] = mult(sum, dp[i][j][c - 1]);
                addSelf(p1[i][j], p1[i - 1][j]);
                addSelf(p1[i][j], p1[i][j - 1]);
                subSelf(p1[i][j], p1[i - 1][j - 1]);

                int x = sub(0, i);
                addSelf(p2[i][j], mult(dp[i][j][c - 1], x));
                addSelf(p2[i][j], p2[i - 1][j]);
                addSelf(p2[i][j], p2[i][j - 1]);
                subSelf(p2[i][j], p2[i - 1][j - 1]);


                x = sub(0, j);
                addSelf(p3[i][j], mult(dp[i][j][c - 1], x));
                addSelf(p3[i][j], p3[i - 1][j]);
                addSelf(p3[i][j], p3[i][j - 1]);
                subSelf(p3[i][j], p3[i - 1][j - 1]);

                p4[i][j] = dp[i][j][c - 1];
                addSelf(p4[i][j], p4[i - 1][j]);
                addSelf(p4[i][j], p4[i][j - 1]);
                subSelf(p4[i][j], p4[i - 1][j - 1]);
            }
        }

        fr (i, 1, h) {
            if ((i - 1) / 2 + 1 < c) continue;
            fr (j, 1, w) {
                if (i - 2 < 0 || j - 2 < 0) continue;
                if ((j - 1) / 2 + 1 < c) continue;

                int sum = 0;
                int ans = 0;
                addSelf(sum, mult(i, j));
                addSelf(sum, sub(0, i));
                addSelf(sum, sub(0, j));
                addSelf(sum, 1);

                addSelf(ans, mult(sum, p4[i - 2][j - 2]));

                addSelf(ans, p1[i - 2][j - 2]);

                addSelf(ans, mult(j, p2[i - 2][j - 2]));
                addSelf(ans, mult(i, p3[i - 2][j - 2]));
                dp[i][j][c] = ans;
            }
        }
    }


    fr (i, 1, mx) {
        dp2[h][w][i] = 1;
    }

//    cout << mx << "\n";
//
//    rf (c, mx, 2) {
//        fr (wasI, 1, h) {
//            fr (wasJ, 1, w) {
//                fr (nxtI, 1, wasI - 2) {
//                    fr (nxtJ, 1, wasJ - 2) {
//                        int ways = mult(wasI - nxtI - 1, wasJ - nxtJ - 1);
//                        dp2[nxtI][nxtJ][c - 1] = add(mult(dp2[wasI][wasJ][c], ways), dp2[nxtI][nxtJ][c - 1]);
//                    }
//                }
//            }
//        }
//    }

    rf (c, mx - 1, 1) {
        fr (i, 0, h + 1) {
            fr (j, 0, w + 1) {
                p1[i][j] = 0;
                p2[i][j] = 0;
                p3[i][j] = 0;
                p4[i][j] = 0;
            }
        }

        rf (i, h, 1) {
            if ((i - 1) / 2 + 1 < c) continue;
            rf (j, w, 1) {
                if ((j - 1) / 2 + 1 < c) continue;
                int sum = 0;
                addSelf(sum, mult(i, j));
                addSelf(sum, sub(0, i));
                addSelf(sum, sub(0, j));
                p1[i][j] = mult(sum, dp2[i][j][c + 1]);
                addSelf(p1[i][j], p1[i + 1][j]);
                addSelf(p1[i][j], p1[i][j + 1]);
                subSelf(p1[i][j], p1[i + 1][j + 1]);

                int x = sub(0, i);
                addSelf(p2[i][j], mult(dp2[i][j][c + 1], x));
                addSelf(p2[i][j], p2[i + 1][j]);
                addSelf(p2[i][j], p2[i][j + 1]);
                subSelf(p2[i][j], p2[i + 1][j + 1]);


                x = sub(0, j);
                addSelf(p3[i][j], mult(dp2[i][j][c + 1], x));
                addSelf(p3[i][j], p3[i + 1][j]);
                addSelf(p3[i][j], p3[i][j + 1]);
                subSelf(p3[i][j], p3[i + 1][j + 1]);

                p4[i][j] = dp2[i][j][c + 1];
                addSelf(p4[i][j], p4[i + 1][j]);
                addSelf(p4[i][j], p4[i][j + 1]);
                subSelf(p4[i][j], p4[i + 1][j + 1]);
            }
        }


        fr (i, 1, h) {
            fr (j, 1, w) {
                if (i + 2 > h + 1 || j + 2 > w + 1) continue;

                int sum = 0;
                int ans = 0;
                addSelf(sum, mult(i, j));
                addSelf(sum, i);
                addSelf(sum, j);
                addSelf(sum, 1);

                addSelf(ans, mult(sum, p4[i + 2][j + 2]));

                addSelf(ans, p1[i + 2][j + 2]);

                addSelf(ans, mult(j, p2[i + 2][j + 2]));
                addSelf(ans, mult(i, p3[i + 2][j + 2]));
                dp2[i][j][c] = ans;
            }
        }
    }


    int sum = 0;
    fr (i, 1, h) {

       fr (j, 1, w) {
            fr (c, 1, h) {
                int ways = mult(dp2[i][j][c], dp[i][j][c]);

                sum = add(sum, mult(ways, mult(i, j)));
            }
        }
    }

    cout << sum << "\n";

    return 0;
}
