#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast")
#pragma GCC target("sse,sse2,sse3,abm,avx,popcnt")

#define vec vector
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef vec<ll> vll;
typedef pair<ll, ll> pll;

const ll inf = 1e18;

const int MOD = 1e9 + 7;

int mult(const vector<int>& v) {
    int res = 1;
    for (int i : v) {
        res = (res * 1LL * i) % MOD;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout.precision(20);

    int h, w;
    cin >> h >> w;
    vector<vector<int>> sum(h + 1, vector<int>(w + 1, 0)), cnt(h + 1, vector<int>(w + 1, 1));


    int abacaba;
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            sum[i][j] = i * j;
            for (int a = i - 2, x; a >= 1; --a) {
                x = (i - 2) - (a - 1);
                for (int b = j - 2, y; b >= 1; --b) {
                    y = (j - 2) - (b - 1);
                    cnt[i][j] = (cnt[i][j] + 0LL + mult({ cnt[a][b], x, y })) % MOD;
                    abacaba = (sum[a][b] + 0LL + mult({cnt[a][b], i, j})) % MOD;
                    sum[i][j] = (sum[i][j] + 0LL + mult({ abacaba, x, y} )) % MOD;
                }
            }
        }
    }

//    for (int i = 1; i <= h; ++i) {
//        for (int j = 1; j <= w; ++j) {
//            cerr << sum[i][j] << ' ';
//        }
//        cerr << endl;
//    }
//
//    for (int i = 1; i <= h; ++i) {
//        for (int j = 1; j <= w; ++j) {
//            cerr << cnt[i][j] << ' ';
//        }
//        cerr << endl;
//    }

    cout << sum[h][w];

    return 0;
}
