#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


using ll = long long;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> arr(n);
    for (int i = 0; i < n; i++) cin >> arr[i];
    sort(arr.begin(), arr.end());
    ll max1 = 0, max2 = 0, min1 = 2e9, min2 = 2e9, buff;
    for (int i = 0; i < (n - 1) / 2; i++) {
        buff = arr[i];
        buff += arr[n - i - 2];
        if (buff > max1) max1 = buff;
        if (buff < min1) min1 = buff;
    }
    for (int i = 1; i < (n - 1) / 2 + 1; i++) {
        buff = arr[i];
        buff += arr[n - i - 1];
        if (buff > max2) max2 = buff;
        if (buff < min2) min2 = buff;
    }
    cout << min(abs(max1 - min1), abs(max2 - min2)) << '\n';
    return 0;
}