#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

const int N = 5e5 + 7;
const int INF = 2e9;

int n;
int a[N];
int prefmn[N], prefmx[N];
int tmn[2 * N], tmx[2 * N];
int ans = INF;

int getmn(int l, int r) {
    int ret = INF;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            ret = min(ret, tmn[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            ret = min(ret, tmn[r]);
        }
    }
    return ret;
}

int getmx(int l, int r) {
    int ret = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            ret = max(ret, tmx[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            ret = max(ret, tmx[r]);
        }
    }
    return ret;
}

void solve() {
    prefmn[0] = INF;
    prefmx[0] = 0;
    for (int i = 0; i < n / 2; ++i) {
        prefmn[i + 1] = min(prefmn[i], a[i] + a[n - i - 1]);
        prefmx[i + 1] = max(prefmx[i], a[i] + a[n - i - 1]);
    }
    ans = min(ans, prefmx[n / 2] - prefmn[n / 2]);
    for (int i = 0; i < n; ++i) {
        tmn[i + n] = a[i] + a[n - i];
        tmx[i + n] = a[i] + a[n - i];
    }
    for (int i = n - 1; i > 0; --i) {
        tmn[i] = min(tmn[2 * i], tmn[2 * i + 1]);
        tmx[i] = max(tmx[2 * i], tmx[2 * i + 1]);
    }
    for (int i = 0; i < n / 2; ++i) {
        int mn = min(prefmn[i], getmn(i + 1, i + 1 + (n - 1 - 2 * i) / 2));
        int mx = max(prefmx[i], getmx(i + 1, i + 1 + (n - 1 - 2 * i) / 2));
        ans = min(ans, mx - mn);
    }
    ans = min(ans, prefmx[n / 2] - prefmn[n / 2]);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a, a + n);
    solve();
    reverse(a, a + n);
    solve();
    cout << ans << endl;
    return 0;
}