#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = 1e18;

constexpr int mod = 1e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int s, t;
    ll l;
    cin >> s >> t >> l;
    s--, t--;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    vector<ll> dist(n, inf), cnt_t(n, 0);
    dist[t] = 0;
    cnt_t[t] = 1;
    set<pair<ll, int>> st;
    for (int i = 0; i < n; ++i) {
        st.insert({dist[i], i});
    }
    while (!st.empty()) {
        int v = st.begin()->second;
        st.erase(st.begin());
        if (dist[v] == inf) {
            break;
        }
        for (auto [u, w] : g[v]) {
            if (dist[u] > dist[v] + w) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                cnt_t[u] = cnt_t[v];
                st.insert({dist[u], u});
            } else if (dist[u] == dist[v] + w) {
                cnt_t[u] += cnt_t[v];
                if (cnt_t[u] >= mod) {
                    cnt_t[u] -= mod;
                }
            }
        }
    }
    if (l == dist[s]) {
        cout << cnt_t[s] << '\n';
        return 0;
    }
    vector<int> cnt_s(n);
    cnt_s[s] = 1;
    vector<pair<ll, int>> ord;
    for (int i = 0; i < n; ++i) {
        ord.emplace_back(dist[i], i);
    }
    sort(ord.rbegin(), ord.rend());
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[ord[i].second]) {
            if (dist[j] + w == ord[i].first) {
                cnt_s[j] += cnt_s[ord[i].second];
                if (cnt_s[j] >= mod) {
                    cnt_s[j] -= mod;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            if (dist[s] + dist[j] + w - dist[i] == l) {
                ans += cnt_s[i] * 1LL * cnt_t[j] % mod;
                if (ans >= mod) {
                    ans -= mod;
                }
            }
        }
    }
    cout << ans << '\n';
    return 0;
}
