#include <bits/stdc++.h>

using namespace std;
using ll = long long;


constexpr int MOD = 1e9 + 7;

constexpr int N = 401;

int add(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

int dp[N][N], cnt[N][N], sum[N], c[N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int y = 1; y <= m; ++y) {
        for (int x = 1; x <= n; ++x) {
            sum[x] = c[x] = 0;
            for (int w = 1; w <= y - 2; ++w) {
                sum[x] = add(sum[x], 1LL * dp[x][w] * (y - 2 - w + 1) % MOD);
                c[x] = add(c[x], 1LL * cnt[x][w] * (y - 2 - w + 1) % MOD);
            }
        }

        for (int x = 1; x <= n; ++x) {
            for (int p = 1; p <= x - 2; ++p) {
                dp[x][y] = add(dp[x][y], sum[p] * 1LL * (x - 2 - p + 1) % MOD);
                cnt[x][y] = add(cnt[x][y], c[p] * 1LL * (x - 2 - p + 1) % MOD);
            }
            cnt[x][y] = add(cnt[x][y], 1);
            dp[x][y] = add(dp[x][y], 1LL * cnt[x][y] * x * y % MOD);
        }
    }

    cout << dp[n][m];

    return 0;
}
