#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int long long
#define ld long double
const int mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, s, t, l;
    cin >> n >> m >> s >> t >> l;
    s--;
    t--;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    int ans = 0;
    vector<pair<int, int>> dist(n, {LLONG_MAX, 0});
    vector<pair<int, int>> dist1(n, {LLONG_MAX, 0});
    dist[s] = {0, 1};
    dist1[t] = {0, 1};
    set<pair<int, pair<int, int>>> vert;
    vert.insert({0, {s, 1}});
    while (!vert.empty()) {
        auto v = *vert.begin();
        vert.erase(v);
        for (auto to: g[v.second.first]) {
            if (v.first + to.second < dist[to.first].first) {
                dist[to.first] = {v.first + to.second, 1};
                vert.insert({v.first + to.second, {to.first, 1}});
            } else if (v.first + to.second == dist[to.first].first) {
                dist[to.first].second += dist[v.second.first].second;
                dist[to.first].second %= mod;
                vert.insert({dist[to.first].first, {to.first, dist[to.first].second}});
            }
        }
    }
    vert.insert({0, {t, 1}});
    while (!vert.empty()) {
        auto v = *vert.begin();
        vert.erase(v);
        for (auto to: g[v.second.first]) {
            if (v.first + to.second < dist1[to.first].first) {
                dist1[to.first] = {v.first + to.second, 1};
                vert.insert({v.first + to.second, {to.first, 1}});
            } else if (v.first + to.second == dist1[to.first].first) {
                dist1[to.first].second += dist1[v.second.first].second;
                dist1[to.first].second %= mod;
                vert.insert({dist1[to.first].first, {to.first, dist1[to.first].second}});
            }
        }
    }
    vector<pair<int, int>> z(n);
    for (int i = 0; i < n; ++i) {
        z[i].first = dist[i].first + dist1[i].first;
        z[i].second = dist[i].second * dist1[i].second % mod;
    }
    for (int i = 0; i < n; ++i) {
        if (z[i].first != dist[t].first||i==t)continue;
        for (auto to: g[i]) {
            if (dist[i].first + to.second + dist1[to.first].first == l) {
                ans += z[i].second * z[to.first].second % mod;
                ans %= mod;
            }
        }
    }
    cout << ans;
}
/*
3 10 5
0 3
1 1
4 2

 */