#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define pii pair < ll, ll >

const int INF = 1e9, N = 1e3 + 5;

int dx[] = {1, -1, 0, 0}, dy[] = {0, 0, 1, -1}, dx1[] = {-1, -1, -1, 0, 0, 1, 1, 1}, dy1[] = {-1, 0, 1, -1, 1, -1, 0, 1};

int n, m, cnt[N][N];

char a[N][N], ans[N][N];

bool good = 1, used[N][N];

void dfs(int x, int y){
    used[x][y] = 1;
    for(int i = 0; i < 4; i++){
        if(!(1 <= x + dx[i] and x + dx[i] <= n and 1 <= y + dy[i] and y + dy[i] <= m)){
            good = 0;
        }
        else{
            if(!used[x + dx[i]][y + dy[i]] and a[x + dx[i]][y + dy[i]] == '.'){
                dfs(x + dx[i], y + dy[i]);
            }
        }
    }
}

void dfs1(int x, int y){
    used[x][y] = 1;
    for(int i = 0; i < 8; i++){
        if(cnt[x + dx1[i]][y + dy1[i]] == INF) cnt[x + dx1[i]][y + dy1[i]] = 1;
        else cnt[x + dx1[i]][y + dy1[i]]++;
    }
    for(int i = 0; i < 4; i++){
        if(!used[x + dx[i]][y + dy[i]] and a[x + dx[i]][y + dy[i]] == '.'){
            dfs1(x + dx[i], y + dy[i]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            cin >> a[i][j];
            ans[i][j] = '.';
            cnt[i][j] = INF;
        }
    }
    int x, y;
    for(int i = 1; i <= n; i++){
        bool cond = 1;
        for(int j = 1; j <= m; j++){
            if(!used[i][j] and a[i][j] == '.'){
                good = 1;
                dfs(i, j);
                if(good){
                    x = i;
                    y = j;
                    cond = 0;
                    break;
                }
            }
        }
        if(!cond) break;
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            used[i][j] = 0;
        }
    }
    dfs1(x, y);
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            if(cnt[i][j] <= 3 and a[i][j] == '#') ans[i][j] = '#';
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            cout << ans[i][j];
        }
        cout << "\n";
    }
}
