#include <iostream>
#include <set>
#include <algorithm>

using namespace std;

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define sz(s) (int)s.size()
#define nl '\n'
#define pb push_back
typedef long long ll;

const int N = 5e5+500;
const ll inf = 1e14;

ll n, a[N], ans = inf, mid;
multiset <ll> mul;

void calc(){
    ll min_sum = *mul.begin();
    ll max_sum = *mul.rbegin();
    ans = min(ans, max_sum - min_sum);
}

int main(){
    speed;
    cin >> n;
    mid = (n+1)/2;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    sort(a + 1, a + n + 1);
    int l = 2, r = n;
    while(l < r){
        mul.insert(a[l] + a[r]);
        l++;
        r--;
    }
    calc();
    for(int i = 2; i <= n; i++){
        if(i <= mid){
            //cout << "erase " << i << " and " << n-i+2 << " add " << i-1 << " and " << n-i+2 << nl;
            mul.insert(a[i-1] + a[n-i+2]);
            mul.erase(a[i] + a[n-i+2]);
        }
        else{
            //cout << "erase " << i << " and " << n-i+1 << " add " << i-1 << " and " << n-i+1 << nl;
            mul.insert(a[i-1] + a[n-i+1]);
            mul.erase(a[i] + a[n-i+1]);
        }
        calc();
    }
    cout << ans << nl;
    return 0;
}
/*
9
1 5 7 12 20 32 35 40 42
*/
