#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n, b, c;
vector<long long> x;
vector<long long> p;
vector<pair<long long, int>> seg;
int s = 1;

void build(int l, int r, int u){
    if(l == r){
        if(l < x.size()) seg[u] = {p[l], l};
        else seg[u] = {1e18, -1};
        return;
    }
    int m = (l + r) / 2;
    build(l, m, 2 * u + 1), build(m + 1, r, 2 * u + 2);
}

pair<long long, int> get(int l, int r, int lx, int rx, int u){
    if(lx >= l && rx <= r) return seg[u];
    if(lx > r || rx < l) return {1e18, -1};
    int m = (lx + rx )/ 2;
    return min(get(l, r, lx, m, 2 * u + 1), get(l, r, m + 1, rx, 2 *u  + 2));
}


void solve(){
    cin >> n >> b >> c;
    x = p = vector<long long>(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    while(s < n) s <<= 1;
    seg = vector<pair<long long, int>> (2 * s);
    build(0, s - 1, 0);
    int i = 0;
    long long benzin = 0;
    for (; i < n - 1;) {
        long long mxx = upper_bound(x.begin(), x.end(), x[i] + min(c * 1ll, 1ll * p[i] * b + benzin)) - x.begin() - 1;
        if (mxx <= i) break;
        int l = i, r = mxx;
        bool f = 0;
        while(l + 1 < r){
            int m = (l + r) / 2;
            pair<long long, int> pp = get(l, m, 0, s - 1, 0);
            if(pp.first <= p[i]) r = m, f = 1;
            else l = m;
        }
        int j = r;
        if(!f){
            pair<long long, int> pp = get(i + 1, mxx, 0,s - 1, 0);
            j = pp.second;
        }
        // amenadzax
        if (benzin >= x[j] - x[i]) {
            benzin -= x[j] - x[i];
            i = j;
            continue;
        }
        long long cost = (x[j] - x[i] - benzin) * p[i];
        if (p[j] > p[i] || cost > b) {
            b -= (c - benzin) * p[i];
            benzin = c - (x[j] - x[i]);
            i = j;
        } else {
            b -= cost;
            benzin = 0;
            i = j;
        }
        // cout << b << " " << i << endl;
    }
    long long ans = x[i] + min(c - benzin,b / p[i]) + benzin;
    cout << ans << endl;
}

int main() {
    // cout << ceil(5.2) <<endl;
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    // int t; cin >> t; while (t--)
        solve();
}
