﻿#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <algorithm>
using namespace std;
const int N = 401;
const long long P = 1e9 + 7;
long long dp[N][N], cnt[N][N];
int main()
{
    long long n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        dp[i][1] = i;
        cnt[i][1] = 1;
    }
    for (int i = 1; i <= m; i++)
    {
        dp[1][i] = i;
        cnt[1][i] = 1;
    }
    for (long long i = 2; i <= n; i++)
    for (long long j = 2; j <= m; j++)
    {
        cnt[i][j] = 1;
        for (long long k = 1; k < i - 1; k++)
        for (long long v = 1; v < j - 1; v++)
        {
            cnt[i][j] += cnt[v][k] * (i - v - 1) * (j - k - 1);
            cnt[i][j] %= P;
        }
    }
    for (long long i = 2; i <= n; i++)
    for (long long j = 2; j <= m; j++)
    {
        dp[i][j] = i * j;
        for (long long k = 1; k < i - 1; k++)
        for (long long v = 1; v < j - 1; v++)
        {
            dp[i][j] = dp[i][j] + ((i - k - 1) * (j - v - 1) * (cnt[v][k] * v * k + dp[v][k]));
            dp[i][j] %= P;
            dp[i][j] = dp[i][j] + ((i - k - 1)* (j - v - 1)* cnt[v][k] * ((i* j) - (v * k)));
            dp[i][j] %= P;
        }
    }
    cout << dp[n][m] << "\n";
}