#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
 
using namespace std;
 
#define ll long long
#define wv vector< vector< vector<ll> > >
 
const int N = 404;
const ll inf = 1e9 + 7;

ll c[N][N];
wv pc(4, vector< vector<ll> >(N, vector<ll>(N, 0ll)));
ll dp[N][N];
wv pd(4, vector< vector<ll> >(N, vector<ll>(N, 0ll)));

ll clc(wv p, ll h, ll w)
{
   ll ans = (p[0][h - 2][w - 2] * (1 - h) * (1 - w) + inf * inf) % inf + 
            (p[1][h - 2][w - 2] * (1 - w) + inf * inf) % inf +
            (p[2][h - 2][w - 2] * (1 - h) + inf * inf) % inf +
            p[3][h - 2][w - 2];
   return (ans + inf * inf) % inf; 
}

void solve() {
   ll h, w;
   cin >> h >> w;

   for (ll i = 1; i <= h; i++)
   {
      for (ll j = 1; j <= w; j++)
      {
         if (min(i, j) < 3)
         {
            c[i][j] = 1;
            dp[i][j] = i * j;
         }
         else
         {
            c[i][j] = (1 + clc(pc, i, j)) % inf;
            dp[i][j] = (i * j * c[i][j] + clc(pd, i, j)) % inf;
         }
         pc[0][i][j] = (c[i][j] + pc[0][i - 1][j] + pc[0][i][j - 1] - pc[0][i - 1][j - 1] + inf * inf) % inf;
         pc[1][i][j] = (c[i][j] * i + pc[1][i - 1][j] + pc[1][i][j - 1] - pc[1][i - 1][j - 1] + inf * inf) % inf;
         pc[2][i][j] = (c[i][j] * j + pc[2][i - 1][j] + pc[2][i][j - 1] - pc[2][i - 1][j - 1] + inf * inf) % inf;
         pc[3][i][j] = (c[i][j] * i * j + pc[3][i - 1][j] + pc[3][i][j - 1] - pc[3][i - 1][j - 1] + inf * inf) % inf;
         
         pd[0][i][j] = (dp[i][j] + pd[0][i - 1][j] + pd[0][i][j - 1] - pd[0][i - 1][j - 1] + inf * inf) % inf;
         pd[1][i][j] = (dp[i][j] * i + pd[1][i - 1][j] + pd[1][i][j - 1] - pd[1][i - 1][j - 1] + inf * inf) % inf;
         pd[2][i][j] = (dp[i][j] * j + pd[2][i - 1][j] + pd[2][i][j - 1] - pd[2][i - 1][j - 1] + inf * inf) % inf;
         pd[3][i][j] = (dp[i][j] * i * j + pd[3][i - 1][j] + pd[3][i][j - 1] - pd[3][i - 1][j - 1] + inf * inf) % inf;
      }
   }
   cout << dp[h][w] % inf;
} 
  
int main() {
   ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
   cout.precision(9);
   cout << fixed; 
 
   int tt = 1;
   //cin >> tt;
   while (tt--)
      solve();
 
   return 0;
} 