#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define add push_back
#define all(v) v.begin(),v.end()
#define mpr make_pair
#define sz(v) (ll)v.size()
#define vi vector<int>
#define pii pair<int,int>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

const ll MOD = 1e9+7;
const ll INF = 1e18;
const ll N = 200005;

//#define endl '\n'
vector<pll> g[N];
ll qanS[N], qanT[N];
ll herS[N], herT[N];

int main()
{

    fastio;

    ll n,m;
    cin>>n>>m;
    ll start,end,L;
    cin>>start>>end>>L;
    
    FOR(i,1,m+1)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        g[a].add(mpr(b,w));
        g[b].add(mpr(a,w));
    }

    //Dijkstra from start

    set<pll> s;
    qanS[start] = 1;
    FOR(i,1,n+1)
    {
        herS[i] = INF;
    }
    herS[start] = 0;
    s.insert(mpr(0,start));

    while(!s.empty())
    {
        ll now = s.begin()->sc;
        s.erase(s.begin());
        if(now != start)
        {
            for(auto f : g[now])
            {
                if(qanS[f.ft] != 0 and herS[f.ft]+f.sc == herS[now])
                {
                    qanS[now]+=qanS[f.ft];
                    qanS[now] %= MOD;
                }
            }
        }
        for(auto f : g[now])
        {
            if(herS[now]+f.sc < herS[f.ft])
            {
                s.erase(mpr(herS[f.ft], f.ft));
                s.insert(mpr(herS[now]+f.sc, f.ft));
                herS[f.ft] = herS[now]+f.sc;
            }
        }
    }

    //Dijkstra from end

    s.clear();
    qanT[end] = 1;
    FOR(i,1,n+1)
    {
        herT[i] = INF;
    }
    herT[end] = 0;
    s.insert(mpr(0,end));

    while(!s.empty())
    {
        ll now = s.begin()->sc;
        s.erase(s.begin());
        if(now != end)
        {
            for(auto f : g[now])
            {
                if(qanT[f.ft] != 0 and herT[f.ft]+f.sc == herT[now])
                {
                    qanT[now]+=qanT[f.ft];
                    qanT[now] %= MOD;
                }
            }
        }
        for(auto f : g[now])
        {
            if(herT[now]+f.sc < herT[f.ft])
            {
                s.erase(mpr(herT[f.ft], f.ft));
                s.insert(mpr(herT[now]+f.sc, f.ft));
                herT[f.ft] = herT[now]+f.sc;
            }
        }
    }

    if(L == herT[start])
    {
        cout<<qanS[end]<<endl;
        return 0;
    }
    ll ans = 0;
    FOR(i,1,n+1)
    {
        if(herS[i]+herT[i] != herT[start])
        {
            continue; 
        }
        for(auto f : g[i])
        {
            if(herT[f.ft] == L-herS[i]-f.sc)
            {
                ans = (ans + (qanS[i]*qanT[f.ft])%MOD)%MOD;
            }
        }
    }

    // FOR(i,1,n+1)
    // {
    //     cout<<herS[i]<<" "<<herT[i]<<endl;
    // }
    cout<<ans<<endl;

    return 0;
}