#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) long(x.size())
#define rs resize
#define ff first
#define ss second
#define X first
#define Y second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MX = 1e6 + 2;
const int INF32 = 2e9 + 5;
const int INF64 = 2e18 + 7;

int n, b, c;


struct Tree {
    int n;
    vector<pii> t;

    Tree(int n_) {
        n = n_;
        t.rs(4 * n);
    }


    void build(int v, int tl, int tr, vector<int> &a) {
        if (tl == tr) {
            t[v] = {a[tl], tl};
            return;
        }
        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm, a);
        build(2 * v + 2, tm + 1, tr, a);
        t[v] = t[2 * v + 2];
        if (t[2 * v + 1].ff < t[2 * v + 2].ff) t[v] = t[2 * v + 1];
    }


    pii get(int v, int tl, int tr, int l, int r) {
        if (l > tr || tl > r) return {INF64, -1};
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2;
        pii res1 = get(2 * v + 1, tl, tm, l, r);
        pii res2 = get(2 * v + 2, tm + 1, tr, l, r);
        if (res1.ff < res2.ff) return res1;
        return res2;
    }
};

void solve() {
    cin >> n >> b >> c;
    Tree tree = Tree(n);
    vector<int> x(n), p(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    int ans = 0;
    tree.build(0, 0, n - 1, p);
    vector<pii> st;
    st.pb({p[0], 0});
    vector<int> nr(n, -1);
    for (int i = 1; i < n; i++) {
        while (sz(st) && st.back().ff > p[i]) {
            nr[st.back().ss] = i;
            st.pop_back();
        }
        st.pb({p[i], i});
    }
    int f = 0, mon = b;
    int i = 0;
    for (;i < n;) {
        //cout << i << " " << f << " " << mon << "\n";
        int dist = min(c, f + mon / p[i]);
        ans = max(ans, x[i] + dist);
        if (nr[i] != -1 && x[nr[i]] - x[i] <= dist) {
            int d = x[nr[i]] - x[i];
            mon -= max(0ll, d - f) * p[i];
            f = 0;
            i = nr[i];
        }
        else {
            int l = i + 1;
            int r = upper_bound(all(x), x[i] + dist) - x.begin();
            r--;
            if (r < l) {
                ans = max(ans, x[i] + dist);
                break;
            }
            auto g = tree.get(0, 0, n - 1, l, r);
            int ind = g.ss;
            int nf = min(c, f + mon / p[i]);
            mon -= (nf - f) * p[i];
            f = nf - x[ind] + x[i];
            ans = max(ans, x[i] + f);
            i = ind;
        }
    }
    cout << ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
    return 0;
}
