#ifdef LOCAL
#define _GLIB_CXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

void solve() {
    ll n, t, m, x, y;
    cin >> n >> t >> m >> x >> y;

    ll k = (m * y + n * x - m * x) / (x * y);
    if((m * y + n * x - m * x) % (x * y) > 0)
        k++;
    k = k / 60 + (k % 60 > 0 ? 1 : 0);
    cout << max(0ll, k - t);
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    auto start = clock();
    cerr.precision(3);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

#ifdef LOCAL
    auto end_t = clock();
    cerr << "Execution time: " << (end_t - start) * 1000 / CLOCKS_PER_SEC << " ms\n";
#endif
}