#include <bits/stdc++.h>

#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define int int64_t
#define ins insert
#define pii pair<int, int>
#define PB push_back
#define F first
#define S second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;

const ll INF=1e18+2;
const ll N=2e5+12;
const ll mod=1e9+7;

ve<pll> gr[N];
tuple<ll,ll,ll> ed[N];
ll dist[2][N];
char used[N];
ll n;

void calc_dist(ll k, ll st)
{
    priority_queue<pll> pq;
    fill(dist[k],dist[k]+n,INF);
    fill(used,used+n,0);
    pq.push({0,st});
    dist[k][st]=0;

    while(!pq.empty())
    {
        ll x=pq.top().S;
        pq.pop();

        if(used[x]) continue;
        used[x]=1;

        for(pll i:gr[x])
        {
            if(dist[k][i.F]>dist[k][x]+i.S)
            {
                dist[k][i.F]=dist[k][x]+i.S;
                pq.push({-dist[k][i.F],i.F});
            }
        }
    }
}

ll s,t,l,ans=0;

void rec(ll x, ll pr)
{
    for(pll i:gr[x])
    {
        if(dist[0][x]+i.S+dist[1][i.F]==l&&dist[0][x]+dist[1][x]==dist[0][t])
            ans++;

        if(i.F!=pr&&dist[0][i.F]+dist[1][i.F]==dist[0][t])
            rec(i.F,x);
    }
}

void solve()
{
    ll m;
    cin>>n>>m>>s>>t>>l;
    s--, t--;

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        a--, b--;
        gr[a].PB({b,w});
        gr[b].PB({a,w});
        ed[i]={a,b,w};
    }

    calc_dist(0,s);
    calc_dist(1,t);
    rec(s,s);
    cout<<ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
