#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector <int64_t> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
	}
	mas.push_back(-1);
	mas.push_back(2E9 + 1);
	sort(ALL(mas));
	vector <pair<int64_t, int64_t>> otr;
	for (int i = 1; i < mas.size(); i++)
	{
		otr.push_back({ mas[i - 1] + 1,mas[i] - 1 });
	}

	vector <int64_t> pref(otr.size() + 1);
	for (int i = 0; i < otr.size(); i++)
	{
		pref[i + 1] = pref[i] + otr[i].second - otr[i].first + 1;
	}

	for (int i = 0; i < q; i++)
	{
		int64_t x;
		cin >> x;
		auto t = lower_bound(ALL(pref), x) - pref.begin();
		cout << otr[t - 1].second - (pref[t] - x) << ' ';
	}
}