#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<deque>
#include<bitset>
#include<random>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const int N = 1e6 + 9;
const ll INF = 1e18 + 9;

pair<int, int> res1[N] ,res2[N];
int a[N];
int n;

void recalc(pair<int, int>* pref, int i, int j, pair<int, int> p) {
	pref[i] = { min(a[i] + a[j], p.first), max(a[i] + a[j], p.second) };
}

pair<int, int> f(pair<int, int> a, pair<int, int> b) {
	return { min(a.first, b.first), max(a.second, b.second) };
}

pair<int, int> st1[30][N], st2[30][N];
int p[N];

void precalc() {
	p[1] = 0;
	for (int i = 2; i < N; i++)
		p[i] = p[i / 2] + 1;
	for (int k = 1; k < 30; k++) {
		for (int i = 0; i + (1 << k) <= n / 2 + 1; i++) {
			st1[k][i] = f(st1[k - 1][i], st1[k - 1][i + (1 << (k - 1))]);
			st2[k][i] = f(st2[k - 1][i], st2[k - 1][i + (1 << (k - 1))]);
		}
	}
}

pair<int, int> get1(int l, int r) {
	int k = p[r - l];
	return f(st1[k][l], st1[k][r - (1 << k)]);
}
pair<int, int> get2(int l, int r) {
	int k = p[r - l];
	return f(st2[k][l], st2[k][r - (1 << k)]);
}

int calc() {
	for (int i = 0; i <= n / 2; i++) {
		st1[0][i] = { a[n - i - 1] + a[i], a[n - i - 1] + a[i] };
		st2[0][i] = { a[n - i] + a[i], a[n - i] + a[i] };
	}
	int ans = INF;
	precalc();
	for (int i = 0; i <= n / 2; i++) {
		pair<int, int> res = { INF, -INF };
		if (i != 0) {
			res = f(res, get1(0, i));
		}
		if (i != n / 2)
			res = f(res, get2(i + 1, n / 2 + 1));
		ans = min(ans, res.second - res.first);
	}
	return ans;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	
	
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	sort(a, a + n);
	int res1 = calc();
	reverse(a, a + n);
	int res2 = calc();
	cout << min(res1, res2);
	
}