#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<deque>
#include<bitset>
#include<random>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const int N = 1e6 + 9;
const ll INF = 1e18 + 9;

struct Query {
	int k, ind, answ;
};

int n;
vector<int> sorted;
vector<Query> q;
bool cmp(Query a, Query b) {
	return a.k < b.k;
}
bool cmp2(Query a, Query b) {
	return a.ind < b.ind;
}

int CntBefore(int i) {
	int ind = upper_bound(sorted.begin(), sorted.end(), i) - sorted.begin();
	if (ind == sorted.size()) {
		return i + 1 - sorted.size();
	}
	if (ind == 0) {
		return i + 1;
	}
	int cnt_less = ind;
	return i + 1 - cnt_less;

}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> n;
	int Q;
	cin >> Q;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		sorted.push_back(x);
	}
	sort(sorted.begin(), sorted.end());
	sorted.resize(unique(sorted.begin(), sorted.end()) - sorted.begin());

	q.resize(Q);
	for (int i = 0; i < Q; i++) {
		int k;
		cin >> k;
		int L = -1, R = 2e9 + 7;
		while (R - L > 1) {
			int mid = (L + R) / 2;
			if (CntBefore(mid) >= k) {
				R = mid;
			}
			else {
				L = mid;
			}
		}
		cout << R << " ";
	}
	
}