#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
	int n, q;
	cin >> n >> q;

	vector<int> inp(n);
	for (auto& i : inp) {
		cin >> i;
	}

	inp.insert(inp.begin(), -1);
	inp.push_back(2e9);
	sort(inp.begin(), inp.end());
	inp = vector<int>(inp.begin(), unique(inp.begin(), inp.end()));
	int cur = 0;
	vector<pair<int, int>> prefs;
	for (int i = 1; i < inp.size(); i++) {
		prefs.push_back({ cur, inp[i - 1] + 1 }); 
		cur += inp[i] - inp[i - 1] - 1;
	}

	for (int i = 0; i < q; i++) {
		int x;
		cin >> x;
		x--;

		auto it = prev(lower_bound(prefs.begin(), prefs.end(), pair<int, int>{ x, 1e9}));
		cout << (x - (*it).first) + (*it).second << ' ';
	}

	cout << endl;
}

/*
4 11
1 2 6 7
1 2 3 4 5 6 7 8 9 10 11
*/