#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;
#define all(a) a.begin(), a.end()
#define int long long
#define st string
#define pb push_back
#define vec vector
#define pi pair<int, int>
#define ff first
#define ss second
#define vpi vector<pair<int, int>>
template <typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (size_t i = 0; i < v.size(); ++i) cin >> v[i];
    return in;
}

using vi = vector<int>;

struct Node {
    int val = 0;
    int add = 0;
    int id = 0;
};

vec<Node> t;

void push(int v, int tl, int tr) {
    if (tr - tl == 1 || t[v].add == 0) {
        return;
    }
    t[2 * v + 1].add += t[v].add;
    t[2 * v + 2].add += t[v].add;
    t[2 * v + 1].val += t[v].add;
    t[2 * v + 2].val += t[v].add;
    t[v].add = 0;
}

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        t[v].id = tl;
        return;
    }
    int m = (tl + tr) / 2;
    build(2 * v + 1, tl, m);
    build(2 * v + 2, m, tr);
}

void upd(int v, int tl, int tr, int l, int r, int val) {
    push(v, tl, tr);
    if (tl >= r || tr <= l) {
        return;
    }
    if (tl >= l && tr <= r) {
        t[v].add += val;
        t[v].val += val;
        return;
    }
    int m = (tl + tr) / 2;
    upd(2 * v + 1, tl, m, l, r, val);
    upd(2 * v + 2, m, tr, l, r, val);
    pi p = { t[2 * v + 2].val, t[2 * v + 2].id };
    if (t[2 * v + 1].val > t[2 * v + 2].val) {
        p = { t[2 * v + 1].val, t[2 * v + 1].id };
    }
    t[v].val = p.ff;
    t[v].id = p.ss;
}

pi get(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (tl >= r || tr <= l) {
        return { 0, -1 };
    }
    if (tl >= l && tr <= r) {
        return { t[v].val, t[v].id };
    }
    int m = (tl + tr) / 2;
    pi ans1 = get(2 * v + 1, tl, m, l, r);
    pi ans2 = get(2 * v + 2, m, tr, l, r);
    if (ans1.ff > ans2.ff) {
        return ans1;
    }
    return ans2;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, b, c; cin >> n >> b >> c;
    vpi a(n);
    for (int i = 0; i < n; i++) {
        int x, p; cin >> x >> p;
        a[i] = { x, p };
    }
    a.pb({ 1e18, 1e18 });
    n++;
    int k = 1;
    while (k < n) {
        k *= 2;
    }
    t.resize(2 * k - 1);
    build(0, 0, n);
    set<pi> s; // .ff - цена, .ss - индекс
    int ans = 0;
    s.insert({ a[0].ss, 0 });
    for (int i = 1; i < n; i++) {
        int d = a[i].ff - a[i - 1].ff;
        int ok = 0;
        //        cout << i + 1 << endl;
        //        cout << get(0, 0, n, 1, 2).ff << endl;
        while (s.size()) {
            auto it = *s.begin();
            int ind = it.ss;
            int val = it.ff;
            pi mx = get(0, 0, n, ind, n);
            int can = min(c - mx.ff, d);
            //                cout << val << " " << can << " " << ind << endl;
            //                cout << can << " " << val << endl;
            if (can * val >= b) {
                ans += min(can, b / val);
                ok = 1;
                break;
            }
            ans += can;
            d -= can;
            b -= val * can;
            if (can == c - mx.ff) {
                s.erase(s.begin());
            }
            //                cout << ind << " " << can << endl;
            upd(0, 0, n, ind, i, can);
            if (!d) {
                break;
            }
        }
        s.insert({ a[i].ss, i });
        if (ok) {
            break;
        }
        //        cout << ans << " " << b << endl;
    }
    cout << ans << endl;
}
