#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);
    cout << fixed << setprecision(15);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    rep(i, 0, n) {
        cin >> a[i];
    }
    sort(all(a));
    vector<pii> mex;
    int pre = 0;
    rep(i, 0, n) {
        if (a[i] > pre) {
            mex.emplace_back(pre, a[i]);
        }
        pre = a[i] + 1;
    }

    vi len(sz(mex));
    if (!mex.empty()) {
        len[0] = mex[0].second - mex[0].first;
        rep(i, 1, sz(mex)) {
            len[i] = len[i - 1] + mex[i].second - mex[i].first;
        }
    }

    while (q--) {
        int k;
        cin >> k, k--;

        int p = int(upper_bound(all(len), k) - len.begin());
        if (p) k -= len[p - 1];
        cout << (p < sz(mex)? mex[p].first + k: a.back() + 1 + k) << ' ';
    }
}
