#include <bits/stdc++.h>

using namespace std;
#define int long long

const int inf = 1e18 + 100;


int mod = 1e9 + 7;
vector <int> tree;


void nw(int v, int i, int x, int lx, int rx) {
    if (lx + 1 == rx) {
        tree[x] = v;
        return;
    }
    int m = (lx + rx) / 2;
    if (m > i) {
        nw(v, i, 2 * x + 1, lx, m);
    }
    else {
        nw(v, i, 2 * x + 2, m, rx);
    }
    tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
}

int maxx(int l, int r, int x, int lx, int rx) {
    if (rx <= l) {
        return inf;
    }
    if (lx >= r) {
        return inf;
    }
    if (lx >= l and rx <= r) {
        return tree[x];
    }
    int m = (lx + rx) / 2;
    int s1 = maxx(l, r, 2 * x + 1, lx, m);
    int s2 = maxx(l, r, 2 * x + 2, m, rx);
    return min(s1, s2);
}








signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, b, c;
    cin >> n >> b >> c;
    vector <vector <int>> s(n, vector <int> (2));
    for (int i = 0; i < n; i++) {
        cin >> s[i][0] >> s[i][1];
    }
    s.push_back({(long long)2e18, (long long)0});
    n++;
    int sz = 1;
    while (sz < n) {
        sz *= 2;
    }
    for (int i = 0; i < 2 * sz - 1; i++) {
        tree.push_back(inf);
    }
    for (int i = 0; i < n; i++) {
        nw(s[i][1], i, 0, 0, sz);
    }
    int kl = 0;
    int obs = 0;
    int ns = b;
    int id = 0;
    while (ns != 0) {
        int h = 1;
        int l = id - 1;
        int r = n - 1;
        while (l + 1 != r) {
            int m = (l + r) / 2;
            int mn = maxx(id, m + 1, 0, 0, sz);
            if (mn >= s[id][1]) {
                l = m;
            }
            else {
                r = m;
            }
        }
        vector <int> nw = {s[r][1], r};
        int pl = nw[0];
        int i = nw[1];
        if (s[i][0] - s[id][0] <= c) {
            if (kl >= s[i][0] - s[id][0]) {
                kl -= (s[i][0] - s[id][0]);
                while (id != i) {
                    id++;
                }
                h = 0;
            }

            else {
                int nd = s[i][0] - s[id][0] - kl;
                if (nd * s[id][1] > ns) {
                    int ppl = ns / s[id][1];
                    obs += ppl;
                    kl += ppl;
                    ns -= ppl * s[id][1];
                }
                else {
                    int ppl = nd;
                    obs += ppl;
                    kl += ppl;
                    ns -= ppl * s[id][1];
                    int pr = s[id][0];
                    while (id != i) {
                        id++;
                    }
                    kl -= (s[i][0] - pr);
                    h = 0;
                }
            }








        }
        else {
            int d = min(c - kl, ns / s[id][1]);
            kl += d;
            ns -= d * s[id][1];
            obs += d;
        }
        if (h) {
            if (kl < s[id + 1][0] - s[id][0]) {
                ns = 0;
            }
            else {
                kl -= (s[id + 1][0] - s[id][0]);
                id++;
            }
        }
    }
    cout << obs << "\n";
}
