//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pb push_back
#define mp make_pair
#define ff first
#define ss second

void solve () {
    ll n, m;
    cin >> n >> m;
    ll s1, s2, e1, e2;
    cin >> s1 >> e1 >> s2 >> e2;
    --s1;--s2;--e1;--e2;
    ll sum = 0;
    vector<vector<ll>> sp(n, vector<ll> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> sp[i][j];
            sum += sp[i][j];
        }
    }
    vector<pair<ll, ll>> cycle;
    if (n % 2 == 0) {
        pair<ll, ll> now = {0, 0};
        cycle.pb(now);
        now.ss++;
        for (int i = 0; i < n; i += 2) {
            for (int j = 1; j < m; j++) {
                cycle.pb(mp(i, j));
            }
            for (int j = m - 1; j >= 1; j--) {
                cycle.pb(mp(i + 1, j));
            }
        }
        cycle.pb({n - 1, 0});
        for (int i = n - 2; i >= 1; i--) {
            cycle.pb(mp(i, 0));
        }
    } else if (m % 2 == 0) {
        swap(n, m);
        pair<ll, ll> now = {0, 0};
        cycle.pb(now);
        now.ss++;
        for (int i = 0; i < n; i += 2) {
            for (int j = 1; j < m; j++) {
                cycle.pb(mp(i, j));
            }
            for (int j = m - 1; j >= 1; j--) {
                cycle.pb(mp(i + 1, j));
            }
        }
        cycle.pb({n - 1, 0});
        for (int i = n - 2; i >= 1; i--) {
            cycle.pb(mp(i, 0));
        }
        swap(n, m);
        for (int i = 0; i < cycle.size(); i++) {
            swap(cycle[i].ff, cycle[i].ss);
        }
    } else {
        vector<pair<ll, ll>> cycle1, cycle2, cycle3;
        for (int i = 1; i < m; ++i) {
            cycle1.pb(mp(0, i));
        }
        for (int j = m - 1; j > 1; j--) {
            if (j % 2 == 0)
                for (int i = 1; i < n; ++i)
                    cycle1.pb(mp(i, j));
            else
                for (int i = n - 1; i >= 1; --i)
                    cycle1.pb(mp(i, j));
        }
        for (int i = n - 1; i >= 1; --i) {
            if (i % 2 == 0) {
                cycle1.pb(mp(i, 1));
                cycle1.pb(mp(i, 0));
            } else {
                cycle1.pb(mp(i, 0));
                cycle1.pb(mp(i, 1));
            }
        }
        // cycl1 without 0 0
        for (auto [x, y]: cycle1) {
            cycle2.push_back({x, m - 1 - y});
        }

        for (auto [x, y]: cycle1) {
            cycle3.push_back({n - 1 - x, y});
        }
        if (count(cycle1.begin(), cycle1.end(), mp(s1, e1)) && count(cycle1.begin(), cycle1.end(), mp(s2, e2)))
            cycle = cycle1;
        else if (count(cycle2.begin(), cycle2.end(), mp(s1, e1)) && count(cycle2.begin(), cycle2.end(), mp(s2, e2)))
            cycle = cycle2;
        else
            cycle = cycle3;
    }
//    for (auto i : cycle) {
//        cout << i.ff << " " << i.ss << endl;
//    }
    int x = find(cycle.begin(), cycle.end(), mp(s1, e1)) - cycle.begin();
    int y = find(cycle.begin(), cycle.end(), mp(s2, e2)) - cycle.begin();
    if(x > y)
        swap(x, y);
    int cursum = 0;
    for(int i = x;i<=y;++i){
        cursum += sp[cycle[i].ff][cycle[i].ss];
    }
    if(cursum * 2 > sum){
    }
    else{
        swap(x, y);
    }
    vector<pair<ll, ll>> way;
    for(int i = x; i != y; i = (i + 1) % (int)cycle.size()){
        way.pb(cycle[i]);
    }
    way.pb(cycle[y]);
    if (way[0] != mp(s1, e1)) {
        reverse(way.begin(), way.end());
    }
    string ans = "";
    for (int i = 1; i < way.size(); i++) {
        if (way[i] == mp(way[i - 1].ff, way[i - 1].ss + 1)) {
            ans += "R";
        }
        if (way[i] == mp(way[i - 1].ff, way[i - 1].ss - 1)) {
            ans += "L";
        }
        if (way[i] == mp(way[i - 1].ff + 1, way[i - 1].ss)) {
            ans += "D";
        }
        if (way[i] == mp(way[i - 1].ff - 1, way[i - 1].ss)) {
            ans += "U";
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
