#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s){
    return '"' + s + '"';
}

string to_string(const char *s){
    return to_string((string)s);
}

string to_string(bool a){
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p){
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v){
    bool f = 1;
    string res = "{";
    for(auto x : v){
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out(){
    cerr << endl;
}
template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T){
    cerr << " " << to_string(H);
    debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();
signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

void run(){
    ll n, B, C;
    cin >> n >> B >> C;
    vector<ll> x(n);
    vector<ll> p(n);
    for (int i = 0; i < n; ++i){
        cin >> x[i] >> p[i];
    }
    deque<pair<ll, ll>> q;
    q.push_back({min(C, B / p[0]), p[0]});
    B -= q.back().first * q.back().second;
    C -= q.back().first;
    for (int i = 1; i < n; ++i){
        ll l = x[i] - x[i - 1];
        while (l > 0){
            if (q.empty()){
                cout << p[i] - l << endl;
                return;
            }
            if (q.front().first > l){
                q.front().first -= l;
                C += l;
                l = 0;
            } else{
                l -= q.front().first;
                C += q.front().first;
                q.pop_front();
            }
        }
        while (!q.empty() && q.back().second >= p[i]){
            B += q.back().first * q.back().second;
            C += q.back().first;
            q.pop_back();
        }
        q.push_back({min(C, B / p[i]), p[i]});
        B -= q.back().first * q.back().second;
        C -= q.back().first;
    }
    ll l = 0;
    while (true){
        if (q.empty()){
            cout << x[n - 1] + l << endl;
            return;
        }
        l += q.front().first;
        q.pop_front();
    }
}
