//#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <set>
//typedef long long ll;
//typedef long double ld;
//#define all(a) a.begin(), a.end()
//#define ve vector
//#define ft first
//#define sd second
//using namespace std;
//ll MOD = 1e9 + 7;
//ll INF = 1e18;
//
//ll n, m;
//vector<string> g;
//int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
//
//    cin >> n >> m;
//    g.resize(n);
//    for (ll i = 0; i < n; ++i) cin >> g[i];
//
//    for (ll i )
//
//    return 0;
//}

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define ve vector
#define ft first
#define sd second
using namespace std;
ll MOD = 1e9 + 7;
ll INF = 1e18;

ve<ve<pair<int, int> > > g;
ve<ll> w[2];


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    w[1].resize(n, INF);
    w[0].resize(n, INF);
    ll s, t, L;
    cin >> s >> t >> L;
    --s; --t;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        g[a].push_back({ b, c });
        g[b].push_back({ a, c });
    }
    ve<int> look[2];
    set <pair <int, int> > q;
    q.insert({ 0, s });
    w[0][s] = 0;
    ve<bool> used(n, 0);
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(q.begin());
        if (used[v.sd]) {
            continue;
        }
        look[0].push_back(v.sd);
        used[v.sd] = true;
        for (auto u : g[v.sd]) {
            if (w[0][u.ft] > w[0][v.sd] + u.sd) {
                q.insert({ w[0][v.sd] + u.sd, u.ft });
                w[0][u.ft] = w[0][v.sd] + u.sd;
            }
        }
    }
    used.assign(n, 0);
    q.insert({ 0, t });
    w[1][t] = 0;
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(q.begin());
        if (used[v.sd]) {
            continue;
        }
        look[1].push_back(v.sd);
        used[v.sd] = true;
        for (auto u : g[v.sd]) {
            if (w[1][u.ft] > w[1][v.sd] + u.sd) {
                q.insert({ w[1][v.sd] + u.sd, u.ft });
                w[1][u.ft] = w[1][v.sd] + u.sd;
            }
        }
    }
    ve <ll> cnt[2];
    for (int j = 0; j <= 1; ++j) {
        cnt[j].resize(n, 0);
        cnt[j][look[j][0]] = 1;
        for (auto i : look[j]) {
            for (auto u : g[i]) {
                if (w[j][u.ft] == w[j][i] - u.sd) {
                    cnt[j][i] += cnt[j][u.ft];
                    cnt[j][i] %= MOD;
                }
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (i == t) continue;
        for (auto u : g[i]) {
            if (w[0][i] + w[1][u.ft] + u.sd == L && w[0][i] + w[1][i] == w[1][s]) {
                ans += cnt[0][i] * cnt[1][u.ft];
                ans %= MOD;
            }
        }
    }
    cout << ans;
    return 0;
}
