#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define ve vector
#define ft first
#define sd second
using namespace std;
ll MOD = 1e9 + 7;
ll INF = 1e18;

ll n, m, ax, ay, bx, by;
vector<vector<ll>> a;
vector<vector<vector<pair<ll, ll>>>> g;

void add(ll x1, ll y1, ll x2, ll y2) {
    g[x1][y1].push_back({x2, y2});
    g[x2][y2].push_back({x1, y1});
}

void add_reverse_x(ll x1, ll y1, ll x2, ll y2) {
    add(x1, m - 1 - y1, x2, m - 1 - y2);
}

void add_reverse_y(ll x1, ll y1, ll x2, ll y2) {
    add(n - 1 - x1, y1, n - 1 - x2, y2);
}

char get_char(ll x1, ll y1, ll x2, ll y2) {
    if (x1 + 1 == x2) return 'D';
    if (x1 - 1 == x2) return 'U';
    if (y1 + 1 == y2) return 'R';
    if (y1 - 1 == y2) return 'L';
}

string get() {
    ll ans1 = 0;
    string s1 = "";
    ll ans2 = 0;
    string s2 = "";

    if (true) {
        ll prev_x = ax, prev_y = ay;
        ll now_x = g[ax][ay][0].first, now_y = g[ax][ay][0].second;

        while (now_x != bx || now_y != by) {
            ans1 += a[now_x][now_y];

            s1 += get_char(prev_x, prev_y, now_x, now_y);

            if (g[now_x][now_y][0] == make_pair(prev_x, prev_y)) {
                auto k = g[now_x][now_y][1];

                prev_x = now_x;
                prev_y = now_y;

                now_x = k.first;
                now_y = k.second;
            }
            else {
                auto k = g[now_x][now_y][0];

                prev_x = now_x;
                prev_y = now_y;

                now_x = k.first;
                now_y = k.second;
            }
        }

        s1 += get_char(prev_x, prev_y, bx, by);
    }
    if (true) {
        ll prev_x = ax, prev_y = ay;
        ll now_x = g[ax][ay][1].first, now_y = g[ax][ay][1].second;

        while (now_x != bx || now_y != by) {
            ans2 += a[now_x][now_y];

            s2 += get_char(prev_x, prev_y, now_x, now_y);

            if (g[now_x][now_y][0] == make_pair(prev_x, prev_y)) {
                auto k = g[now_x][now_y][1];

                prev_x = now_x;
                prev_y = now_y;

                now_x = k.first;
                now_y = k.second;
            }
            else {
                auto k = g[now_x][now_y][0];

                prev_x = now_x;
                prev_y = now_y;

                now_x = k.first;
                now_y = k.second;
            }
        }

        s2 += get_char(prev_x, prev_y, bx, by);
    }

    if (ans1 > ans2) return s1;
    return s2;
}

void solve() {
    a.clear();
    g.clear();

    cin >> n >> m >> ax >> ay >> bx >> by;

    --ax;
    --ay;
    --bx;
    --by;

    a.resize(n, vector<ll> (m));

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    if (n % 2 == 0) {
        g.resize(n, vector<vector<pair<ll, ll>>> (m));

        for (ll i = 0; i < n; ++i) {
            for (ll j = 1; j < m - 1; ++j) {
                add(i, j, i, j + 1);
            }
        }

        add(0, 0, 0, 1);
        add(n - 1, 0, n - 1, 1);

        for (ll i = 0; i < n - 1; ++i) {
            add(i, 0, i + 1, 0);

            if (i % 2 == 0) {
                add(i, m - 1, i + 1, m - 1);
            }
            else {
                add(i, 1, i + 1, 1);
            }
        }

        cout << get() << endl;
        return;
    }
    if (m % 2 == 0) {
        g.resize(n, vector<vector<pair<ll, ll>>> (m));

        for (ll i = 1; i < n - 1; ++i) {
            for (ll j = 0; j < m; ++j) {
                add(i, j, i + 1, j);
            }
        }

        add(0, 0, 1, 0);
        add(0, m - 1, 1, m - 1);

        for (ll j = 0; j < m - 1; ++j) {
            add(0, j, 0, j + 1);

            if (j % 2 == 0) {
                add(n - 1, j, n - 1, j + 1);
            }
            else {
                add(1, j, 1, j + 1);
            }
        }

        cout << get() << endl;
        return;
    }

    g.resize(n, vector<vector<pair<ll, ll>>> (m));

    if ((ax != 0 || ay != 0) && (by != 0 || bx != 0)) {
        for (ll j = 1; j < m; ++j) {
            add(0, j, 1, j);
        }
        for (ll j = 1; j < m - 1; j += 2) {
            add(0, j, 0, j + 1);
            add(1, j - 1, 1, j);
        }

        for (ll i = 2; i < n; ++i) {
            for (ll j = 1; j < m - 1; ++j) {
                add(i, j, i, j + 1);
            }
        }

        add(n - 1, 0, n - 1, 1);

        for (ll i = 1; i < n - 1; ++i) {
            add(i, 0, i + 1, 0);

            if (i % 2 == 1) {
                add(i, m - 1, i + 1, m - 1);
            }
            else {
                add(i, 1, i + 1, 1);
            }
        }

        cout << get() << endl;
        return;
    }
    if ((ax != n - 1 || ay != 0) && (by != n - 1 || bx != 0)) {
        for (ll j = 1; j < m; ++j) {
            add_reverse_y(0, j, 1, j);
        }
        for (ll j = 1; j < m - 1; j += 2) {
            add_reverse_y(0, j, 0, j + 1);
            add_reverse_y(1, j - 1, 1, j);
        }

        for (ll i = 2; i < n; ++i) {
            for (ll j = 1; j < m - 1; ++j) {
                add_reverse_y(i, j, i, j + 1);
            }
        }

        add_reverse_y(n - 1, 0, n - 1, 1);

        for (ll i = 1; i < n - 1; ++i) {
            add_reverse_y(i, 0, i + 1, 0);

            if (i % 2 == 1) {
                add_reverse_y(i, m - 1, i + 1, m - 1);
            }
            else {
                add_reverse_y(i, 1, i + 1, 1);
            }
        }

        cout << get() << endl;
        return;
    }
    if ((ax != 0 || ay != m - 1) && (bx != 0 || by != m - 1)) {
        for (ll j = 1; j < m; ++j) {
            add_reverse_x(0, j, 1, j);
        }
        for (ll j = 1; j < m - 1; j += 2) {
            add_reverse_x(0, j, 0, j + 1);
            add_reverse_x(1, j - 1, 1, j);
        }

        for (ll i = 2; i < n; ++i) {
            for (ll j = 1; j < m - 1; ++j) {
                add_reverse_x(i, j, i, j + 1);
            }
        }

        add_reverse_x(n - 1, 0, n - 1, 1);

        for (ll i = 1; i < n - 1; ++i) {
            add_reverse_x(i, 0, i + 1, 0);

            if (i % 2 == 1) {
                add_reverse_x(i, m - 1, i + 1, m - 1);
            }
            else {
                add_reverse_x(i, 1, i + 1, 1);
            }
        }

        cout << get() << endl;
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll tests;
    cin >> tests;

    while (tests--) {
        solve();
    }
}

/*
1
3 3
2 1
3 3
4 3 8
4 1 2
9 3 5
 */
