#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma,sse2,sse3,ssse3,sse4,sse4.1,lzcnt,popcnt,bmi,bmi2")

#include <iostream>
#include <vector>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(x) x.begin(),x.end()
#define ff first
#define ss second

typedef long long int ll;
typedef vector<int> vi;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


void solve() {
    int n;
    cin >> n;

    vi a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    sort(all(a));

    multiset<int> d;
    for (int i = 0; i < n / 2; i++) {
        d.insert(a[i] + a[n-i-2]);
    }

    int ans = *prev(d.end()) - *(d.begin());

    for (int i = n-2; i >= n/2; i--) {
        int pr = a[i] + a[n-i-2];
        int cur = a[i] + a[n-i-1];

        d.erase(d.find(pr));
        d.insert(cur);

        ans = min(ans, *prev(d.end()) - *(d.begin()));
    }

    d = multiset<int>();
    reverse(all(a));

    for (int i = 0; i < n / 2; i++) {
        d.insert(a[i] + a[n-i-2]);
    }

    for (int i = n-2; i >= n/2; i--) {
        int pr = a[i] + a[n-i-2];
        int cur = a[i] + a[n-i-1];

        d.erase(d.find(pr));
        d.insert(cur);

        ans = min(ans, *prev(d.end()) - *(d.begin()));
    }

    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}