#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define int ll
//#define endl '\n'
//
typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
//template<typename T> tree<T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const double eps = 1e-9;
const int inf = 2e9, INF = 1e18;

void solve() {
    int n, q;
    cin >> n >> q;
    ordered_set s;
    s.insert(INF);
    for (int i = 0, p; i < n && cin >> p; i++)
        s.insert(p);
    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;
        int lo = -1, hi = INF;
        while (lo + 1 < hi) {
            int u = (lo + hi) >> 1;
            int h = s.order_of_key(u + 1);
            if (u + 1 - h < k)
                lo = u;
            else
                hi = u;
        }
        cout << hi << ' ';
    }
}

signed main() {
#ifdef BIBIKOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
