//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define int ll
//#define endl '\n'
//
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
//template<typename T> tree<T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const double eps = 1e-9;
const int inf = 2e9, INF = 1e18;

void solve() {
    int n;
    cin >> n;
    map<set<pair<int, int>>, pair<int, int>> m;
    vector<vector<int>> pol;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        pol.push_back({a, b, c});
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            vector<int> a = pol[i], b = pol[j];
            for (int h = 0; h < 3; h++) {
                for (int w = 0; w < 3; w++) {
                    set<pair<int, int>> s = {{a[(h + 1) % 3], a[(h + 2) % 3]},
                                             {b[(w + 1) % 3], b[(w + 2) % 3]}};
                    if (a[h] == b[w] && m.count(s)) {
                        auto [x, y] = m[s];
                        cout << "Yes" << '\n';
                        cout << i + 1 << ' ' << j + 1 << ' ' << x + 1 << ' ' << y + 1 << '\n';
                        return;
                    }
                }
            }
        }
        for (int j = 0; j < i; j++) {
            vector<int> a = pol[i], b = pol[j];
            for (int h = 0; h < 3; h++)
                for (int w = 0; w < 3; w++) if (a[h] == b[w]) {
                        set<pair<int, int>> s1 = {{a[(h + 1) % 3], b[(w + 2) % 3]},
                                                 {b[(w + 1) % 3], a[(h + 2) % 3]}};
                        set<pair<int, int>> s2 = {{a[(h + 2) % 3], b[(w + 1) % 3]},
                                                  {b[(w + 2) % 3], a[(h + 1) % 3]}};
                        m[s1] = {i, j};
                        m[s2] = {i, j};
                    }
        }
    }
    cout << "No";
}

signed main() {
#ifdef BIBIKOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
