#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef long double ld;

const ll INF = 1e18;
const ll LIMIT = 1e9 * 2;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, b, c;
    cin >> n >> b >> c;
    vector<pair<int, int>> a(n);
    for (auto &[x, p]: a) {
        cin >> x >> p;
    }
    vector<int> min_right(n, n);
    vector<int> id_min;
    for (int i = n - 1; i >= 0; --i) {
        while (!id_min.empty() && a[id_min.back()].second > a[i].second) {
            id_min.pop_back();
        }
        if (!id_min.empty()) {
            min_right[i] = id_min.back();
        }
        id_min.push_back(i);
    }
    /*for (auto i: min_right) {
        cout << i << ' ';
    }
    cout << '\n';*/
    ll v = 0;
    ll x = 0;
    for (int i = 0; i < n; ++i) {
        if (i != 0) {
            v -= (a[i].first - a[i - 1].first);
        }
        if (v < 0 || b == 0) {
            break;
        }
        if (min_right[i] != n && a[min_right[i]].first - a[i].first <= c &&
            b / a[i].second + v >= a[min_right[i]].first - a[i].first) {
            ll d = max(0ll, a[min_right[i]].first - a[i].first - v);
            v += d;
            b -= d * a[i].second;
        } else {
            ll cnt = min(c - v, (ll) b / a[i].second);
            v += cnt;
            b -= cnt * a[i].second;
            x = a[i].first + v;
        }
    }
    cout << x;
}
