#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<pll> vpll;
typedef long double ld;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const ll LIMIT = 1e9 * 2;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll h, w;
    cin >> h >> w;
    vvll dp(h + 1, vll(w + 1, 0));
    vvll dp2(h + 1, vll(w + 1, 0));
    if (h < 3 || w < 3){
        cout << h * w << "\n";
        return 0;
    }
    dp[0][0] = 1;
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            dp[i][j] = (i * j) % mod;
            dp2[i][j] = 1;
            for (int k = 1; k <= i - 2; ++k) {
                for (int l = 1; l <= j - 2; ++l) {
                    dp2[i][j] += (dp2[k][l] * (i - k - 1)) % mod * (j - l - 1);
                    dp2[i][j] %= mod;
                    dp[i][j] += ((((i * j) % mod * dp2[k][l]) % mod + dp[k][l]) % mod) * ((i - k - 1) * (j - l - 1)) % mod;
                    dp[i][j] %= mod;
                    //cout << i << ' ' << j << " " << k << " " << l << " " <<  (i * j + dp[k][l]) * (i - k - 1) * (j - l - 1) << "\n";
                }
            }
        }
    }
    /*
    for (int i = 0; i <= h; ++i) {
        for (int j = 0; j <= w; ++j) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    }*/
    cout << dp[h][w];
}