from sys import setrecursionlimit
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def main():
    n, q = map(int, input().split())
    a = (list(map(int, input().split())))
    a_s = set(a)
    ks = map(int, input().split())

    ans = []
    def left(a, k):
        if len(a) == 1:
            if a[0] >= k:
                return 0
            return 1
        if a[len(a) // 2] < k:
            return len(a) // 2 + left(a[len(a) // 2:], k)
        return left(a[:len(a) // 2], k)

    for k in ks:
        before = left(a, k) + k - 1
        while before in a_s or before in ans:
            before += 1
        ans.append(before)

    """4 10
    1 2 6 7
    1 2 3 4 5 6 7 8 10 11"""

    print(*ans)

thread = threading.Thread(target=main)
thread.start()