from sys import setrecursionlimit
from bisect import bisect_left
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def main():
    n, q = map(int, input().split())
    a = (list(map(int, input().split())))
    a_s = set(a)
    ks = map(int, input().split())

    ans = []
    t = set()

    for k in ks:
        before = bisect_left(a, k) + k - 1
        while before in a_s or before in ans:
            before += 1
        ans.append(before)

    print(*ans)

thread = threading.Thread(target=main)
thread.start()

"""
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11
"""
