from sys import setrecursionlimit
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    cache = dict()
    m = (10 ** 9 + 7)


    def f(w, h): # ret (res, k)
        if w <= 2 or h <= 2:
            return w * h, 1
        if (w, h) in cache:
            return cache[(w, h)]
        size = w * h
        result = size
        gl_count = 1
        for w1 in range(1, w - 1):
            for h1 in range(1, h - 1):
                summary, count = f(max(w1, h1), min(w1, h1))
                sub_count = (w - w1 - 1) * (h - h1 - 1)
                addition = (size * count + summary) * sub_count % m
                gl_count += count * sub_count
                result = (addition + result) % m
        cache[(w, h)] = result, gl_count
        return result, gl_count


    w, h = sorted(map(int, input().split()))
    print(f(h, w)[0])


thread = threading.Thread(target=main)
thread.start()
