#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define sz(v) v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<vector<int>> og;

vector<int> used;
vector<bool> can;
int s, t;
void dfs(int v) {
    used[v] = true;

    if (v == t) {
        can[v] = true;
        return;
    }

    for (auto u : og[v]) {
        if (!used[u]) {
            dfs(u);
        }
        can[v] = can[v] | can[u];
    }
}

const int mod = 1e9 + 7;
void add(ll& a, ll b) {
    a += b;
    a %= mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    ll l;
    cin >> s >> t >> l;
    s--; t--;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> pq;
    vector<pair<ll, ll>> d(n, {1e18, 0});
    og.resize(n);
    d[t] = {0, 1};
    pq.push({0, t});
    while (!pq.empty()) {
        auto [dist, v] = pq.top();
        pq.pop();
        if (d[v].first < dist) continue;

        for (auto [u, w] : g[v]) {
            ll nv = d[v].first + w;
            if (nv < d[u].first) {
                og[u] = {v};
                d[u].first = nv;
                d[u].second = d[v].second;
                pq.push({nv, u});
            } else if (nv == d[u].first) {
                og[u].push_back(v);
                add(d[u].second, d[v].second);
            }
        }
    }

    used.assign(n, false);
    can.assign(n, false);
    dfs(s);

    vector<pair<ll, ll>> d2(n, {1e18, 0});
    d2[s] = {0, 1};
    pq.push({0, s});
    while (!pq.empty()) {
        auto [dist, v] = pq.top();
        pq.pop();
        if (d2[v].first < dist) continue;

        for (auto [u, w] : g[v]) {
            ll nv = d2[v].first + w;
            if (nv < d2[u].first) {
                d2[u].first = nv;
                d2[u].second = d2[v].second;
                pq.push({nv, u});
            } else if (nv == d2[u].first) {
                add(d2[u].second, d2[v].second);
            }
        }
    }

    if (l == d2[t].first) {
        cout << d2[t].second;
        return 0;
    }

    ll ans = 0;
    for (int v = 0; v < n; v++) {
        if (can[v]) {
            for (auto [u, w] : g[v]) {
                ll cur = d2[v].first + w + d[u].first;
                ll cnt = (d2[v].second * d[u].second) % mod;
                if (cur == l) {
                    add(ans, cnt);
                }
            }
        }
    }
    cout << ans << '\n';

    return 0;
}
