#include <bits/stdc++.h>
#define int long long
using namespace std;
vector <vector <pair <int, int>>> ans(2 * 1e6);
map <pair<int, int>, char> check;
vector <vector <char>> a;
int n, m;
int pos = 0;
bool flag = 0;
void dfs(int i, int j){
    if(flag) return;
    if(i == 0 || i == n || j == m || j == 0){
        flag = 1;
        return;
    }
    check[{i, j}] = 1;
    ans[pos].emplace_back(i, j);
    if(!check[{i - 1, j}] && a[i - 1][j] == '.'){
        dfs(i - 1, j);
    }
    if(!check[{i, j - 1}] && a[i][j - 1] == '.'){
        dfs(i, j - 1);
    }
    if(!check[{i + 1, j}] && a[i + 1][j] == '.'){
        dfs(i + 1, j);
    }
    if(!check[{i, j + 1}] && a[i][j + 1] == '.'){
        dfs(i, j + 1);
    }
}
signed main() {
    cin >> n >> m;
    a.assign(n, vector <char>(m));
    vector <pair <int, int>> water;
    for(int i = 0; i < n; i++){
        string tmp;
        cin >> tmp;
        for(int j = 0; j < m; j++){
            a[i][j] = tmp[j];
            if(tmp[j] == '.'){
                water.push_back({i, j});
            }
        }
    }
    for(int i = 0; i < water.size(); i++){
        if(!check[water[i]]){
            dfs(water[i].first, water[i].second);
            if(!flag){
                break;
            }
            flag = 0;
            pos++;
        }
    }
    int mnx = INT_MAX;
    int mxx = INT_MIN;
    int mny = INT_MAX;
    int mxy = INT_MIN;
    vector <vector <char>> res(n, vector <char>(m, '.'));
    for(auto &x : ans[pos]){
        mnx = min(mnx, x.first);
        mxx = max(mxx, x.first);
        mny = min(mny, x.second);
        mxy = max(mxy, x.second);
    }
    for(int i = mnx - 1; i <= mxx + 1; i++){
        res[i][mny - 1] = '#';
    }
    for(int i = mnx - 1; i <= mxx + 1; i++){
        res[i][mxy + 1] = '#';
    }
    for(int i = mny - 1; i <= mxy + 1; i++){
        res[mnx - 1][i] = '#';
    }
    for(int i = mny - 1; i <= mxy + 1; i++){
        res[mxx + 1][i] = '#';
    }
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cout << res[i][j];
        }
        cout << '\n';
    }
    return 0;
}
