#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define pb push_back
using namespace std;

void solve(){
	int n, q, t;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<pair<int, int>> r;
	if (a[0] > 0) {
		r.pb({ 0, a[0] });
	}
	for (int i = 1; i < n; i++) {
		if (a[i] - a[i - 1] > 1) {
			r.pb({a[i - 1] + 1, a[i] - a[i - 1] - 1 });
		}
	}
	vector<int> p{ 0 };
	for (auto i : r) {
		p.pb(i.second + p[p.size() - 1]);
	}
	sort(all(a));
	for (int i = 0; i < q; i++) {
		cin >> t;
		int e = upper_bound(all(p), t-1) - p.begin() -1;
		if (e == r.size()) {
			cout << t - p[p.size() - 1] + a[n - 1] << '\n';
		}
		else {
			cout << r[e].first + t - p[e] -1<< '\n';
		}
	}
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	solve();
}
