#include<bits/stdc++.h>
using namespace std;
#define fast() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long
#define M7 1'000'000'007LL
#define INF M7*M7
//#define N A.size()
//#include<ext/pd_ds/assoc_container.hpp>
//#include<ext/pd_ds/tree_policy.hpp>
//using __gnu_pbds;
//typedef tree<int, null_type, less<int>
void solve();
int32_t main() {
    fast();
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1; //cin >> t;
    while(t--) solve();
#ifdef LOCAL
    cout << '\n' << 1.0 * clock() / 1000.0 << " s.\n";
#endif
}
 // 2 - ok, 0 - wasn't, 1 - bad
void dfs(int now, vector<vector<pair<int, int>>> &g, vector<int> &dist, vector<int> &color){

    for(auto &[to, cost] : g[now]){
        if(dist[to] != dist[now] + cost) continue;
        if(color[to] == 2) color[now] = 2;
        else if(color[to] == 0){
            dfs(to, g, dist, color);
            if(color[to] == 2) color[now] = 2;
        }
        else continue;
    }
    if(color[now] != 2) color[now] = 1;
}
pair<vector<int>, vector<int>> DJ(int s, int n, vector<vector<pair<int, int>>> &g){
    vector<int> dist_s(n, INF);
    vector<int> cnt(n, 0);
    dist_s[s] = 0;
    cnt[s] = 1;
    priority_queue<pair<int, int>> q;
    q.push({0, s});
    while(!q.empty()){
        int now = q.top().second, d = -q.top().first;
        q.pop();
        if(dist_s[now] < d) continue;
        for(auto &[to, cost] : g[now]){
            if(dist_s[to] > d + cost){
                dist_s[to] = d + cost;
                cnt[to] = cnt[now];
                q.push({-dist_s[to], to});
            }
            else if(dist_s[to] == d + cost){
                cnt[to] += cnt[now];
                cnt[to] %= M7;
            }
        }
    }
    return {dist_s, cnt};
}

void solve(){

    int n, m; cin >> n >> m;
    int s, t, L; cin >> s >> t >> L;
    s--; t--;
    vector<vector<pair<int, int>>> g(n, vector<pair<int, int>>());
    for(int i = 0; i < m; i++){
        int from, to, cost; cin >> from >> to >> cost;
        g[--from].push_back({--to, cost});
        g[to].push_back({from, cost});
    }


    vector<int> color(n, 0);
    pair<vector<int>, vector<int>> r = DJ(s, n, g);
    vector<int> cnt_s= r.second, dist_s = r.first;
    color[t] = 2;
    dfs(s, g, dist_s, color);

    pair<vector<int>, vector<int>> e = DJ(t, n, g);
    vector<int> dist_t = e.first, cnt_t = e.second;
    int ans = 0;
    for (int v = 0; v < n; v++) {
        if (color[v] == 2) {
            for (auto [u, w]: g[v]) {
                int dist = dist_s[v] + w + dist_t[u];
                if (dist == L) {
                    ans += (cnt_s[v] * cnt_t[u]) % M7;
                    ans %= M7;
                }
            }
        }
    }
    cout << ans;



}
