﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <cstdio>
#include <set>
#include <map>
#include <bitset>
#include <unordered_map>
#include <random>
#include <ctime>
#include <stack>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

int n, m;
char x[2010][2010];
int us[2010][2010];

set <pair <int, int>> s;

int dfs(int i, int j) {
    while (i >= n || j >= m || i < 0 || j < 0);
    us[i][j] = 1;
    s.insert({ i, j });
    vector <pair <int, int> > r = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };
    int f = 0;
    for (auto& u : r) {
        if (i + u.first >= 0 && i + u.first < n && j + u.second >= 0 && j + u.second < m) {
            if (x[i + u.first][j + u.second] == '.' && !us[i + u.first][j + u.second])
                f |= dfs(i + u.first, j + u.second);
        }
        else {
            f = 1;
        }
    }
    return f;
}

void dfs2(int i, int j) {
    while (i >= n || j >= m || i < 0 || j < 0);
    us[i][j] = 1;
    vector <pair <int, int> > r = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };
    int kl = 0, kl2 = 0;
    for (auto& u : r) {
        if (i + u.first >= 0 && i + u.first < n && j + u.second >= 0 && j + u.second < m) {
            if (x[i + u.first][j + u.second] == '#' && !us[i + u.first][j + u.second])
                dfs2(i + u.first, j + u.second);
            if (s.find({ i + u.first, j + u.second }) != s.end())
                kl++;
        }
    }
    r = { { -1, 1 }, { 1, 1 }, { 1, -1 }, { -1, -1 } };
    for (auto& u : r) {
        if (i + u.first >= 0 && i + u.first < n && j + u.second >= 0 && j + u.second < m) {
            if (s.find({ i + u.first, j + u.second }) != s.end())
                kl2++;
        }
    }
    if (kl2 == 1 && kl == 0)
        return;
    if (kl > 2) {
        x[i][j] = '.';
        s.insert({ i, j });
    }
    if (kl == 0)
        x[i][j] = '.';
}

int main() {
#ifdef _DEBUG 
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            cin >> x[i][j];
        }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (!us[i][j] && x[i][j] == '.') {
                if (!dfs(i, j)) {
                    for (int ii = 0; ii < n; ii++)
                        for (int jj = 0; jj < m; jj++)
                            if (!us[ii][jj] && x[ii][jj] == '#') {
                                dfs2(ii, jj);
                            }
                    for (int ii = 0; ii < n; ii++) {
                        for (int jj = 0; jj < m; jj++)
                            cout << x[ii][jj];
                        cout << endl;
                    }
                    return 0;
                }
                s.clear();
            }
}