#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define x first
#define y second

#define all(x) (x).begin(), (x).end()

const int mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;

    vector<pair<pair<int, int>, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].x.x >> arr[i].x.y;
        arr[i].y = i;
    }

    vector<int> x;
    for (auto e : arr) {
        x.push_back(e.x.x);
        x.push_back(e.x.y);
    }
    sort(all(x));
    x.resize(unique(all(x)) - x.begin());
    sort(all(x));
    map<int, int> mp;
    for (int i = 0; i < x.size(); ++i)
        mp[x[i]] = i;

    for (auto & e : arr) {
        e.x.x = mp[e.x.x];
        e.x.y = mp[e.x.y];
    }

    sort(all(arr), [&](auto a, auto b) {
         if (a.x.y != b.x.y)
            return a.x.y < b.x.y;
         return a.x.x > b.x.x;
         });

    vector<int> cnt(n);

    vector<int> ans(2 * n + 10);

    vector<int> v;

    for (int i = 0; i < n; ++i) {
        int res = (ans[arr[i].x.x] + 1) % mod;
        cnt[arr[i].y] = res;

        for (int j = 0; j <= arr[i].x.x; ++j) {
            ans[j] = (ans[j] + res) % mod;
        }

        while (v.size() > 0 && arr[v.back()].x.x >= arr[i].x.x) {
            int u = v.back();
            v.pop_back();

            for (int j = 0; j <= arr[i].x.x; ++j)
                ans[j] = ((ans[j] - cnt[arr[u].y]) % mod + mod) % mod;
        }

        v.push_back(i);

    }

    for (int i : cnt)
        cout << i << " ";
    cout << endl;
}

signed main()
{

    solve();

    return 0;
}
