#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define VI vector<int>
#define PAR pair<int,int>
#define VP vector<PAR>
#define x first
#define y second

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < v.size(); ++i) {
        in >> v[i];
    }
    return in;
}

signed main() {
    cout.precision(16);
    /*
    int n, b, c;
    cin >> n >> b >> c;
    VI vx(n), vp(n);
    //cin >> vx >> vp;
    for (int i = 0; i < n; ++i) {
        cin >> vx[i] >> vp[i];
    }
    VI vnext(n);
    vector<pair<int, int>> stack;
    for (int i = 0; i < n; ++i) {
        int p = vp[i];
        while (!stack.empty() && stack.back().first > p) {
            vnext[stack.back().second] = i;
            stack.pop_back();
        }
        stack.emplace_back(p, i);
    }

    while (!stack.empty()) {
        vnext[stack.back().second] = n;
        stack.pop_back();
    }

    int curr = 0;
    for (int i = 0; i < n; ++i) {
        if (curr < vx[i]) break;
        int next = vnext[i];
        int avail = b / vp[i];
        if (next != n && vx[next] - curr <= min(c, avail)) {
            b -= max(vx[next] - curr, 0ll) * vp[i];
            curr += max(vx[next] - curr, 0ll);
        } else {
            b -= min(c, avail) * vp[i];
            curr += min(c, avail);
        }
        assert(b >= 0);
    }
    cout << curr << endl;

    */
    int n,q;
    cin>>n>>q;
    VI a(n);
    map<int,int> m;
    for(auto& i: a){
        cin>>i;
        m[i]=1;
    }
    VP qes(q);
    for(int i=0;i<q;++i){
        cin>>qes[i].x;
        qes[i].y=i;
    }

    VI ans(q,0);
    sort(qes.begin(),qes.end());
    int tec=0,pred=0;
    for(auto i:qes){
        i.x--;
        int dif=i.x-pred;
        int ind= upper_bound(a.begin(),a.end(),tec+dif)-upper_bound(a.begin(),a.end(),tec);
        tec+=dif+ind;
        while(m[tec]){
            tec++;
        }
        ans[i.y]=tec;
        pred=i.x;
    }
    for(auto i:ans){
        cout<<i<<' ';
    }
    cout<<endl;
    return 0;
}
