#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define F first
#define S second
#define PB push_back

ll n, m, s, t, l;
vector<vector<pair<ll, ll>>> g;
vector <ll> col, dist, cnt;
const ll mod = 1e9 + 7;

void dfs(ll now) {
    col[now]++;
    for (auto to : g[now]) {
        if (dist[now] == to.S + dist[to.F]) {
            dfs(to.F);
        }
    }
}

void solve() {
    cin >> n >> m;
    cin >> s >> t >> l;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        g[a].PB({b, w});
        g[b].PB({a, w});
    }
    dist.resize(n, LLONG_MAX);
    cnt.resize(n, 0);
    s--; t--;
    dist[t] = 0;
    cnt[t] = 1;
    set <pair<ll, ll>> st;
    st.insert({0, t});
    while (!st.empty()) {
        auto a = *st.begin();
        st.erase(a);
        auto now = a.S;
        for (auto to : g[now]) {
            if (dist[to.F] > dist[now] + to.S) {
                st.erase({dist[to.F], to.F});
                dist[to.F] = dist[now] + to.S;
                cnt[to.F] = cnt[now];
                st.insert({dist[to.F], to.F});
            }
            else if (dist[to.F] == dist[now] + to.S) {
                cnt[to.F] += cnt[now];
            }
        }
    }
    col.resize(n);
    dfs(s);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            if (col[to.F] && (dist[s] - dist[to.F] + to.S + dist[i]) == l) {
                ans += cnt[i];
                ans %= mod;
            }
        }
    }
    cout << ans << "\n";
}


int main() {
    int tt = 1;
//    cin >> t;
    while (tt --) {
        solve();
    }
}
