#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define F first
#define S second
#define PB push_back

ll n, m, s, t, l;
vector<vector<pair<ll, ll>>> g;
vector <ll> col, dist, cnt, used, dist2, cnt2;
const ll mod = 1e9 + 7;

void dfs(ll now) {
    used[now]++;
    col[now]++;
    for (auto to : g[now]) {
        if (!used[to.F] && dist[now] == to.S + dist[to.F]) {
            dfs(to.F);
        }
    }
}

void solve() {
    cin >> n >> m;
    cin >> s >> t >> l;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        g[a].PB({b, w});
        g[b].PB({a, w});
    }
    dist.resize(n, LLONG_MAX);
    cnt.resize(n, 0);
    s--; t--;
    dist[t] = 0;
    cnt[t] = 1;
    set <pair<ll, ll>> st;
    st.insert({0, t});
    while (!st.empty()) {
        auto a = *st.begin();
        st.erase(a);
        auto now = a.S;
        for (auto to : g[now]) {
            if (dist[to.F] > dist[now] + to.S) {
                st.erase({dist[to.F], to.F});
                dist[to.F] = dist[now] + to.S;
                cnt[to.F] = cnt[now];
                st.insert({dist[to.F], to.F});
            }
            else if (dist[to.F] == dist[now] + to.S) {
                cnt[to.F] += cnt[now];
                cnt[to.F] %= mod;
            }
        }
    }
    col.resize(n);
    used.resize(n);
    if (dist[s] == l) {
        cout << cnt[s] << "\n";
        return;
    }
    dfs(s);
    ll ans = 0;
    dist2.resize(n, LLONG_MAX);
    cnt2.resize(n, 0);
    dist2[s] = 0;
    cnt2[s] = 1;
    st.insert({0, s});
    while (!st.empty()) {
        auto a = *st.begin();
        st.erase(a);
        auto now = a.S;
        for (auto to : g[now]) {
            if (dist2[to.F] > dist2[now] + to.S) {
                st.erase({dist2[to.F], to.F});
                dist2[to.F] = dist2[now] + to.S;
                cnt2[to.F] = cnt2[now];
                st.insert({dist2[to.F], to.F});
            }
            else if (dist2[to.F] == dist2[now] + to.S) {
                cnt2[to.F] += cnt2[now];
                cnt2[to.F] %= mod;
            }
        }
    }
    col[t] = 0;
    for (int i = 0; i < n; i++) {
        if (col[i]) {
            for (auto to : g[i]) {
                if (dist2[i] + to.S + dist[to.F] == l) {
                    ans += cnt[to.F] * cnt2[i];
                    ans %= mod;
                }
            }
        }
    }
    cout << ans << "\n";
}


int main() {
    int tt = 1;
//    cin >> t;
    while (tt --) {
        solve();
    }
}
