#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define inf (LONG_LONG_MAX / 2)
#define all(x) x.begin(), x.end()

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(all(a));
    vector<int> dmn(n + 1), dmx(n + 1);
    dmn[0] = inf;
    dmx[0] = -inf;
    for (int i = 0; i < n; i++) {
        dmn[i + 1] = min(dmn[i], a[i] + a[n - 1 - i]);
        dmx[i + 1] = max(dmx[i], a[i] + a[n - 1 - i]);
    }
    int mid = n / 2;
    vector<int> rmx(mid), rmn(mid), lmn(mid), lmx(mid);
    rmx[0] = a[mid] + a[mid - 1]; rmn[0] = a[mid] + a[mid - 1]; lmn[0] = a[mid] + a[mid + 1]; lmx[0] = a[mid] + a[mid + 1];
    for (int i = 1; i < mid; i++) {
        lmn[i] = min(lmn[i - 1], a[mid - i] + a[n - (mid - i)]);
        lmx[i] = max(lmx[i - 1], a[mid - i] + a[n - (mid - i)]);
        rmn[i] = min(lmn[i - 1], a[mid + i] + a[n - (mid + i) - 1]);
        rmx[i] = max(lmx[i - 1], a[mid + i] + a[n - (mid + i) - 1]);
    }
    int ans = inf;
    for (int i = 0; i < mid; i++) {
        ans = min(ans, max(dmx[i], lmx[mid - i - 1]) - min(dmn[i], lmn[mid - i - 1]));
    }
    for (int i = n - 1; i > mid; i--) {
        ans = min(ans, max(dmx[n - 1 - i], rmx[i - mid - 1]) - min(dmn[n - 1 - i], rmn[i - mid - 1]));
    }
    ans = min(ans, dmx[mid] - dmn[mid]);
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
/*
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11
 */