#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define inf (LONG_LONG_MAX / 2)
#define all(x) x.begin(), x.end()

int mod = 1000000007;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> p(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < w; j++) {
            if (s[j] == '#') {
                p[i][j] = 1;
            }
        }
    }
    int ix, jx;
    for (int j = 1; j < w; j++) {
        int mn = inf, mx = -inf, s = 0;
        for (int i = 0; i < h; i++) {
            if (p[i][j]) {
                mn = min(mn, i);
                mx = max(mx, i);
                s += 1;
            }
        }
        if (mx - mn + 1 != s) {
            jx = j - 1;
            for (int i = mn; i < mx; i++) {
                if (!p[i][j]) {
                    ix = i;
                    break;
                }
            }
            break;
        } else {
            for (int i = 0; i < h; i++) {
                p[i][j - 1] = 0;
            }
        }
    }
    int s = w * ix + jx, f = s + w;
    vector<vector<int>> g(h * w);
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (p[i][j]) {
                if (i + 1 < h && p[i + 1][j] && (i * w + j != s)) {
                    g[i * w + j].push_back((i + 1) * w + j);
                    g[(i + 1) * w + j].push_back(i * w + j);
                }
                if (j + 1 < w && p[i][j + 1]) {
                    g[i * w + j].push_back(i * w + j + 1);
                    g[i * w + j + 1].push_back(i * w + j);
                }
            }
        }
    }
    vector<int> dist(h * w, inf), used(h * w, 0), pr(h * w, -1);
    dist[s] = 0;
    used[s] = 1;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int i : g[x]) {
            if (!used[i]) {
                dist[i] = dist[x] + 1;
                pr[i] = x;
                q.push(i);
                used[i] = 1;
            }
        }
    }
    vector<vector<int>> ans(h, vector<int>(w, 0));
    int pred = f;
    while (pred != -1) {
        ans[pred / w][pred % w] = 1;
        pred = pr[pred];
    }
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (ans[i][j]) {
                cout << '#';
            } else {
                cout << '.';
            }
        }
        cout << '\n';
    }
}
/*
 * 4 6
######
#.#.##
#...#.
#####.
 */

signed main() {
    ios_base::sync_with_stdio(false);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}