#include <bits/stdc++.h>
#define F first
#define S second
#define vi vector <int>
#define pii pair <int, int>
#define sz(a) (int)(a.size())
#define pb push_back
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
#define int long long
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1e9 + 7, MX = 200009, R = 1 << 17;
const ld EPS = 1e-9;

int sign(int x) {
    if (x < -EPS) return -1;
    if (x > EPS) return 1;
    return 0;
}

const ll INF = 1e18;
ll dists[200010], distt[200010];
ll kols[200010], kolt[200010];
vector <pair <int, ll>> g[200010];
const ll mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int n, m;
    cin >> n >> m;
    int s, t; ll L;
    cin >> s >> t >> L;
    s--, t--;
    for (int i = 0; i < m; i++) {
        int a, b; ll c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }

    set <pair <ll, int>> st;
    st.insert({0, s});
    kols[s] = 1;
    fill(dists, dists + n, INF);
    dists[s] = 0;
    while (!st.empty()) {
        int a = st.begin()->S;
        st.erase(st.begin());
        for (auto& el : g[a]) {
            int b = el.F; ll c = el.S;
            if (dists[a] + c < dists[b]) {
                st.erase({dists[b], b});
                dists[b] = dists[a] + c;
                kols[b] = kols[a];
                st.insert({dists[b], b});
            }
            else if (dists[a] + c == dists[b]) {
                kols[b] += kols[a];
                kols[b] %= mod;
            }
        }
    }

    st.clear();
    st.insert({0, t});
    kolt[t] = 1;
    fill(distt, distt + n, INF);
    distt[t] = 0;
    while (!st.empty()) {
        int a = st.begin()->S;
        st.erase(st.begin());
        for (auto& el : g[a]) {
            int b = el.F; ll c = el.S;
            if (distt[a] + c < distt[b]) {
                st.erase({distt[b], b});
                distt[b] = distt[a] + c;
                kolt[b] = kolt[a];
                st.insert({distt[b], b});
            }
            else if (distt[a] + c == distt[b]) {
                kolt[b] += kolt[a];
                kolt[b] %= mod;
            }
        }
    }

    if (L == dists[t]) {
        cout << kolt[s] << endl;
        return 0;
    }

    ll kol = 0;
    for (int a = 0; a < n; a++) {
        for (auto& el : g[a]) {
            int b = el.F; ll c = el.S;
            if (a != t && dists[a] + distt[a] == dists[t] && dists[a] + distt[b] + c == L) {
                kol += kols[a] * kolt[b];
                kol %= mod;
            }
        }
    }
    cout << kol << endl;
}




