#include<bits/stdc++.h>
#define int long long
#define ld long double
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define allr(x) x.rbegin(),x.rend()
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair


using namespace std;

const int INF = 1e18;

int solve(vector < int > a)
{
    int n = sz(a);
    int m = n / 2 + 1;
    vector < int > x(m), y(m);
    for(int i = 0; i < m; i++)
    {
        x[i] = a[i] + a[n - i - 1];
        y[i] = a[i] + a[n - i];
    }
    vector < int > pma(m + 1), pmi(m + 1), sma(m + 1), smi(m + 1);
    pma[0] = sma[m] = -INF;
    pmi[0] = smi[m] = INF;
    for(int i = 1; i <= m; i++)
    {
        pmi[i] = min(pmi[i - 1], x[i - 1]);
        pma[i] = max(pma[i - 1], x[i - 1]);
    }
    for(int i = m - 1; i >= 0; i--)
    {
        smi[i] = min(smi[i + 1], y[i]);
        sma[i] = max(sma[i + 1], y[i]);
    }
    int ans = INF;
    for(int i = 0; i < m; i++)
    {
        int mi = min(pmi[i], smi[i + 1]);
        int ma = max(pma[i], sma[i + 1]);
        ans = min(ans, ma - mi);
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector < int > a(n);
    for(auto &i : a)
        cin >> i;
    sort(all(a));
    vector < int > b = a;
    reverse(all(b));
    cout << min(solve(a), solve(b));
    return 0;
}

