#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define int ll

const char en = '\n';
const int INF = 1e9 + 7;
const int INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

const int N = 500;
int dp[N][N];
int cnt[N][N];
int pdp[N][N], pdp1[N][N];
int pcnt[N][N], pcnt1[N][N];

const int mod = 1e9 + 7;

int sub(int a, int b) {
    a -= b;
    if (a < 0) {
        a += mod;
    }
    return a;
}

int mul(int a, int b) {
    return a * b % mod;
}

void solve() {
    int a, b;
    cin >> a >> b;
    for (int n = 1; n <= a; n++) {
        for (int m = 1; m <= b; m++) {
            cnt[n][m] = 1;
            dp[n][m] = mul(n, m);
            if (m >= 2) {
                for (int w = 1; w <= n - 2; w++) {
                    (dp[n][m] += mul(n - w - 1, sub(mul(m, pdp[w][m - 2]), pdp1[w][m - 2]))) %= mod;
                    int add = sub(mul(m, pcnt[w][m - 2]), pcnt1[w][m - 2]);
                    (dp[n][m] += mul(mul(n - w - 1, mul(n, m)), add)) %= mod;
                    (cnt[n][m] += mul(n - w - 1, add)) %= mod;
                }
            }
            (pdp[n][m] = dp[n][m] + pdp[n][m - 1]) %= mod;
            (pdp1[n][m] = m * dp[n][m] + dp[n][m] + pdp1[n][m - 1]) %= mod;
            (pcnt[n][m] = cnt[n][m] + pcnt[n][m - 1]) %= mod;
            (pcnt1[n][m] = m * cnt[n][m] + cnt[n][m] + pcnt1[n][m - 1]) %= mod;
        }
    }
//    1 2 2
//    1 3 3
//    2 2 4
//    2 3 6
//    3 2 6
//    3 3 19
    cout << dp[a][b] << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
