#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define rep(i, a, b) for( auto i = a; i < b; i++)
#define forall(i, x) for(auto& i: x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)x.size())

using ll = long long;
using ld =  long double;
using ull = unsigned long long;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int test = 0;
const int maxn = 1e3+5;
char a[maxn][maxn];

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

char used[maxn][maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    rep(i, 0, n){
        rep(j, 0, m){
            cin >> a[i][j];
        }
    }
    queue<pair<int, int>> q;
    rep(i, 0, m){
        q.push({0, i});
        used[0][i] = 1;
        q.push({n-1, i});
        used[n-1][i] = 1;
    }
    rep(i, 0, n){
        q.push({i, 0});
        used[i][0] = 1;
        q.push({i, m-1});
        used[i][m-1] = 1;
    }

    vector<int> dx = {0, 0, -1, 1};
    vector<int> dy = {-1, 1, 0, 0};

    // bfs
    while(!q.empty()){
        auto kok = q.front();
        q.pop();
        rep(j, 0, 4){
            int nx = kok.first + dx[j];
            int ny = kok.second + dy[j];
            if(nx >= 0 && nx < n && ny >= 0 && ny < m && !used[nx][ny] && a[nx][ny] == a[kok.first][kok.second]){
                used[nx][ny] = 1;
                q.push({nx, ny});
            }
        }
    }
//    rep(i, 0, n){
//        rep(j, 0, m){
//            cout << (char)('0'+used[i][j]);
//        }
//        cout << '\n';
//    }
    auto cnt = [&](int i, int j){
        int ans = 0;
        rep(k, 0, 4){
            int nx = i + dx[k];
            int ny = j + dy[k];
            if(nx >= 0 && nx < n && ny >= 0 && ny < m && a[nx][ny] == '.' && !used[nx][ny]){
                ans++;
            }
        }
        return ans;
    };
    auto suka = [&](int i, int j){
        if(a[i][j] == '#'){
            int cc = cnt(i, j);
            if(cc > 2){
                return 1;
            }
            else if(cc == 2){
                if(i > 0 && i < n - 1 && j > 0 && j < m - 1) {
                    set<pair<int, int>> s;
                    rep(k, 0, 4){
                        int nx = i + dx[k];
                        int ny = j + dy[k];
                        if(a[nx][ny] == '#') s.insert({nx, ny});
                    }
                    if(s.size() == 2){
                        auto g1 = *s.begin(), g2 = *s.rbegin();
                        if(g1.first != g2.first && g1.second != g2.second){
                            pair<int, int> vec1 = {g1.first - i, g1.second - j}, vec2 = {g2.first - i, g2.second - j};
                            pair<int, int> vec3 = {vec1.first + vec2.first + i, vec1.second + vec2.second + j};
                            if(a[vec3.first][vec3.second] == '.' && used[vec3.first][vec3.second]) return 0;
                            else return 1;
                        }
                        else{
                            return 1;
                        }
                    }
                    else return 1;
                }
                else return 1;
            }
            else{
                return 0;
            }
        }
        else return 0;
    };
    rep(i, 0, n){
        rep(j, 0, m){
            if(suka(i, j)) {
                q.push({i, j});
//                cout << i << ' ' << j << '\n';
            }
        }
    }
    while(!q.empty()){
        auto kok = q.front();
        q.pop();
        if(a[kok.first][kok.second] == '.') continue;
        used[kok.first][kok.second] = 0;
        a[kok.first][kok.second] = '.';
        rep(j, 0, 4){
            int nx = kok.first + dx[j];
            int ny = kok.second + dy[j];
            if(nx >= 0 && nx < n && ny >= 0 && ny < m && cnt(nx, ny) == 2 && suka(nx, ny)){
                q.push({nx, ny});
            }
        }
    }
    vector<int> dx1 = {0, 1, -1}, dy1 = {0, 1, -1};
    auto correct = [&](int i, int j){
        if(a[i][j] == '.') return true;
        bool f = 0;
        rep(_1, 0, 3){
            rep(_2, 0, 3){
                if(!_1 && !_2) continue;
                int nx = i + dx1[_1];
                int ny = j + dy1[_2];
                if(nx >= 0 && nx < n && ny >= 0 && ny < m && !used[nx][ny] && a[nx][ny] == '.'){
                    f = 1;
                    break;
                }
            }
        }
        return f;
    };
    rep(i, 0, n){
        rep(j, 0, m){
            cout << (correct(i, j) ? a[i][j] : '.');
        }
        cout << '\n';
    }
}

int32_t main() {
    fast();
    int t = 1;
    if (test) cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
