#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast")
#pragma GCC target("sse,sse2,sse3,abm,avx,popcnt")

#define vec vector
#define F first
#define S second

#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef vec<ll> vll;

int f(int x, int n, const vector<int>& a) {
    return x + 1 - (upper_bound(a.begin(), a.end(), x) - a.begin());
}

int bisearch(int x, int n, const vector<int>& a) {
    int l = -1, r = 2e9, mid;
    while (r - l > 1) {
        mid = (r - l) / 2 + l;
        if (f(mid, n, a) < x) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout.precision(20);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int x;
    for (int i = 0; i < q; ++i) {
        cin >> x;
        cout << bisearch(x, n, a) << ' ';
    }

    return 0;
}
