#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast")
#pragma GCC target("sse,sse2,sse3,abm,avx,popcnt")

#define vec vector
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

#define endl '\n'

typedef int ll;
typedef long double ld;
typedef vec<ll> vll;
typedef pair<ll, ll> pll;

const ll inf = 1e9 + 10;

struct Node{
    ll ind, l, r,len;
};

bool cmp(Node a, Node b) {
    return a.len < b.len || a.len == b.len && a.l < b.l;
}

bool ok(Node a, Node b) {
    return (a.l <= b.l && b.r <= a.r);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout.precision(20);
    ll n;
    cin >> n;
    vec<ll> dp(n + 1);
    vec<Node> a(n + 1);
    vec<set<ll>> used(n + 1);
    for (ll i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        a[i] = {i, l, r, r - l + 1};
    }
    a.pb({n, 0, inf, inf + 1});
    sort(all(a), cmp);
    vec<ll> ans(n + 1);
    for (ll i = 0; i <= n; ++i) {
        for (ll j = i - 1; j >= 0; --j) {
            if (ok(a[i], a[j]) && used[i].find(j) == used[i].end()) {
                dp[i] += dp[j];
                used[i].insert(all(used[j]));
            }
        }
        dp[i]++;
        used[i].insert(i);
        ans[a[i].ind] = dp[i];
    }
    for (ll i = 0; i < n; ++i) cout << ans[i] << " ";
    return 0;
}
