#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(),v.end()
#define pll pair<long long, long long>
#define pii pair<int, int>
#define ff first
#define ss second

vector<vector<pll>> sp(100005, vector<pll>(19));
vector<int> logs(100005);

pll query(int l, int r){
    int lev = logs[r - l + 1];
    return min(sp[l][lev], sp[r - (1 << lev) + 1][lev]);
}

ll INF = 2e18;

void solve(){
    ll n, b, c;
    cin >> n >> b >> c;
    vector<pll> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i].ff >> a[i].ss;
    }
    int cur = 0;
    ll ost = 0;
    while(true){
       // cout << cur << ' ' << b << ' ' << ost << '\n';
        if(cur == n - 1){
            cout <<(ll)(a[cur].ff + min(c, b / a[cur].ss + ost));
            return;
        }
        int need = -1;
        pll mn = {INF, INF};
        for(int i1 = cur + 1; i1 < n; i1++){
            if(a[cur].ff + c < a[i1].ff) break;
            mn = min(mn, {a[i1].ss, i1});
            if(a[i1].ss <= a[cur].ss){
                need = i1;
                break;
            }
        }
        if(need != -1){
            if(a[cur].ss*(a[need].ff - a[cur].ff - ost) <= b){
                b -= a[cur].ss * (a[need].ff - a[cur].ff - ost);
                cur = need;
                ost = 0;
                continue;
            } else {
                ost += b / a[cur].ss;
                cout << (ll)(a[cur].ff + ost);
                return;
            }
        }
        if(mn.ff != INF && a[cur].ss*(c - ost) <= b){
            b -= a[cur].ss * (c - ost);
            ost = c - (a[mn.ss].ff - a[cur].ff -ost);
            cur = mn.ss;
            //cout << mn.ff << ' ' << mn.ss << ' ' << ost << '\n';
            continue;
        } else {
            ost += b / a[cur].ss;
            cout << (ll)(a[cur].ff + ost);
            return;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    //cin >> tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "_________________________________\n";
        #endif // LOCAL
    }
    return 0;
}
