//77 team
#include <iostream>
#include<algorithm>
#include<cmath>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
int main()
{
	cin.tie(0)->sync_with_stdio();
	int n, b, c;
	cin >> n >> b >> c;
	vector<int> pos(n), cost(n+1);
	for (int i = 0; i < n; i++) cin >> pos[i] >> cost[i];
	vector<int> ans(n, n);
	ans[n - 1] = n;
	cost[n] = -INF;
	stack<int> st;
	st.push(n);
	for (int i = 0; i < n; i++)
	{
		while (cost[i] < cost[st.top()])
		{
			if (pos[i] - pos[st.top()] <= c)
			{
				ans[st.top()] = i;
			}
			st.pop();
		}
		if (st.top() != n && (cost[i] < cost[ans[st.top()]] || cost[ans[st.top()]] == -INF)) ans[st.top()] = i;
		st.push(i);
	}
	int p = 0, money = b, dist = 0, fuel = 0;
	while (money != 0 && ans[p] != n)
	{
		int d = pos[ans[p]] - pos[p];
		if (cost[p] > cost[ans[p]])
		{
			dist += min(money / cost[p], d);
			money -= min(money, cost[p] * d);
			fuel = 0;
		}
		else
		{
			dist += min(money / cost[p]+fuel, d);
			int cnt = min(money / cost[p], c - fuel);
			fuel += cnt-d;
			money -= cnt * cost[p];
		}
		//cout << p << ' ' << money << ' ' << dist << ' ' << fuel << ' ' << d << '\n';

		p = ans[p];
	}
	dist += fuel + min(money / cost[p], c - fuel);
	cout << dist << '\n';
}