#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7;
const int INF = 1e18 + 7;
const int BASE = 69;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    set<int> s;
    for (auto &i: a) {
        cin >> i;
        s.insert(i);
    }
    sort(a.begin(), a.end());
    a.push_back(INF);
    while (q--) {
        int k;
        cin >> k;
        k--;
        int rp = -1;
        while (true) {
            int l = -1, r = n;
            while (l < r - 1) {
                int m = (l + r) / 2;
                if (a[m] <= k)
                    l = m;
                else
                    r = m;
            }

            if (a[r] > k) r--;
            if (l == -1) break;
            k += (r - rp);
            if (r - rp == 0) break;//cout << r << ' ' << rp << '\n';
            rp = r;

        }
        cout << k << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}