#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 2e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, B, C;
    cin >> n >> B >> C;

    vector<int> x(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i];
    }

    vector<int> R(n, n);
    vector<int> stk;
    for (int i = 0; i < n; ++i) {
        while (!stk.empty() && p[stk.back()] >= p[i]) {
            R[stk.back()] = i;
            stk.pop_back();
        }
        stk.push_back(i);
    }

    x.push_back(inf);

    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        if (i != 0 && ans < x[i] - x[i - 1] || i == n) {
            cout << x[i - 1] + ans << '\n';
            return 0;
        }
        if (i > 0)
            ans -= x[i] - x[i - 1];

        int mx = min({C - ans, x[R[i]] - x[i], B / p[i]});

        ans += mx;
        B -= p[i] * mx;
    }

    return 0;
}
