#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mod = 1000000007;

void solve(){
    int n, m;
    cin >> n >> m;

    int s, t, l;
    cin >> s >> t >> l;
    --s; --t;

    vector < vector < pair <int, int> > > a(n);
    for(int i = 0; i < m; ++i){
        int x, y, z;
        cin >> x >> y >> z;
        --x; --y;

        a[x].push_back({y, z});
        a[y].push_back({x, z});
    }

    vector <int> dist(n), used(n), dp(n);
    auto deixtra = [&](int v){
        dist.assign(n, 1e18);
        used.assign(n, 0);
        dp.assign(n, 0);
        priority_queue < pair <int, int> > q;

        int start = v;

        dist[v] = 0;
        used[v] = 1;
        dp[v] = 1;
        q.push({0, v});
        while(!q.empty()){
            while(!q.empty() && used[v]){
                v = q.top().second;
                q.pop();
            }

            if(used[v] && v != start){
                break;
            }

            used[v] = 1;

            for(auto to : a[v]){
                if(dist[to.first] + to.second == dist[v]) {
                    dp[v] += dp[to.first];
                    dp[v] %= mod;
                }
                if(dist[to.first] > dist[v] + to.second){
                    dist[to.first] = dist[v] + to.second;
                    q.push({-dist[to.first], to.first});
                }
            }
        }
    };

    vector <int> dps(n), dpt(n);

    deixtra(s);
    vector <int> dists = dist;
    dps = dp;

    deixtra(t);
    vector <int> distt = dist;
    dpt = dp;

    if(l == dists[t]){
        cout << dps[t];
        return;
    }

    int otv = 0;
    for(int v = 0; v < n; ++v){
        for(auto to : a[v]){
            int u = to.first;
            int w = to.second;
            if(dists[v] + distt[v] == dists[t] && distt[u] == l - w - dists[v]){
                otv += dps[v] * dpt[u];
                otv %= mod;
            }
        }
    }

    //cout << dists[t] << '\n';
    cout << otv;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();
}