#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct ST {
    vector<vector<ll>> mn;
    vector<ll> lg;
    ll k, n;

    explicit ST(vector<ll> &a) {
        n = (ll) a.size();
        k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mn.assign(k, vector<ll>(n));

        for (ll i = 0; i < n; i++) {
            mn[0][i] = a[i];
        }
        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                mn[i][j] = min(mn[i - 1][j], mn[i - 1][j + (1 << (i - 1))]);
            }
        }

        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(ll l, ll r) {
        ll ans = min(mn[lg[r - l]][l], mn[lg[r - l]][r - (1 << lg[n])]);
        return ans;
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll c, n, b;
    cin >> n >> b >> c;
    vector<ll> x(n), p(n);
    for (ll i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }

    vector<ll> pref(n + 1);
    pref[0] = 0;
    for (ll i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + p[i - 1];
    }

    vector<ll> a(n);

    ST st = ST(p);

    for (ll i = 0; i < n; i++) {
        ll l = i, r = n;
        while (r - l > 1) {
            ll m = (l + r) / 2;
            if (st.get(i, m + 1) < p[i]) {
                r = m;
            } else {
                l = m;
            }
        }
        a[i] = r;
    }

    ll cur = 0, fuel = 0;

    while (cur < n - 1) {
        if (min(fuel + b / p[cur], c) < x[cur + 1] - x[cur]) {
            cout << x[cur] + min(fuel + b / p[cur], c);
            return 0;
        }
        if (a[cur] == n) {
            if (c - fuel <= b / p[cur]) {
                b -= (c - fuel) * p[cur];
                fuel = c;
            } else {
                fuel += b / p[cur];
                b = b % p[cur];
            }
            fuel -= x[cur+1] - x[cur];
            cur++;

            continue;
        }
        ll z = min(c, b / p[cur] + fuel);
        if (x[a[cur]] - x[cur] > z) {
            if (c - fuel <= b / p[cur]) {
                b -= (c - fuel) * p[cur];
                fuel = c;
            } else {
                fuel += b / p[cur];
                b = b % p[cur];
            }
            fuel -= x[cur+1] - x[cur];
            cur++;
        } else {
            z = x[a[cur]] - x[cur];
            b -= z * p[cur];
            fuel += z;
            fuel -= x[a[cur]] - x[cur];
            cur = a[cur];
        }
    }
    cout << x[n - 1] + min(fuel + b / p[cur], c);
//    while (true) {
//        ll z = gg[cur];
//        if (z == a.size() - 1) {
//            if ((c - fuel) <= b * p[cur]) {
//                b-= (c-fuel)
//            }
//        }
//    }
}