#include <iostream>
#include <vector>
#include <set>
#include <algorithm>


using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

const long long INF = 90999999999999999;
const long long nmax = 1e5 + 15;

int n, ans = INF;
vector <int> arr;

int LEN(pair<int, int> a, pair<int, int> b) {
    return arr[a.first] + arr[a.second] - arr[b.first] - arr[b.second];
}

int SOL() {
    vector <int> m(n);

    auto cmp = [](pair<int, int> a, pair<int, int> b) {
        return arr[a.first] + arr[a.second] < arr[b.first] + arr[b.second];
    };
    set <pair<int, int>, decltype(cmp)> s(cmp);

    for (int i = 0; i < n / 2; i++) {
        s.insert({i, n - i - 1});
        m[i] = n - i - 1;
    }

    ans = min(ans, LEN(*s.rbegin(), *s.begin()));
    for (int i = n / 2 - 1; i > -1; i--) {
        int u = m[i];
        s.erase({i, u});
        s.insert({i + 1, u});

        m[i + 1] = u;

        ans = min(ans, LEN(*s.rbegin(), *s.begin()));
    }
}

void solve() {
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    if (n == 3) {
        cout << 0;
        return;
    }

    sort(all(arr));
    SOL();
    reverse(all(arr));
    SOL();

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}