#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
#define int ll
#define ar array

const int N = 2e5 + 5;
const int mod = 1e9 + 7;
vector<ar<int, 2>> edges[N];

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    int s, t, L; cin >> s >> t >> L;
    vector<ar<int, 3>> e;
    for(int i=0;i<m;i++){
        int a, b, c; cin >> a >> b >> c;
        edges[a].push_back({b, c});
        edges[b].push_back({a, c});
        e.push_back({a, b, c});
    }
    
    auto djk = [&](int s, vector<int>& d, vector<int>& cnt){
        priority_queue<ar<int, 2>, vector<ar<int, 2>>, greater<ar<int, 2>>> q;
        d.resize(n + 1, 1e18);
        cnt.resize(n + 1);
        d[s] = 0, cnt[s] = 1;
        q.push({0, s});
        while(!q.empty()){
            auto [D, u] = q.top(); q.pop();
            if(D > d[u]) continue;
            for(auto [x, c] : edges[u]){
                if(d[x] > d[u] + c){
                    d[x] = d[u] + c;
                    cnt[x] = cnt[u];
                    q.push({d[x], x});
                } else if(d[x] == d[u] + c){
                    cnt[x] = (cnt[x] + cnt[u]) % mod;
                }
            }
        }
    };
    
    vector<int> d[2], cnt[2];
    djk(s, d[0], cnt[0]);
    djk(t, d[1], cnt[1]);
    int D = d[0][t];
    if(L == D){
        cout<<cnt[0][t]<<"\n";
        return 0;
    }
    int res = 0;
    for(auto [a, b, c] : e){
        if(d[0][a] + d[1][a] == D && d[0][a] + c + d[1][b] == L){
            res = (res + cnt[0][a] * 1ll * cnt[1][b]) % mod;
        }
        swap(a, b);
        if(d[0][a] + d[1][a] == D && d[0][a] + c + d[1][b] == L){
            res = (res + cnt[0][a] * 1ll * cnt[1][b]) % mod;
        }
    }
    
    cout<<res<<"\n";
}
