#include <bits/stdc++.h>
#define int long long
#define F first
#define S second
#define pb push_back
#define mp make_pair
using namespace std;

const int MAXN = 2e5 + 10;
const int mod = 1e9 + 7;
int n, m, s, t;
int L;
int inf = 1e18;
pair <int, int> d[MAXN][2];
vector<pair<int,int> > g[MAXN];

void dijkstra(int x, int t) {
    for(int i = 1; i <= n; i ++) {
        d[i][t].F = inf;
        d[i][t].S = 0;
    }
    d[x][t] = {0 , 1};
    set<pair<int,int>> st;
    st.insert({d[x][t].F , x});
    while(st.size()) {
        auto cur = *st.begin();
        st.erase(cur);
        for(auto to: g[cur.S]) {
            if(cur.F+to.S < d[to.F][t].F) {
                st.erase({d[to.F][t].F, to.F});
                d[to.F][t].F = cur.F+to.S;
                d[to.F][t].S = d[cur.S][t].S;
                st.insert({d[to.F][t].F, to.F});
            }
            else if(cur.F+to.S == d[to.F][t].F) {
                d[to.F][t].S += d[cur.S][t].S;
                d[to.F][t].S %= mod;
            }
        }
    }
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s >> t >> L;
    for(int i = 1; i <= m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb(mp(v, w));
        g[v].pb(mp(u, w));
    }
    dijkstra(s, 0);
    dijkstra(t, 1);
    if(L == d[t][0].F) {
        cout << d[t][0].S;
        return 0;
    }
    int ans = 0;
    for(int i = 1; i <= n; i ++) {
        if(d[i][0].F + d[i][1].F == d[t][0].F) {
            for(auto x: g[i]) {
                if(d[i][0].F + x.S + d[x.F][1].F == L) {
                    ans += d[i][0].S * d[x.F][1].S % mod;
                    ans %= mod;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
/*
8 10
1 8 3
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
4 8 1
5 8 1
6 8 1
7 8 1
*/
