#include <bits/stdc++.h>
#define int long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

const int MAXN = 2e5 + 10;
const int MOD = 1e9 + 7;
int n, m, s, t;
int L;
pair <int, int> d[MAXN][2];
pair <pair<int, int>, int> ed[MAXN];
vector<pair<int,int> > g[MAXN];

void dijkstra(int x, int t) {
    for(int i = 1; i <= n; ++i) d[i][t] = mp(1E9, 0);
    d[x][t] = mp(0, 1);
    set <pair<int, int> > st;
    st.insert(mp(0, x));
    while(!st.empty()) {
        auto sf = *st.begin();
        st.erase(st.begin());
        int v = (sf).s;
        for(auto to : g[v]) {
            if(d[to.f][t].f > d[v][t].f + to.s) {
                st.erase(mp(d[to.f][t].f, to.f));
                d[to.f][t].f = d[v][t].f + to.s;
                d[to.f][t].s = d[v][t].s;
                st.insert(mp(d[to.f][t].f, to.f));
            } else if(d[to.f][t].f == d[v][t].f + to.s) {
                d[to.f][t].s = (d[to.f][t].s + d[v][t].s) % MOD;
            }
        }
    }
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s >> t >> L;
    for(int i =1; i <= m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        ed[i] = mp(mp(u, v), w);
        g[u].pb(mp(v, w));
        g[v].pb(mp(u, w));
    }
    dijkstra(s, 0);
    dijkstra(t, 1);
//    cout << d[t][0].s << ' ';
  //  return 0;
    if(L == d[t][0].f) {
        cout << d[t][0].s;
        return 0;
    }
    int ans = 0;/*
    for(int i = 1; i <= m; ++i) {
        int u = ed[i].f.f;
        int v = ed[i].f.s;
        int w = ed[i].s;
        if(d[u][0].f + d[v][1].f + w == L) {
            ans = (ans + d[u][0].s * d[v][1].s % MOD) % MOD;
        }
        //cout << u << ' ' << v << ' ' << d[u][0].f << ' ' << d[v][1].f << ' ' << d[u][0].s << ' ' << d[v][1].s << '\n';
        swap(u, v);
        if(d[u][0].f + d[v][1].f + w == L) {
            ans = (ans + d[u][0].s * d[v][1].s % MOD) % MOD;
        }
        ///cout << u << ' ' << v << ' ' << d[u][0].f << ' ' << d[v][1].f << ' ' << d[u][0].s << ' ' << d[v][1].s << '\n';

    }
    */
    for(int i = 1; i <= n; i ++) {
        if(d[i][0].f + d[i][1].f == d[t][0].f) {
            for(auto x: g[i]) {
                if(d[i][0].f + x.s + d[x.f][1].f == L) {
                    ans += d[i][0].s * d[x.f][1].s % MOD;
                    ans %= MOD;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
