#include <bits/stdc++.h>
#define f first
#define s second
using namespace std;
typedef long long ll;
typedef pair<long long, long long> pii;
#define ent "\n";

const int maxn = 1e3 + 100;
const int MOD = 1e9 + 7;
const int dx[] = {1, 0, -1, 0, 1, 1, -1, -1};
const int dy[] = {0, 1, 0, -1, -1, 1, 1, -1};

int n, m;
int a[maxn][maxn];
int used[maxn][maxn];

void dfs(int x, int y, int c){
    used[x][y] = c;
    for(int i = 0; i < 4; i++){
        int x1 = x + dx[i];
        int y1 = y + dy[i];
        if(min(x1, y1) < 1 || x1 > n || y1 > m || used[x1][y1] == c || a[x1][y1]) continue;
        dfs(x1, y1, c);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            char c; cin >> c;
            a[i][j] = c == '#';
        }
    }
    for(int i = 1; i <= n; i++){
        if(!used[i][1] && !a[i][1]) dfs(i, 1, 1);
        if(!used[i][m] && !a[i][m]) dfs(i, m, 1);
    }
    for(int i = 1; i <= m; i++){
        if(!used[1][i] && !a[1][i]) dfs(1, i, 1);
        if(!used[n][i] && !a[n][i]) dfs(n, i, 1);
    }
    for(int i = 1; i <= n; i++){
        int f = 1e9, s = 0;
        for(int j = 1; j <= m; j++){
            if(a[i][j] || used[i][j]) continue;
            if(f == 1e9) f = j;
            s = j;
        }
        for(int j = f; j <= s; j++) a[i][j] = 0;
    }
    for(int j = 1; j <= m; j++){
        int f = 1e9, s = 0;
        for(int i = 1; i <= n; i++){
            if(a[i][j] || used[i][j]) continue;
            if(f == 1e9) f = i;
            s = i;
        }
        for(int i = f; i <= s; i++) a[i][j] = 0;
    }
    vector<pii> v;
    for(int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if(!a[i][j]) continue;
            bool ok = 0;
            for(int k = 0; k < 8; k++) {
                int x = i + dx[k];
                int y = j + dy[k];
                if(x < 1 || y < 1 || x > n || y > m || a[x][y] || used[x][y]) continue;
                ok = 1;
            }
            if(!ok) v.push_back({i, j});
        }
    }
    for(auto [i, j]: v) a[i][j] = 0;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            if(a[i][j]) cout << "#";
            else cout << ".";
        }
        cout << ent;
    }
}