#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, m; cin >> n >> m;
    vector<vector<char>> g(n, vector<char>(m));
    for(int i = 0; i < n; i++) {
        string s; cin >> s;
        for(int j = 0; j < m; j++) g[i][j] = s[j];
    }
    vector<vector<bool>> w(n, vector<bool>(m, false));
    vector<int> di = {1, 0, -1, 0};
    vector<int> dj = {0, 1, 0, -1};
    auto isValid = [&](int i, int j) {
        return i >= 0 && i < n && j >= 0 && j < m;
    };
    function<bool(int, int)> dfs = [&](int i, int j) {
        if(!isValid(i, j)) return false;
        if(g[i][j] == '#') return true;
        if(w[i][j]) return true;
        w[i][j] = 1;
        bool ok = true;
        for(int k = 0; k < 4; k++) ok &= dfs(i + di[k], j + dj[k]);
        return ok;
    };
    int si = -1, sj = -1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(si != -1) break;
            if(g[i][j] == '.' && w[i][j] == 0) {
                if(dfs(i, j)) {
                    si = i, sj = j;
                }
            }
        }
    }
    w = vector<vector<bool>>(n, vector<bool>(m, false));
    dfs(si, sj);
    int l = m + 1, r = -1, u = n + 1, d = -1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(g[i][j] == '#' || !w[i][j]) continue;
            l = min(l, j);
            r = max(r, j);
            u = min(u, i);
            d = max(d, i);
        }
    }
    vector<vector<char>> ng(n, vector<char>(m, '.'));
    ng[u - 1][l - 1] = '#';
    ng[u - 1][r + 1] = '#';
    ng[d + 1][l - 1] = '#';
    ng[d + 1][r + 1] = '#';
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(j == l - 1 || j == r + 1) {
                if(i >= u && i <= d) ng[i][j] = '#';
            }
            if(i == u - 1 || i == d + 1) {
                if(j >= l && j <= r) ng[i][j] = '#';
            }
        }
    }
    for(int i = 0; i < n; i++) {
        string s;
        for(int j = 0; j < m; j++) s +=  ng[i][j];
        cout << s << '\n';
    }
    return 0;
}
