#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll MOD = 1e9 + 7;

vector<long long> p, x;
vector<pair<long long, int>> seg;
int s = 1;

void build(int l, int r, int u){
    if(l == r){
        if(l < x.size()) seg[u] = {p[l], l};
        else seg[u] = {1e18, -1};
        return;
    }
    int m = (l + r) / 2;
    build(l, m, 2 * u + 1), build(m + 1, r, 2 * u + 2);
}

pair<long long, int> get(int l, int r, int lx, int rx, int u){
    if(lx >= l && rx <= r) return seg[u];
    if(lx > r || rx < l) return {1e18, -1};
    int m = (lx + rx )/ 2;
    return min(get(l, r, lx, m, 2 * u + 1), get(l, r, m + 1, rx, 2 *u  + 2));
}

void solve(){
    long long n, b, c; cin >> n >> b >> c;
    p = x = vector<long long> (n);
    for(int i = 0; i < n; i++){
        cin >> x[i] >> p[i];
    }
    while(s < n) s *= 2;
    seg =vector<pair<long long, int>> (2 * s);
    build(0, s - 1, 0);
    int i = 0;
    // b -> pox, c -> bak
    ll benzin = 0 ;
    while(i < n){
        // cout << benzin << '\n';
        ll radius = min(c, b / p[i] + benzin) + x[i];
        int id = upper_bound(x.begin(), x.end(), radius) - x.begin();
        if(id == i + 1){
            // cout <<"! " << i << endl;
            benzin += b / p[i];
            benzin = min(benzin, c);
            break;
        }
        id--;
        // cout << "! " << id << endl;
        ll l = i, r = id;
        bool f = 0;
        if(r == l + 1){
            pair<ll, int> pp = get(r,r,0, s-  1, 0);
            if(pp.first <= p[l]) f = 1;
        }
        while(l + 1 < r){
            int m = (l + r) / 2;
            pair<long long, int> pp =  get(i + 1, m, 0, s - 1, 0);
            if(pp.first <= p[i]) r = m, f = 1;
            else l = m;
        }
        if(f){
            // cout << "! " << i << endl;
            ll needmoney = max(0ll, (x[r] - x[i] - benzin)) * p[i];
            b -= needmoney;
            benzin -= min(benzin, x[r] - x[i]);
            i = r;
        }
        else{
            pair<long long, int> pp = get(i + 1, id, 0, s - 1, 0);
            r = pp.second;
            //int needmoney = max(0ll, (x[r] - x[i] - benzin)) * p[i], neeedbenzin = x[r] - x[i];
            ll krnanqlcel = min(b / p[i], c - benzin);
            benzin += krnanqlcel - (x[r] - x[i]);
            b -= krnanqlcel * p[i];
            i = pp.second;
        }
    }
    // cout << x[i] << " ";
    cout << benzin + x[i] << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    // int t; cin >> t; while (t--)
        solve();
}
