#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int f(int ind, int n, long long sum, vector<long long>& a) {
	int l = 0, r = n - 1;
	long long max = 0, min = sum;
	int max1, max2, min1, min2;
	for (int i = 0; i < n / 2; ++i) {
		if (ind == l) {
			l += 1;
		}
		else if (ind == r) {
			r -= 1;
		}
		long long s = a[l] + a[r];
		if (s > max) {
			max = s;
			max1 = l;
			max2 = r;
		}
		if (s < min) {
			min = s;
			min1 = l;
			min2 = r;
		}
		++l;
		--r;
	}
	return max - min;
}

long long miN(long long a, long long b) {
	return (a < b) ? a : b;
}
bool cmp(const pair<int, int> &a, const pair<int, int> &b) {
	return (a.first + a.second) < (b.first + b.second);
}

int main() {
	int n;
	cin >> n;
	vector<long long> a(n);
	long long sum = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum += a[i];
	}
	sort(a.begin(), a.end());
	
	vector<pair<int, int>> b;
	for (int i = 0; i < n / 2 + 1; ++i) {
		if (n - 1 - i + 1 < n) {
			b.push_back(make_pair(a[i], a[n - i - 1 + 1]));
		}
		if (n - 2 - i != i) {
			b.push_back(make_pair(a[i], a[n - i - 2]));
		}
		b.push_back(make_pair(a[i], a[n - i - 1]));
	}
	sort(b.begin(), b.end(), cmp);

	int max1 = b.back().first, max2 = b.back().second, min1 = b.front().first, min2 = b.front().second;
	long long t2 = f(min1, n, sum, a),
		t3 = f(min2, n, sum, a),
		t4 = f(max1, n, sum, a),
		t5 = f(max2, n, sum, a),
		t6 = f(0, n, sum, a),
		t7 = f(n - 1, n, sum, a);

	cout << miN(t2, miN(t3, miN(t4, miN(t5, miN(t6, t7))))) << endl;
}