#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

typedef tree
<ll,
 null_type,
 less<ll>,
 rb_tree_tag,
 tree_order_statistics_node_update> ordered_set;

 const ll MOD = 1e9 + 7;

 ll sum(ll x, ll y)
 {
     return (x + y + MOD * MOD) % MOD;
 }

 ll mult(ll x, ll y)
 {
     return (x * y) % MOD;
 }

 const ll N = 500;

 ll dp[N][N];
 ll kol[N][N];

 ll p_p[N];
 ll p_m[N];
 ll m_p[N];
 ll m_m[N];

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll x, y;
    cin >> x >> y;
    for (ll i = 1; i <= y; i++)
    {
        kol[1][i] = 1;
        kol[2][i] = 1;
    }
    for (ll j = 1; j <= y; j++)
    {
        p_p[j] = sum(p_p[j - 1], kol[1][j]);
        p_m[j] = sum(p_m[j - 1], kol[1][j] * j);
        m_p[j] = sum(m_p[j - 1], kol[1][j] * 1);
        m_m[j] = sum(m_m[j - 1], kol[1][j] * j * 1);
    }

    for (ll i = 3; i <= x; i++)
    {
        kol[i][1] = 1;
        kol[i][2] = 1;
        for (ll j = 3; j <= y; j++)
        {
            kol[i][j] = sum(mult(p_p[j - 2], mult((i - 1), (j - 1))) - mult(p_m[j - 2], i - 1) - mult(m_p[j - 2], j - 1) + m_m[j - 2], 1);
        }
        ll p_p1 = 0;
        ll p_m1 = 0;
        ll m_p1 = 0;
        ll m_m1 = 0;
        for (ll j = 1; j <= y; j++)
        {
            p_p1 = sum(p_p1, kol[i - 1][j]);
            p_m1 = sum(p_m1, kol[i - 1][j] * j);
            m_p1 = sum(m_p1, kol[i - 1][j] * (i - 1));
            m_m1 = sum(m_m1, kol[i - 1][j] * (i - 1) * j);
            p_p[j] = sum(p_p[j], p_p1);
            p_m[j] = sum(p_m[j], p_m1);
            m_p[j] = sum(m_p[j], m_p1);
            m_m[j] = sum(m_m[j], m_m1);
        }
    }

    for (ll i = 0; i < N; i++)
    {
        p_p[i] = 0;
        p_m[i] = 0;
        m_p[i] = 0;
        m_m[i] = 0;
    }
    for (ll i = 1; i <= y; i++)
    {
        dp[1][i] = i;
        dp[2][i] = 2 * i;
    }
    for (ll j = 1; j <= y; j++)
    {
        p_p[j] = sum(p_p[j - 1], dp[1][j]);
        p_m[j] = sum(p_m[j - 1], dp[1][j] * j);
        m_p[j] = sum(m_p[j - 1], dp[1][j] * 1);
        m_m[j] = sum(m_m[j - 1], dp[1][j] * j * 1);
    }

    for (ll i = 3; i <= x; i++)
    {
        dp[i][1] = i;
        dp[i][2] = 2 * i;
        for (ll j = 3; j <= y; j++)
        {
            dp[i][j] = sum(mult(p_p[j - 2], mult((i - 1), (j - 1))) - mult(p_m[j - 2], i - 1) - mult(m_p[j - 2], j - 1),  m_m[j - 2]);
            dp[i][j] = sum(dp[i][j], mult(kol[i][j], mult(i, j)));
        }
        ll p_p1 = 0;
        ll p_m1 = 0;
        ll m_p1 = 0;
        ll m_m1 = 0;
        for (ll j = 1; j <= y; j++)
        {
            p_p1 = sum(p_p1, dp [i - 1][j]);
            p_m1 = sum(p_m1, dp [i - 1][j] * j);
            m_p1 = sum(m_p1, dp [i - 1][j] * (i - 1));
            m_m1 = sum(m_m1, dp [i - 1][j] * (i - 1) * j);
            p_p[j] = sum(p_p[j], p_p1);
            p_m[j] = sum(p_m[j], p_m1);
            m_p[j] = sum(m_p[j], m_p1);
            m_m[j] = sum(m_m[j], m_m1);
        }
    }

    cout << dp[x][y];

}
