#ifdef LOCAL
#define _GLIB_CXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

void solve() {
    ll n, ans = 10e18;
    cin >> n;
    multiset <ll> ms;
    vector<ll> a(n), p(n / 2, 0);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    for(int i = 0; i < n / 2; i++){
        p[i] = a[i + 1] + a[n - i - 1];
        ms.insert(p[i]);
    }
    ans = min(ans, (*(--ms.end()) - *ms.begin()));
    for(int i = 0; i < n / 2; i++){
        auto it = ms.find(p[i]);
        ms.erase(it);
        p[i] += a[i];
        p[i] -= a[i + 1];
        ms.insert(p[i]);
        ans = min(ans, (*(--ms.end()) - *ms.begin()));
    }

    for(int i = n / 2; i > 0; i--){
        auto it = ms.find(p[i - 1]);
        ms.erase(it);
        p[i - 1] += a[n - i - 1];
        p[i - 1] -= a[n - i];
        ms.insert(p[i - 1]);
        ans = min(ans, (*(--ms.end()) - *ms.begin()));
    }

    cout << ans;


}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    auto start = clock();
    cerr.precision(3);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

#ifdef LOCAL
    auto end_t = clock();
    cerr << "Execution time: " << (end_t - start) * 1000 / CLOCKS_PER_SEC << " ms\n";
#endif
}