#ifdef LOCAL
#define _GLIB_CXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    cin >> a;
//    vector<ll> d;
//    d.push_back(a[0]);
//    for (int i = 1; i < n; ++i) {
//        d.push_back(a[i] - a[i - 1] - 1);
//    }
//    vector<ll> pref(n + 1);
//    for (int i = 1; i <= n; ++i) {
//        pref[i] = pref[i - 1] + d[i - 1];
//    }
    for (int i = 0; i < q; ++i) {
        ll x;
        cin >> x;
        ll l = -1, r = n;
        while (r - l > 1) {
            ll m = (r + l) / 2;
            if (a[m] - m >= x) {
                r = m;
            } else {
                l = m;
            }
        }
        if (r == 0) {
            cout << x - 1 << ' ';
        } else {
            cout << a[r - 1] + (x - (a[r - 1] + 1 - r)) << ' ';
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    auto start = clock();
    cerr.precision(3);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

#ifdef LOCAL
    auto end_t = clock();
    cerr << "Execution time: " << (end_t - start) * 1000 / CLOCKS_PER_SEC << " ms\n";
#endif
}