#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<deque>

using namespace std;

pair<int, int> arr[100005];
int rightl[100005];
int rightmin[100005];


/*
2 10 2
0 3
3 1
*/
void solve() {
	//cout << 1500 * 1500 * 4 * 4 * 4 * 4;
	int n, b, c;
	cin >> n >> b >> c;
	int rn = -1;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
		if (rn == -1 && i != 0 && arr[i].first - arr[i - 1].first > c) {
			rn = i;
		}
	}
	if (rn != -1) {
		n = rn;
	}
	
	deque<pair<int, int>> d;
	d.push_back({ 0, -1 });
	for (int i = n - 1; i >= 0; i--) {
		while (d.back().first > arr[i].second) {
			d.pop_back();
		}
		rightl[i] = d.back().second;
		d.push_back({arr[i].second, i});
	}
	deque<pair<int, int>> d2;
	d2.push_back({ arr[n - 1].second, n - 1 });
	for (int i = n - 2; i >= 0; i--) {
		while (!d2.empty() && arr[d2.front().second].first > arr[i].first + c) {
			d2.pop_front();
		}
		rightmin[i] = d2.front().second;
		while (!d2.empty() && d2.back().first > arr[i].second) {
			d2.pop_back();
		}
		d2.push_back({ arr[i].second, i });
	}

	int tc = 0;
	int ind = 0;
	int ans = min(tc + b / arr[ind].second, c);
	while (ind != n - 1 && b > 0) {
		if (rightl[ind] == -1 || arr[rightl[ind]].first > arr[ind].first + c) {
			b -= (c - tc) * arr[ind].second;
			tc = c - (arr[rightmin[ind]].first - arr[ind].first);
			ind = rightmin[ind];
		}
		else {
			b -= (arr[rightl[ind]].first - arr[ind].first - tc) * arr[ind].second;
			tc = 0;
			ind = rightl[ind];
		}
		if (b >= 0)
			ans = max(ans, arr[ind].first + min(tc + b / arr[ind].second, c));
	}
	cout << ans << "\n";
	return;
}

int main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;

	while (tt--) {
		solve();
	}
}