#include <bits/stdc++.h>

#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define int long long

using namespace std;

typedef long double ld;
typedef long long ll;


const ll mod = 1e9 + 7;
const ll base = 1e6 + 6;
const ll inf = 1e18;
const int MAX = 2e5;

random_device rd;

void solve() {
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    vector<vector<pair<int, int>>> adj(n + 1);
    vector<int> ready(n + 1);
    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        adj[u].pb({v, w});
        adj[v].pb({u, w});
    }
    vector<pair<int, int>> df(n + 1, {inf, 0});
    df[t] = {0, 1};
    set<pair<int, int>> q;
    for(int i = 1; i <= n; i++) {
        q.insert({df[i].f, i});
    }
    while(!q.empty()) {
        auto [dist, v] = *q.begin();
        ready[v] = 1;
        q.erase(q.begin());
        for(auto [to, w] : adj[v]) {
            if(dist + w < df[to].f) {
                q.erase({df[to].f, to});
                df[to].f = dist + w;
                q.insert({df[to].f, to});
            }
            if(ready[to] && dist == df[to].f + w) {
                df[v].s += df[to].s;
                df[v].s %= mod;
            }
        }
    }
    if(df[s].f == L) {
        cout << df[s].s << '\n';
        return;
    }
    fill(all(ready), 0);
    vector<pair<int, int>> ds(n + 1, {inf, 0});
    ds[s] = {0, 1};
    for(int i = 1; i <= n; i++) {
        q.insert({ds[i].f, i});
    }
    while(!q.empty()) {
        auto [dist, v] = *q.begin();
        ready[v] = 1;
        q.erase(q.begin());
        for(auto [to, w] : adj[v]) {
            if(dist + w < ds[to].f) {
                q.erase({ds[to].f, to});
                ds[to].f = dist + w;
                q.insert({ds[to].f, to});
            }
            if(ready[to] && dist == ds[to].f + w) {
                ds[v].s += ds[to].s;
                ds[v].s %= mod;
            }
        }
    }
    int ans = 0;
    for(int v = 1; v <= n; v++) {
        if(df[v].f + ds[v].f != df[s].f) {
            continue;
        }
        for(auto [u, w] : adj[v]) {
            if(ds[v].f + w + df[u].f == L) {
                ans += ds[v].s * df[u].s % mod;
                ans %= mod;
            }
        }
    }
    cout << ans << '\n';
}
/**
4 4
1 4 2
1 2 1
2 4 1
1 3 1
3 4 1
**/


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}
