#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define loop(start, end, var) for (int var = start; var <= end; var++)
#define loopDown(start, end, var) for (int var = start; var >= end; var--)
#define sz(x) (int)((x).size())
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define pw(x) (1ll << (x))

typedef pair<int, int> pi;
typedef pair<int, int> pii;
typedef vector<int> vi;

int n, B, C;

vector <vector<pi>> mn;

void build(vector <pi> & a)
{
	int n = a.size() - 1;

	int lg = __lg(n + 1);

	mn.assign(lg+1, vector <pi>(n+1, {1e18, -1}));

	loop(0, n, i)
		mn[0][i] = {a[i].S, i};

	loop(1, lg, l)
	{
		loop(0, n - pw(l) + 1, i)
		{
			mn[l][i] = min(mn[l-1][i], mn[l-1][i + pw(l-1)]);
		}
	}
}

pi get(int l, int r)
{
	int lg = __lg(r-l+1);
	return min(mn[lg][l], mn[lg][r - pw(lg) + 1]);
}

void solve()
{
	cin >> n >> B >> C;

	vector <pi> a(n+1);

	loop(1, n, i)
	{
		cin >> a[i].F >> a[i].S;
	}

	sort(all(a));

	build(a);

	int cur = 1, bak = 0;

	int ans = 0;

	while (B >= 0)
	{
//		cout << "!" << cur << ' ' << bak << ' ' << B<< '\n';

		int pos = upper_bound(all(a),
								mp(a[cur].F + min(C, bak + B / a[cur].S), -1ll)) - a.begin() - 1;

		ans = max(ans, a[cur].F + min(C, bak + B / a[cur].S) );

		if (pos <= cur)
			break;

		pi m = get(cur + 1, pos);

		if (m.F >= a[cur].S)
		{
			int dist = a[m.S].F - a[cur].F;
			B -= (C - bak) * a[cur].S;
			bak = C;
			bak -= dist;
			cur = m.S;
		}
		else
		{
			int l = cur + 1, r = pos + 1;

			while (r - l > 1)
			{
				int m = (l + r) / 2;

				if (get(cur + 1, m).F < a[cur].S)
					r = m;
				else
					l = m;
			}

			if (r == pos + 1) r = pos;

			int dist = a[r].F - a[cur].F;
			B -= max(0ll, dist - bak) * a[cur].S;
			bak += max(0ll, dist - bak);
			bak -= dist;
			cur = r;
		}
	}

//	cout << cur << ' ' << bak << ' ' << B << '\n';

	ans = max(ans, a[cur].F + min(C, bak + B / a[cur].S) );

	cout << ans << '\n';
}

signed main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie();
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
	while (T--){
		solve();
	}
}
