#include <bits/stdc++.h>

using namespace std;
#define LL long long int
#define ll long long
#define fori(n) for(int i = 0; i < n; i++)
#define PLL pair<LL, LL>
#define x first
#define y second

struct info {
   ll x, p, i;
};

struct i2{
    ll p, i;
};

i2 minQ(i2 a, i2 b){
    if(a.p < b.p)return a;
    return b;
}

struct queue2{
    vector<pair<info, i2>> a, b;

    void insert(info t){
        if(a.size() == 0)a.push_back({t, {t.p, t.i}});
        else a.push_back({t, minQ({t.p, t.i}, a.back().second)});
    }

    ll get_min(){
        if(b.size() == 0){
            b.push_back({a.back().first, {a.back().first.p, a.back().first.i}});
            a.pop_back();
            while(a.size() > 0){
                b.push_back({a.back().first, minQ({a.back().first.p, a.back().first.i} , b.back().second)});
                a.pop_back();
            }
        }

        if(a.size() == 0)return b.back().second.i;
        else{
            if(a.back().second.p < b.back().second.p)return a.back().second.i;
            else return b.back().second.i;
        }
    }

    void del(){
        if(b.size() == 0){
            b.push_back({a.back().first, {a.back().first.p, a.back().first.i}});
            a.pop_back();
            while(a.size() > 0){
                b.push_back({a.back().first, minQ({a.back().first.p, a.back().first.i} , b.back().second)});
                a.pop_back();
            }
        }
        b.pop_back();
    }

    info back(){
        if(b.size() == 0){
            b.push_back({a.back().first, {a.back().first.p, a.back().first.i}});
            a.pop_back();
            while(a.size() > 0){
                b.push_back({a.back().first, minQ({a.back().first.p, a.back().first.i} , b.back().second)});
                a.pop_back();
            }
        }

        return b.back().first;
    }

    void clear(){
        a.clear();
        b.clear();
    }

    ll size(){return a.size() + b.size();}
};

int main() {
    ll n, b, c; cin >> n >> b >> c;
    ll nowC = 0;
    queue2 q;

    vector<info> v(n + 1);
    for(int i = 0; i < n; i++){
        cin >> v[i].x >> v[i].p;
        v[i].i = i;
    }
    q.insert(v[0]);

    for(int i = 0; i < n; i++){
        if(q.size() > 0)q.del();

        ll maxX = min(c, nowC + b / v[i].p);
        ll j;
        if(q.size() != 0)j = q.back().i + 1;
        else j = i + 1;
        bool ok = false;
        while(j < n && v[j].x <= v[i].x + maxX){
            if(v[j].p < v[i].p){
                ok = true;
                break;
            }
            q.insert(v[j]);
            j++;
        }

        if(ok){
            if(nowC >= v[j].x - v[i].x)nowC -= v[j].x - v[i].x;
            else b -= (v[j].x - v[i].x - nowC) * v[i].p;
            q.clear();
            i = j - 1;
            continue;
        }

        if(q.size() > 0){
            ll ind = q.get_min();
            if(v[i].p < v[ind].p){
                ll t = max(0ll, min(c, b / v[i].p) - nowC);
                b -= t * v[i].p;
                nowC += t - v[ind].x + v[i].x;
                ll f = ind - i - 1;
                while(f-- && q.size() > 0)q.del();
                i = ind - 1;
            }else{
                ll t = max(0ll, min<ll>(v[ind].x - v[i].x, b / v[i].p) - nowC);
                b -= t * v[i].p;
                nowC += t - v[ind].x + v[i].x;
                ll f = ind - i - 1;
                while(f-- && q.size() > 0)q.del();
                i = ind - 1;
            }
        }else{
            cout << v[i].x + min(c, nowC + b / v[i].p);
            break;
        }
    }
}
