#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	ll ans = INF;
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	int l, r;
	ll mi, ma; 

	ma = -INF;
	mi = INF;
	l = 0;
	r = n - 1;
	while (l < r) {
		ma = max(ma, a[l] + a[r]);
		mi = min(mi, a[l] + a[r]);
		l++;
		r--;
	}
	ans = min(ans, ma - mi);

	ma = -INF;
	mi = INF;
	l = 0;
	r = n - 2;
	while (l < r) {
		ma = max(ma, a[l] + a[r]);
		mi = min(mi, a[l] + a[r]);
		l++;
		r--;
	}
	ans = min(ans, ma - mi);

	ma = -INF;
	mi = INF;
	l = 1;
	r = n - 1;
	while (l < r) {
		ma = max(ma, a[l] + a[r]);
		mi = min(mi, a[l] + a[r]);
		l++;
		r--;
	}
	ans = min(ans, ma - mi);

	cout << ans;
}