#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;
const int32_t MAXN = 1E5;
const int64_t MOD = 1E9 + 7;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}



int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, b, c;
	cin >> n >> b >> c;
	vector <int> mas(n), cost(n), ans(n, -1);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i] >> cost[i];
	}

	deque<int> dq;
	for (int i = n - 1; i >= 0; i--) {
		while (!dq.empty() && cost[dq.back()] > cost[i])
			dq.pop_back();
		if (dq.empty())
		{
			ans[i] = -1;
		}
		else
			ans[i] = dq.back();
		dq.push_back(i);
	}

	mas.push_back(2E9 + 1);
	int t_b = 0, t_bal = b;
	for (int i = 0; i < n; i++)
	{
		int nxt = ans[i];
		if (nxt == -1)
		{
			int dop = min(c - t_b, t_bal / cost[i]);
			t_b += dop;
			t_bal -= dop * cost[i];
		}
		else
		{
			if (mas[i] + t_b < mas[nxt])
			{
				int dop = min({ c,mas[nxt] - mas[i] - t_b, t_bal / cost[i] });
				t_b += dop;
				t_bal -= dop * cost[i];
			}
		}
		if (t_b < mas[i + 1] - mas[i])
		{
			cout << mas[i] + t_b;
			exit(0);
		}
		t_b -= mas[i + 1] - mas[i];
	}
	cout << mas[n - 1] + t_b;
}