#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cassert>
#define int long long
#define pi pair<int, int>
using namespace std;
const int INF = 1e16;
const int MOD2 = 1e9 + 7;
vector<vector<int>> fir_group;
vector<vector<int>> groups;
vector<int> req;
vector<int> ans;
vector<vector<int>> sec_groups;
vector<vector<int>> sec_ans;
vector<int> unknown;
vector<int> match;

int intersect(vector<int>& a, vector<int>& b) {
	for (auto x : a) {
		for (auto y : b) {
			if (x == y) return x;
		}
	}
	assert(false);
}

int sqr(int num) {
	int tmp = 1; int clen = 0;
	while (clen <= num) {
		clen += tmp;
		tmp++;
	}
	return tmp - 1;
}

void do_diff() {
	vector<int> fir; vector<int> sec;
	vector<int> ans(5);
	cout << 2 << endl;
	for (int i = 0; i < 5; ++i) {
		if (i < 3) cout << 1 << " ";
		else cout << 2 << " ";
	}
	cout << endl;
	for (int j = 0; j < 2; ++j) {
		int sz = 0; cin >> sz;
		if (sz == 3) {
			for (int j = 0; j < sz; ++j) { int tmp = 0; cin >> tmp; tmp--; fir.push_back(tmp); }
		}
		else {
			for (int j = 0; j < sz; ++j) { int tmp = 0; cin >> tmp; tmp--; sec.push_back(tmp); }
		}
	}
	cout << 2 << endl;
	for (int i = 0; i < 5; ++i) {
		if (i == 0) cout << 1 << " ";
		else cout << 2 << " ";
	}
	cout << endl;
	vector<int> l;
	cout << endl;
	for (int j = 0; j < 2; ++j) {
		int sz = 0; cin >> sz;
		if (sz == 1) {
			int x = 0; cin >> x; x--; ans[0] = x;
		}
		else {
			for (int j = 0; j < sz; ++j) {
				int tmp = 0; cin >> tmp; tmp--; l.push_back(tmp);
			}
		}
	}
	cout << 2 << endl;
	for (int i = 0; i < 5; ++i) {
		if (i % 2 == 0) cout << 1 << " ";
		else cout << 2 << " ";
	}
	cout << endl;
	for (int i = 0; i < 2; ++i) {
		int sz = 0; cin >> sz;
		if (sz == 3) {
			vector<int> aa(3); for (auto& x : aa) cin >> x;
			for (auto& x : aa) x--;
			ans[4] = intersect(aa, sec);
		}
		else {
			vector<int> aa(2); for (auto& x : aa) cin >> x;
			for (auto& x : aa) x--;
			ans[1] = intersect(aa, fir);
			ans[3] = intersect(aa, sec);
		}
	}
	vector<bool> used(5); for (auto x : ans) {
		if (x >= 0) used[x] = true;
	}
	for (int j = 0; j < 5; ++j) {
		if (!used[j]) ans[2] = j;
	}
	for (auto x : ans) cout << x + 1 << " ";
	cout << endl;
}

void solve() {
	int N = 0; cin >> N;
	int k = sqr(N);
	bool have_problem = false;
	if (N == 5) {
		do_diff();
		return;
	}
	req.assign(N, 0);
	int len = 1;
	int last_num = 1;
	int it1 = 0;
	while (it1 < N) {
		cout << it1 << " " << last_num << endl;
		if (it1 + last_num > N) {
			cout << it1 << " " << last_num << "\n";
			for (int k = it1; k < N; ++k) req[k] = last_num - 1;
			break;
		}
		else {
			for (int j = it1; j < it1 + last_num; ++j) req[j] = last_num;
			it1 += last_num;
			last_num++;
		}
	}
	last_num--;
	groups.assign(last_num, vector<int>());
	for (int i = 0; i < N; ++i) groups[req[i] - 1].push_back(i);
	cout << last_num << endl;
	for (int i = 0; i < N; ++i) cout << req[i] << " ";
	cout << endl;
	fir_group.assign(last_num, vector<int>());
	for (int j = 0; j < last_num; ++j) {
		int num = 0; cin >> num;
		int write_num = num; if (write_num > last_num) write_num = last_num;
		write_num--;
		for (int k = 0; k < num; ++k) {
			int tmp = 0; cin >> tmp; tmp--;
			fir_group[write_num].push_back(tmp);
		}
		cout << write_num << endl;
	}
	vector<int> secreq;
	secreq.assign(N, 0);
	int lastbet = 0;
	for (int num = 1; num <= last_num; ++num) {
		for (int j = groups.size() - 1; j >= groups.size() - num; --j) {
			secreq[groups[j].back()] = num; groups[j].pop_back();
		}
	}
	unknown.assign(N, -1);
	for (auto x : groups.back()) {
		secreq[x] = last_num;
	}
	for (int k = N - last_num; k >= N - fir_group.back().size(); --k) unknown[k] = 1;
	sec_groups.assign(last_num, vector<int>());
	sec_ans.assign(last_num, vector<int>());
	cout << last_num << endl;
	for (auto x : secreq) cout << x << " ";
	cout << endl;
	for (int j = 0; j < last_num; ++j) {
		int sz = 0; cin >> sz; 
		int write_num = min(sz, last_num) - 1;
		for (int j = 0; j < sz; ++j) {
			int x = 0; cin >> x; x--;
			sec_ans[write_num].push_back(x);
		}
	}
	ans.assign(N, -1);
	match.assign(N, -1);
	for (int i = 0; i < N; ++i) {
		if (unknown[i] == 1) continue;
		int group_size_1 = req[i] - 1; int sec_size = secreq[i] - 1;
		ans[i] = intersect(fir_group[group_size_1], sec_ans[sec_size]);
	}
	vector<int> known; vector<int> other;
	for (int i = 0; i < N; ++i) {
		if (ans[i] == -1) other.push_back(i);
		else {
			match[ans[i]] = i;
			known.push_back(i);
		}
	}
	vector<int> lst;
	lst.assign(N, 0);
	int cnum = 1;
	for (int i = 0; i < other.size(); ++i) {
		lst[other[i]] = cnum;
		lst[known[i]] = cnum;
		cnum++;
	}
	for (int k = other.size(); k < known.size(); ++k) {
		lst[known[k]] = cnum;
	}
	cout << cnum << endl;
	for (auto x : lst) cout << x << " ";
	cout << endl;
	for (int j = 0; j < cnum; ++j) {
		int sz = 0; cin >> sz;
		vector<int> cr;
		bool dd = false;
		for (int ind = 0; ind < N; ++ind) {
			int tmp = 0; cin >> tmp; tmp--;
			cr.push_back(tmp);
			if (match[tmp] == -1) {
				dd = true;
			}
		}
		if (dd) {
			if (match[cr.front()] == -1) swap(cr[0], cr[1]);
			int tmp = match[cr[0]];
			int d = 0; while (known[d] != tmp) {
				d++;
			}
			ans[other[d]] = cr[1];
		}
	}
	for (auto x : ans) cout << x + 1 << " ";
	cout << endl;
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cout << setprecision(20);
	solve();
	return 0;
}