#include <bits/stdc++.h>

using namespace std;
#define ll long long


const ll mod = 1e9 + 7;

int tn;
vector<ll> d;
vector<int> mx;


void build(int n){
    tn = 1;
    while(tn < n){
        tn *= 2;
    }
    d.assign(tn + tn, 0);
    mx.assign(tn + tn, -1);
}


ll zalupa_slonika(int v, int x){
    if(v >= tn){
        if(mx[v] > x){
            return d[v];
        }
        return 0;
    }
    if(mx[v] <= x){
        return 0;
    }
    if(mx[v + v] <= x){
        return zalupa_slonika(v + v + 1, x);
    }
    ll rs = zalupa_slonika(v + v, x) + (d[v] - d[v + v]);
    rs %= mod;
    if(rs < 0){
        rs += mod;
    }
    return rs;
}


void upd(int v){
    d[v] = (d[v + v] + zalupa_slonika(v + v + 1, mx[v + v]));
    mx[v] = max(mx[v + v], mx[v + v + 1]);
}

void chng(int i, int x, ll dp){
    i += tn;
    d[i] = dp;
    mx[i] = x;
    for(i >>= 1; i > 0; i >>= 1){
        upd(i);
    }
}


ll get(int l){
    l += tn;
    int r = tn + tn;
    ll rs = 0;
    int mmx = -1;
    while(l < r){
        if(l & 1){
            rs = (rs + zalupa_slonika(l, mmx));
            mmx = max(mmx, mx[l]);
            l += 1;
        }
        l /= 2;
        r /= 2;
    }
    return rs;
}


bool comp(const array <int, 3> &a, const array <int, 3> &b){
    if(a[1] != b[1]){
        return a[1] < b[1];
    }
    return a[0] > b[0];
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <array <int, 3>> a(n);
    vector <int> all_l(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
        a[i][2] = i;
        all_l.push_back(a[i][0]);
    }
    sort(all_l.begin(), all_l.end());
    all_l.resize(unique(all_l.begin(), all_l.end()) - all_l.begin());
    int len = (int)all_l.size();
    build(len);
    sort(a.begin(), a.end(), comp);
    vector <int> ans(n);
    for (auto& i : a) {
        int x = lower_bound(all_l.begin(), all_l.end(), i[0]) - all_l.begin();
        int y = i[1];
        ll dp = get(x);
        dp = (dp + 1) % mod;
        ans[i[2]] = dp;
        chng(x, y, dp);
    }
    for (int i : ans) cout << i << " ";
    return 0;
}

/*
3 10 5
0 3
1 1
4 2
 */