#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
////#pragma GCC optimize "O0"
using namespace std;
//#define int long long

#define int ll
typedef long long ll;
typedef vector<ll> vll;
#define sz(x) int(x.size())
const ll inf = 4e9;
struct Node {
    Node *l = 0, *r = 0;
    ll lo, hi, mset = inf, madd = 0, val = -inf;
    Node(int lo, int hi):lo(lo),hi(hi){}
    Node(vll &v, int lo, int hi) : lo(lo), hi(hi) {
    if (lo + 1 < hi) {
        int mid = lo + (hi - lo) / 2;
        l = new Node(v, lo, mid); r = new Node(v, mid, hi);
        val = max(l->val, r->val);
    }
    else val = v[lo];
    }
    ll query(int L, int R) {
    if (R <= lo || hi <= L) return -inf;
    if (L <= lo && hi <= R) return val;
    push();
    return max(l->query(L, R), r->query(L, R));
    }
    void set(int L, int R, int x) {
    if ( R <= lo || hi <= L) return;
    if (L <= lo && hi <= R) mset = val = x, madd = 0;
    else {
        push(), l->set(L, R, x), r->set(L, R, x);
        val = max(l->val, r->val);
    }
    }
    void add(int L, int R, ll x) {
        if (R <= lo || hi <= L) return;
        if (L <= lo && hi <= R) {
            if (mset != inf) mset += x;
            else madd += x;
            val += x;
        } else {
        push();
        l->add(L, R, x);
        r->add(L, R, x);
        val = max(l->val, r->val);
        }
    }
    void push() {
    if (!l) {
        int mid = lo + (hi - lo) / 2;
        l = new Node(lo, mid); r = new Node(mid, hi);
    }
    if (mset != inf) {
        l->set(lo, hi, mset); r->set(lo, hi, mset), mset = inf;

    } else if (madd) {
        l->add(lo, hi, madd), r->add(lo, hi, madd);
        madd = 0;
    }
    }


};
struct FT {
    vector<ll> s;
    FT(int n) : s(n+10) {}
    void update(int pos, ll dif) {
        pos++;
    for (; pos < sz(s); pos += pos & -pos) s[pos] += dif;
    }
    ll query (int pos) {
        pos++;
    ll res =  0;
    for (; pos > 0; pos -= pos & -pos) res += s[pos];
    return res;}
    // upd l, -upd r to up seg
    // query (i+1) to see ans in i
};
signed main()
{
    int n;
    ll b, c;
    ll answ = 0;
    cin >> n >> b >> c;
    vector<ll> a(n), p(n);
    for (int i = 0; i < n; i++) cin >> a[i] >> p[i];
    a.push_back(2000000001);
    p.push_back(2000000001);
    ++n;
    int l = n - 1;
    set<pair<ll, int>> bpc;
    bpc.emplace(p[0], 0);
    int curr = 0;
    int i;
    vector<ll> dsts(n);
//    FT faf(n);
//    faf.update(1, 10);

    for (int i = 1; i < n; ++i) {
        dsts[i] = dsts[i-1] + (a[i-1] - a[i]);
    }
    Node st(dsts, 0, n);
    for (i = 1; i < n; i++) {
//        cout << "i " << i << " b " << b << '\n';
        answ = max(answ, a[i-1] + min(b / p[i-1], c));
        int nd = a[i] - a[i-1];
        bool bk = false;
        while (!bpc.empty() && nd > 0) {
            auto bg = bpc.begin();
            auto bv = *bg;
            ll qwv = st.query(bv.second, n);
            int ca = min((ll)nd, c - qwv);
            ca = min((ll)ca, b / bv.first);
//            cout << bv.first << ' ' << bv.second << ' ' << ca << ' ' << nd << ' ' << b << ' ' << nd * bv.first << '\n';
//            cout << faf.query(bv.second + 1) << '\n';
            if (ca == c - qwv) {
                bpc.erase(bg);
            }
            if (b / bv.first == 0) bk = true;
            nd -= ca;
//            cout << "qu " << bv.second << ' ' << ca <<  ' ' << faf.query(bv.second+1) << '\n';
//            faf.update(bv.second, ca);
            st.add(bv.second, n, ca);
//            cout << "qu " << bv.second << ' ' << ca <<  ' ' << faf.query(bv.second+1) << '\n';
            b -= ca * bv.first;
            if (bk) {
                answ = max(answ, a[i] - nd);
                break;
            }
        }
        answ = max(answ, a[i] - nd);
        if (bk) break;
        if (nd > 0) break;
        bpc.emplace(p[i], i);
    }
//    answ = max(answ, a[i-1] + min(b / p[i-1], c));
    cout << answ;

}
