#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);
    cout << fixed << setprecision(15);
    int n, m, s, t;
    ll L;
    cin >> n >> m >> s >> t >> L;
    vector<vector<pair<int, ll>>> g(n);
    s--, t--;
    for (int i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    vector<vector<ll>> d(2, vector<ll> (n, INF));
    vector<vector<ll>> cnt(2, vector<ll> (n, 0));
    vector<bool> good(n, false);
    d[0][s] = d[1][t] = 0;
    cnt[0][s] = cnt[1][t] = 1;
    auto dijkstra = [&](int t) {
        set<pair<ll, int>> s;
        for (int i = 0; i < n; ++i) {
            s.insert({d[t][i], i});
        }
        while (!s.empty()) {
            auto [cur, v] = *s.begin();
            s.erase(s.begin());
            if (cur == INF) break;
            for (auto [to, w] : g[v]) {
                if (d[t][to] > cur + w) {
                    ll& x = d[t][to];
                    s.erase({x, to});
                    x = cur + w;
                    s.insert({x, to});
                    cnt[t][to] = cnt[t][v];
                } else if (d[t][to] == cur + w) {
                    cnt[t][to] = (cnt[t][to] + cnt[t][v]) % MOD;
                }
            }
        }
    };
    dijkstra(0), dijkstra(1);
    for (int i = 0; i < n; ++i) {
        good[i] = (d[0][i] + d[1][i] == d[0][t]);
    }
    if (L == d[0][t]) {
        cout << cnt[0][t] << '\n';
        return 0;
    }
    ll ans = 0;
    for (int v = 0; v < n; ++v) if (good[v] && v != t) {
        for (auto [to, w] : g[v]) {
            if (d[0][v] + w + d[1][to] == L) {
                ans += (cnt[0][v] * cnt[1][to]) % MOD;
                ans %= MOD;
            }
        }
    }
    cout << ans << '\n';
}
