#include <bits/stdc++.h>

using namespace std;

#define  sz(a) (int)(a.size())
#define  dbg(x) cout << #x << " = " << (x) << endl;
#define int long long
#define all(a) a.begin(), a.end()
#define ll long long
#define ld long double

const int N = 2e5 + 10;

vector<pair<int, int>> g[N];

const ll mod = 1e9 + 7;

int add (int a, int b) {
    return (a + b) % mod;
}

int mul (int a, int b) {
    return (a * b) % mod;
}

int n;

vector<pair<int, int>> dijsktra (int s) {
    vector<pair<int, int>> dist(n, {1e18, 0});
    dist[s] = {0, 1};
    set<pair<int, int>> st;
    st.insert({0, s});
    vector<bool> used(n, false);
    while (!st.empty()) {
        auto [D, u] = *st.begin();
        st.erase(st.begin());
        used[u] = true;
        for (auto x : g[u]) {
            int v = x.first, w = x.second;
            if (used[v]) continue;
            if (dist[v].first > D + w) {
                st.erase({dist[v].first, v});
                dist[v].first = D + w;
                dist[v].second = dist[u].second;
                st.insert({dist[v].first, v});
            } else if (dist[v].first == D + w) {
                dist[v].second = add(dist[v].second, dist[u].second);
            }
        }
    }
    return dist;
}

void solve() {
    int m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    s--;t--;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    auto to = dijsktra(s);
    auto from = dijsktra(t);
    vector<bool> ban(n, false);
    for (int i = 0; i < n; i++) {
        if (to[i].first + from[i].first == to[t].first) {
            ban[i] = true;
        }
    }
    int ans = 0;
    if (to[t].first == L) {
        cout << to[t].second << endl;
        return;
    }
    for (int i = 0; i < n; i++) {
        if (i == t) continue;
        for (auto x : g[i]) {
            int To = i, From = x.first, w = x.second;
            if (!ban[To]) continue;
//            dbg(To);
//            dbg(From);
//            dbg(to[To].second);
//            dbg(from[From].second);
            dbg(w + to[To].first + from[From].first);
            if (w + to[To].first + from[From].first == L) {
               ans = add(ans, mul(to[To].second, from[From].second));
            }
        }
    }
    cout << ans << endl;
}

signed main() {
//#ifdef home
//    freopen("input.txt", "r", stdin);
//#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}