#include <bits/stdc++.h>

using namespace std;

#define  sz(a) (int)(a.size())
#define  dbg(x) cout << #x << " = " << (x) << endl;
#define int long long
#define all(a) a.begin(), a.end()
#define ll long long
#define ld long double

vector<set<int>> ask(vector<int> &t, int num) {
    cout << num << endl;
    for (int j = 0; j < sz(t); j++) {
        cout << t[j] << " ";
    }
    cout << endl;
    vector<set<int>> v(num);
    for (int i = 0; i < num; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            v[i].insert(x);
        }
    }
    sort(all(v), [&](set<int> &t, set<int> &b){
        return sz(t) < sz(b);
    });
    return v;
}

ostream & operator << (ostream &out, vector<int> &a) {
    for (auto &v : a) {
        out << v << " ";
    }
    out << endl;
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n, -1), was_size(n, -1);
    int size = 0, num = 0;
    vector<set<int>> a(n + 1), b(n + 1);
    for (int i = 0; i < n; i++) {
        int j = i;
        size++;
        num++;
        while (j < min(i + size, n)) {
            p[j] = num;
            a[num].insert(j);
            j++;
        }
        i = j - 1;
    }
    for (int i = 0; i < n; i++) {
        was_size[i] = sz(a[p[i]]);
    }
    auto x = ask(p, num);
    // want to Ask Ostatok
    vector<int> Q(n, 2), Was(n, -1);
    int one = -1, two = -1;
    for (int i = 0; i < sz(x); i++) {
        if (Was[sz(x[i])] != -1) {
            one = i;
            two = sz(x[i]);
        }
        Was[sz(x[i])] = i;
    }
    if (one == -1) {
        vector<int> temp(n, 1);
        auto y = ask(temp, 1);
        for (int i = 0; i < sz(x); i++) {
            for (auto v : x[i]) {
                b[sz(x[i])].insert(v);
            }
        }
    } else {
        swap(one, two);
        for (auto &v : a[one]) {
            Q[v] = 1;
        }
        auto y = ask(Q, 2);
        vector<bool> used(n, false);
        for (int i = 0; i < sz(x); i++) {
            if (sz(x[i]) != sz(x[one])) {
                for (auto v : x[i]) {
                    b[sz(x[i])].insert(v);
                    used[v] = true;
                }
            }
        }
        for (auto v : y[0]) {
            used[v] = true;
            b[sz(x[one])].insert(v);
        }
        for (int j = 1; j <= n; j++) {
            if (!used[j]) {
                b[num].insert(j);
            }
        }
    }
//    for (int j = 1; j <= num; j++) {
//        for (auto v : b[j]) {
//            cout << v << " ";
//        }
//        cout << endl;
//    }
    auto A = a;
    vector<set<int>> t;
    for (int j = 1; j <= num; j++) {
        if (sz(A[j]) == 0) continue;
        set<int> k;
        for (int i = j; i <= num; i++) {
            if (sz(A[i]) == 0) continue;
            k.insert(*A[i].begin());
            A[i].erase(A[i].begin());
        }
        t.push_back(k);
    }
    vector<int> color(n, -1);
    for (int i = 0; i < sz(t); i++) {
        for (auto v : t[i]) {
            color[v] = i + 1;
        }
    }
    vector<int> ans(n, -1);
    auto Z = ask(color, sz(t));
    reverse(all(Z));
    for (int i = 0; i < sz(Z); i++) {
        for (auto v : Z[i]) {
//            dbg(v);
            for (int j = 1; j <= num; j++) {
                if (b[j].find(v) != b[j].end()) {
                    for (auto Y : t[i]) {
//                        dbg(Y);
                        if (a[j].find(Y) != a[j].end()) {
                            ans[Y] = v;
                            break;
                        }
                    }
                    break;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
}

signed main() {
//#ifdef home
//    freopen("input.txt", "r", stdin);
//#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}