#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

const int MOD = 1000000007;

int dp[410][410];
int cnt[410][410];
int dp_[410][410];
int cnt_[410][410];

int n, m;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			dp[i][j] = i * j;
			cnt[i][j] = 1;
			for (int x = 1; x <= i - 2; ++x)
			{
				int const1 = (i - x - 1);
				int cnty = j - 2;
				if (cnty <= 0) continue;
				dp[i][j] += (j - 1) * const1 % MOD * dp[x][j - 2] % MOD;
				dp[i][j] %= MOD;
				dp[i][j] += const1 * dp_[x][j - 2] % MOD;
				dp[i][j] %= MOD;
				dp[i][j] += const1 * i % MOD * j % MOD * (j - 1) % MOD * cnt[x][j - 2] % MOD;
				dp[i][j] %= MOD;
				dp[i][j] += const1 * i % MOD * j % MOD * cnt_[x][j - 2] % MOD;
				dp[i][j] %= MOD;

				cnt[i][j] += const1 * (j - 1) % MOD * cnt[x][j - 2] % MOD;
				cnt[i][j] %= MOD;
				cnt[i][j] += const1 * cnt_[x][j - 2] % MOD;
				cnt[i][j] %= MOD;
				/*for (int y = 1; y <= j - 2; ++y)
				{
					dp[i][j] += dp[x][y] * (j - y - 1) + cnt[x][y] * (i - x - 1) * (j - y - 1) * i * j;
					cnt[i][j] += cnt[x][y] * (i - x - 1) * (j - y - 1);
				}*/
			}
			dp_[i][j] = ((MOD - j) * dp[i][j] % MOD + dp_[i][j - 1] % MOD) % MOD;
			cnt_[i][j] = ((MOD -j) * cnt[i][j] % MOD + cnt_[i][j - 1] % MOD) % MOD;

			dp[i][j] += dp[i][j - 1];
			dp[i][j] %= MOD;
			cnt[i][j] += cnt[i][j - 1];
			cnt[i][j] %= MOD;
		}
	}

	cout << (dp[n][m] + MOD - dp[n][m - 1]) % MOD;

	return 0;
}