#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
#define vec vector
#define int ll
//#define endl '\n'

//typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
template<typename T> tree<T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const double eps = 1e-9;
const int inf = 1e18;
void dijictra(int root,vec<int>&dist,vec<int>&cnt,vec<vec<pair<int,int>>>graph){
    set<vector <int>>q;
    dist[root] = 0;
    cnt[root] = 1;
    q.insert({0, root, 0, 1});
    while (!q.empty()){
        vector <int> h = *q.begin();
        q.erase(q.begin());
        int v = h[1];
        for (int i = 0; i < graph[v].size(); i++){
            //cout << v << endl;
            int to = graph[v][i].first, w = graph[v][i].second;
            if (dist[to] == dist[v] + w) {
                int c = cnt[to];
                cnt[to] -= h[2];
                cnt[to] += (int)(1e9 + 7);
                cnt[to] += h[3];
                cnt[to] %= (int) (1e9 + 7);
                q.insert({dist[to], to, c, cnt[to]});
            }else if (dist[to] > dist[v] + w){
                cnt[to] = cnt[v];
                dist[to] = dist[v] + w;
                q.insert({dist[to], to, 0, cnt[to]});
            }
        }
    }
}
void solve() {
    int n,m,s,t,l;
    cin>>n>>m>>s>>t>>l;
    s--;
    t--;
    vec<vec<pair<int,int>>>graf(n);
    for (int i = 0; i < m; ++i) {
        int a,b,cost;
        cin>>a>>b>>cost;
        a--;b--;
        graf[a].emplace_back(b,cost);
        graf[b].emplace_back(a,cost);
    }
    vec<int>dists(n,1e18);
    vec<int>cnts(n);
    dijictra(s,dists,cnts,graf);
    vector <int> distt(n, inf);
    vector <int> cntt(n);
    dijictra(t, distt, cntt, graf);
    if (l == dists[t]){
        cout << cnts[t];
        return;
    }
    //cout << 1 << endl;
    int ans = 0;
    for (int i = 0; i < n; i++){
        if (i == t) continue;
        for (auto [to, w]:graf[i]){
            if (w + dists[i] + distt[to] == l && dists[i] + distt[i] == dists[t]){
                ans += cnts[i] * cntt[to], ans %= (int)(1e9 + 7);
                //cout << i + 1 << " " << to + 1 << endl;
            }
        }
    }
    cout << ans;
}

signed main() {
#ifdef BIBIKOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
