#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#define ll long long
using namespace std;
int r = 1'000'000'007;
pair<ll, ll> rect(ll h, ll w){
    ll s, c;
    if (min(h, w) <= 2){
        s = (w * (w + 1) * (w + 2) * h * (h + 1) * (h + 2) / 36);
        c = (w * (w + 1) * h * (h + 1) / 4);
        return make_pair(s, c);
    }
    else{
        ll h_, w_, s_, c_;
        s = (w * (w + 1) * (w + 2) * h * (h + 1) * (h + 2) / 36) % r;
        c = (w * (w + 1) * h * (h + 1) / 4) % r;
        for (h_ = 3; h_ < h + 1; h_++){
            for (w_ = 3; w_ < w + 1; w_++){
                pair<ll, ll> temp = rect(h_ - 2, w_ - 2);
                s_ = temp.first;
                c_ = temp.second;
                s += ((h_ * w_ * c_ + s_) * (h - h_ + 1) * (w - w_ + 1)) % r;
                c += (c_ * (h - h_ + 1) * (w - w_ + 1)) % r;
                s = s % r;
                c = c % r;
            }
        }
        return make_pair(s, c);
    }
}
ll base(ll h, ll w){
    if (min(h, w) <= 2){
        return h * w;
    }
    else{
        ll s_, c_;
        pair<ll, ll> temp = rect(h - 2, w - 2);
        s_ = temp.first;
        c_ = temp.second;
        return (((((c_ + 1) * w) % r) * h) % r + s_) % r;
    }
}
int main(){
    ll height, width;
    cin >> height >> width;
    ll res = base(height, width);
    cout << res;
}
