#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point
{
    int id;
    long long value;

    bool operator < (Point other)
    {
        return value < other.value;
    }
};

int main()
{
    int n, q;
    cin >> n >> q;

    vector<long long> data(n + 1);
    for (int i = 0; i < n; i++) cin >> data[i];
    data[n] = 1e9 + 5;

    vector<Point> ask(q);
    for (int i = 0; i < q; i++)
    {
        cin >> ask[i].value;
        ask[i].id = i;
    }
    sort(ask.begin(), ask.end());

    vector<long long> res(q);
    long long lastIdx = 0;
    int askId = 0;
    for (int nId = 0; nId < n + 1; nId++)
    {
        if (askId >= q) break;

        long long colNew;
        if (nId == 0)
        {
            colNew = data[nId];
        }
        else
        {
            colNew = data[nId] - data[nId - 1] - 1;
        }

        while (ask[askId].value <= lastIdx + colNew)
        {
            if (askId >= q) break;

            if (nId == 0) res[ask[askId].id] = ask[askId].value - 1;
            else res[ask[askId].id] = data[nId - 1] + ask[askId].value - lastIdx;

            askId++;
        }
        lastIdx = lastIdx + colNew;
    }

    for (int i = 0; i < q; i++)
    {
        cout << res[i] << ' ';
    }
}