#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(v) v.begin(), v.end()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<int> a(n + 1, -1);
    for (int i = 1; i <= n; i++) cin >> a[i];

    vector<pair<ll, ll>> seg = {{-1, -1}};
    for (int i = 1; i <= n; i++) {
        int l = a[i - 1] + 1;
        int r = a[i] - 1;
        if (l <= r) {
            seg.push_back({l, r});
        }
    }
    seg.push_back({a.back() + 1, 2e9});

    int x = seg.size();
    vector<ll> pref(x + 1, 0);
    for (int i = 1; i <= x; i++) pref[i] = pref[i - 1] + seg[i].second - seg[i].first + 1;

    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;

        int l = 0;
        int r = x + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (pref[m] < k) {
                l = m;
            } else {
                r = m;
            }
        }

        k -= pref[l];
        cout << seg[l + 1].first + k - 1 << ' ';
    }

    return 0;
}

