#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include<random>
#define all(a) a.begin(), a.end()
#define int long long
#define pb push_back
using namespace std;




mt19937 rnd(0);

int fast(int n, int b, int c, vector<int> pos, vector<int> pr){
	int p = 0;
   	int ba = 0;
	while (p != n - 1) {
		int j = p + 1;
		while (j < n - 1 && pr[j] > pr[p] && (pos[j+1] - pos[p] - ba)*pr[p] <= b && pos[j+1] - pos[p] <= c) {
			j++;
		}
		if (pr[j] <= pr[p] && (pos[j] - pos[p]) * pr[p] <= b && pos[j] - pos[p] <= c) {
			b -= pr[p] * (pos[j] - pos[p] - ba);
			p = j;
			ba = 0;
		}
		else {
			if ((pos[j] - pos[p]) * pr[p] <= b && pos[j] - pos[p] <= c) {
				int cnt = min(b / pr[p], c);
				b -= cnt  * pr[p];
				ba = cnt - pos[j] + pos[p];
				p = j;
			}
			else {
				break;
			}
		}
	}
	ba = min(c, ba + b / pr[p]);
	return pos[p] + ba;
}

int slow(int n, int b, int c, vector<int> pos, vector<int> pr) {
	int d = 1000;
	vector<int> pos1(100);
	vector<int> pr1(100, 1e9);
	for (int i = 0; i < 100; i++) {
		pos1[i] = i;
	}
	for (int i = 0; i < n; i++) {
		pr1[pos[i]] = pr[i];
	}
	pr = pr1;
	pos = pos1;
	vector<vector<int>> dp(100, vector<int>(d, 1e18));
	dp[0][0] = 0;
	for (int i = 0; i < 100-1; i++) {
		for (int b1 = 0; b1< d; b1++) {
			for (int j = 0; j <= min((b - dp[i][b1]) / pr[i], c - b1); j++) {
				if (b1 + j >= pos[i + 1] - pos[i] ) {
					dp[i + 1][b1 + j - pos[i + 1] + pos[i]] = min(dp[i + 1][b1 + j - pos[i + 1] + pos[i]],
						dp[i][b1] + pr[i] * j);
				}
			}
		}
	}
	for (int i = 99; i >= 0; i--) {
		for (int b1 = 0; b1 < d; b1++) {
			if (dp[i][b1] <= b) {
				
				return i;
			}
		}
	}
}

void solve() {
	int n, b, c;
	cin >> n >> b >> c;
	vector<int> pos(n);
	vector<int> pr(n);
	for (int i = 0; i < n; i++) {
		cin >> pos[i] >> pr[i];
	
	}
	cout << fast(n, b, c, pos, pr);
	while (0) {
		n = rnd() % 3 + 1;
		b = rnd() % 10 + 1;
		c = rnd() % 10 + 1;
		set<int>s {0};
		while (s.size() != n) {

			s.insert(rnd() % 10+1);
		}
		vector<int > pos;
		for (auto i : s) {
			pos.pb(i);
		}
		vector<int> pr(n);
		for (int i = 0; i < n; i++) {
			pr[i] = rnd() % 10 + 1;
		}
		if (slow(n, b, c, pos, pr) != fast(n, b, c, pos, pr)) {
			cout << n <<' ' << b <<" " << c << '\n';
			for (int i = 0; i < n; i++) {
				cout << pos[i] << ' ' << pr[i] << '\n';
			}
			cout << slow(n, b, c, pos, pr) << ' ' << fast(n, b, c, pos, pr);
			return;
		}
	}
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	solve();
}
