#include <bits/stdc++.h>
#define int long long
#define ld long double
#define pb push_back
#define debug(x) cerr<<(#x)<<": "<<x<<endl;
using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}
struct Fenwick {
    vector<int> tree;
    int n;
    Fenwick(int _n) : tree(_n + 1), n(_n) {}
    void update(int i, int val) {
        for (++i; i <= n; i += i & -i)
            tree[i] = add(tree[i], val);
    }
    int get(int r) {
        int ans = 0;
        for (++r; r > 0; r -= r & -r) ans = add(ans, tree[r]);
        return ans;
    }
    int get(int l, int r) {
        return sub(get(r), get(l - 1));
    }
};
struct SegTree{
    vector<int> tree;
    int n;
    SegTree(int _n) : n(_n), tree(2 * _n, -1) {}
    void update(int pos, int val) {
        pos += n;
        tree[pos] = max(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = max(tree[pos], tree[pos ^ 1]);
    }
    int get(int l, int r) {
        int s = -1;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) s = max(s, tree[l++]);
            if (r & 1) s = max(s, tree[--r]);
        }
        return s;
    }
};
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << "2\n"
            "4\n"
            "4\n"
            "3\n"
            "4\n";
}
