#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()
#define pub push_back

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}
template <typename T>
void chmin(T& a, const T& b) {
    if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
    if (b > a) a = b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;
using vii = vector<ii>;

void solve() {
     ll n, b, c;
     cin >> n >> b >> c;
     vii a(n);
     for (int i = 0; i < n; ++i) {
         ll x, p;
         cin >> x >> p;
         a[i] = {x, p};
     }
     vi bpmn(n);
     vii mn;
     mn.pub({-1, 1e18});
     for (int i = n - 1; i >= 0; --i) {
         while(mn.back().first >= a[i].second){
             mn.pop_back();
         }
         bpmn[i] = mn.back().second;
         mn.pub({a[i].second, i});
     }
     ll ind = 0;
     ll lit = 0;
     ll mx = 0;
     while(ind < n){
         mx = max(mx, a[ind].first + min(c, lit + b / a[ind].second));
         if (bpmn[ind] != (ll)1e18 && a[bpmn[ind]].first - a[ind].first <= c){
             if (lit >= a[bpmn[ind]].first - a[ind].first){
                 lit -= a[bpmn[ind]].first - a[ind].first;
                 ind = bpmn[ind];
                 continue;
             }
             if (((a[bpmn[ind]].first - a[ind].first) - lit) * a[ind].second > b || a[bpmn[ind]].first - a[ind].first > c) {
                 break;
             }
             b -= ((a[bpmn[ind]].first - a[ind].first) - lit) * a[ind].second;
             lit = 0;
             ind = bpmn[ind];
         }
         else{
             if ((c - lit) * a[ind].second <= b){
                 b -= (c - lit) * a[ind].second;
                 lit = c;
                 if (ind < n - 1){
                     lit = c - (a[ind + 1].first - a[ind].first);
                 }
                 if (lit < 0){
                     break ;
                 }
                 ind++;
                 continue ;
             }
             else{
                 lit += b / a[ind].second;
                 if (ind < n - 1) {
                     lit -= (a[ind + 1].first - a[ind].first);
                 }
                 if (lit < 0){
                     break ;
                 }
                 b = 0;
                 ind++;
                 continue ;
             }
         }
     }
     cout << mx;
}
